   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.9.10 - 10 Feb 2011
   3                     ; Generator (Limited) V4.3.6 - 15 Feb 2011
  15                     	bsct
  16  0000               _Resp_status:
  17  0000 01            	dc.b	1
  67                     ; 113 void main(void) 
  67                     ; 114 {
  69                     	switch	.text
  70  0000               _main:
  72  0000 88            	push	a
  73       00000001      OFST:	set	1
  76                     ; 118 	communication_watchdog=INIT_VALUE;// Initialization of communication watchdog
  78  0001 3f00          	clr	_communication_watchdog
  79                     ; 120 	Board_Init_Board(); // Init board configure pins
  81  0003 cd0000        	call	_Board_Init_Board
  83                     ; 121 	Board_Init_Display(); // Init Display
  85  0006 cd0000        	call	_Board_Init_Display
  87                     ; 122 	enableInterrupts();// Enable global interrupts
  90  0009 9a            rim
  92                     ; 124 	status_test_config=Test_Config(); // Test communication with CR95HF and one command
  95  000a ad24          	call	L75_Test_Config
  97  000c 6b01          	ld	(OFST+0,sp),a
  98                     ; 125 	Select_Protocol_ISO15693();// Turn RF on and select the ISO15693 protocol
 100  000e cd0000        	call	_Select_Protocol_ISO15693
 102                     ; 127 	if(status_test_config==CR95HF_SUCCESS_CODE)
 104  0011 0d01          	tnz	(OFST+0,sp)
 105  0013 2619          	jrne	L121
 106  0015 200c          	jra	L131
 107  0017               L721:
 108                     ; 134 				delay_ms(WAIT_10ms);
 110  0017 ae000a        	ldw	x,#10
 111  001a cd0000        	call	_delay_ms
 113                     ; 136 				TagHunting ();// Look for contactless tag in the operating field
 115  001d cd0227        	call	L55_TagHunting
 117                     ; 139 					RunUserApplication();
 119  0020 cd0000        	call	_RunUserApplication
 121  0023               L131:
 122                     ; 132 			while (communication_watchdog<= LIMIT_COMMUNICATION_FAILURE)
 124  0023 b600          	ld	a,_communication_watchdog
 125  0025 a102          	cp	a,#2
 126  0027 25ee          	jrult	L721
 127                     ; 143 			Communication_test_and_recovering_procedure();
 129  0029 cd0137        	call	L36_Communication_test_and_recovering_procedure
 132  002c 20f5          	jra	L131
 133  002e               L121:
 134                     ; 147 }
 137  002e 84            	pop	a
 138  002f 81            	ret
 228                     ; 156 static u8 Test_Config(void)
 228                     ; 157 {
 229                     	switch	.text
 230  0030               L75_Test_Config:
 232  0030 5203          	subw	sp,#3
 233       00000003      OFST:	set	3
 236                     ; 158 	u8 status=CR95HF_ERROR_CODE;// Status of the procedure
 238                     ; 160 	u8 Dummy_parameters=0x01;// Dummy parameters only used to send a command
 240  0032 a601          	ld	a,#1
 241  0034 6b03          	ld	(OFST+0,sp),a
 242                     ; 162 	LED_Switch_on(ALL_LED);// activate  all LED
 244  0036 a60f          	ld	a,#15
 245  0038 cd0000        	call	_LED_Switch_on
 247                     ; 163 	LED_Switch_off(ALL_LED);// deactivate all LED
 249  003b a60f          	ld	a,#15
 250  003d cd0000        	call	_LED_Switch_off
 252                     ; 164 	LCD_Clear();
 254  0040 cd0000        	call	_LCD_Clear
 256                     ; 166 	if(SPI_or_UART_Communication==SPI_INTERFACE_SELECTED)
 258  0043 b600          	ld	a,_SPI_or_UART_Communication
 259  0045 a101          	cp	a,#1
 260  0047 261e          	jrne	L371
 261                     ; 168 		LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"##    SPI    ##");
 263  0049 ae012e        	ldw	x,#L571
 264  004c 89            	pushw	x
 265  004d 4b00          	push	#0
 266  004f ae8001        	ldw	x,#32769
 267  0052 cd0000        	call	_LCD_PrintString
 269  0055 5b03          	addw	sp,#3
 270                     ; 173 			LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"     IRQ_in");
 272  0057 ae0122        	ldw	x,#L771
 273  005a 89            	pushw	x
 274  005b 4b00          	push	#0
 275  005d ae9001        	ldw	x,#36865
 276  0060 cd0000        	call	_LCD_PrintString
 278  0063 5b03          	addw	sp,#3
 280  0065 200e          	jra	L102
 281  0067               L371:
 282                     ; 176 		LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"##   UART    ##");
 284  0067 ae0112        	ldw	x,#L302
 285  006a 89            	pushw	x
 286  006b 4b00          	push	#0
 287  006d ae8001        	ldw	x,#32769
 288  0070 cd0000        	call	_LCD_PrintString
 290  0073 5b03          	addw	sp,#3
 291  0075               L102:
 292                     ; 178 	Wait_Display(WAIT_500ms);
 294  0075 ae01f4        	ldw	x,#500
 295  0078 cd0000        	call	_Wait_Display
 297                     ; 180 	flag_status=FLASH_GetFlagStatus(FLASH_FLAG_DUL);// Test if EEPROM is writable for data
 299  007b a608          	ld	a,#8
 300  007d cd0000        	call	_FLASH_GetFlagStatus
 302  0080 6b01          	ld	(OFST-2,sp),a
 303                     ; 181 	CR95HF_IRQ_in_Interrupt();// Send an interrupt in order to wake up the CR95HF
 305  0082 cd0000        	call	_CR95HF_IRQ_in_Interrupt
 308  0085 201f          	jra	L702
 309  0087               L502:
 310                     ; 185 		CR95HF_IRQ_in_Interrupt();// Send an interrupt in order to wake up the CR95HF
 312  0087 cd0000        	call	_CR95HF_IRQ_in_Interrupt
 314                     ; 186 		if(CR95HF_Echo()!=CR95HF_SUCCESS_CODE)
 316  008a cd0000        	call	_CR95HF_Echo
 318  008d 4d            	tnz	a
 319  008e 2703          	jreq	L312
 320                     ; 188 			CR95HF_SPIReset();// Try to reset the CR95HF 
 322  0090 cd0000        	call	_CR95HF_SPIReset
 324  0093               L312:
 325                     ; 190 		LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"##  Echo KO  ##");
 327  0093 ae0102        	ldw	x,#L512
 328  0096 89            	pushw	x
 329  0097 4b00          	push	#0
 330  0099 ae9001        	ldw	x,#36865
 331  009c cd0000        	call	_LCD_PrintString
 333  009f 5b03          	addw	sp,#3
 334                     ; 191 		LED_Switch_on(RED_LED); // activate red LED flag
 336  00a1 a604          	ld	a,#4
 337  00a3 cd0000        	call	_LED_Switch_on
 339  00a6               L702:
 340                     ; 182 	while(CR95HF_Echo()!=CR95HF_SUCCESS_CODE)
 342  00a6 cd0000        	call	_CR95HF_Echo
 344  00a9 4d            	tnz	a
 345  00aa 26db          	jrne	L502
 346                     ; 193 	LED_Switch_off(RED_LED);
 348  00ac a604          	ld	a,#4
 349  00ae cd0000        	call	_LED_Switch_off
 351                     ; 195 	communication_watchdog=INIT_VALUE;
 353  00b1 3f00          	clr	_communication_watchdog
 354                     ; 197 	CR95HF_IDN(&CR95HF_response);
 356  00b3 ae0000        	ldw	x,#_CR95HF_response
 357  00b6 cd0000        	call	_CR95HF_IDN
 360  00b9 2013          	jra	L122
 361  00bb               L712:
 362                     ; 202 		LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"!# CFG ERR  #!");
 364  00bb ae00f3        	ldw	x,#L522
 365  00be 89            	pushw	x
 366  00bf 4b00          	push	#0
 367  00c1 ae9001        	ldw	x,#36865
 368  00c4 cd0000        	call	_LCD_PrintString
 370  00c7 5b03          	addw	sp,#3
 371                     ; 203 		LED_Switch_on(RED_LED); // activate red LED flag
 373  00c9 a604          	ld	a,#4
 374  00cb cd0000        	call	_LED_Switch_on
 376  00ce               L122:
 377                     ; 199 	while(CR95HF_ProtocolSelect
 377                     ; 200 	(CR95HF_PROT_SEL_ISO15693, CR95HF_PARAMETERSLENGTH_PROT_ISO15693, & Dummy_parameters, &Protocol_Settings)!=CR95HF_SUCCESS_CODE)
 379  00ce ae0019        	ldw	x,#_Protocol_Settings
 380  00d1 89            	pushw	x
 381  00d2 96            	ldw	x,sp
 382  00d3 1c0005        	addw	x,#OFST+2
 383  00d6 89            	pushw	x
 384  00d7 ae0101        	ldw	x,#257
 385  00da cd0000        	call	_CR95HF_ProtocolSelect
 387  00dd 5b04          	addw	sp,#4
 388  00df 4d            	tnz	a
 389  00e0 26d9          	jrne	L712
 390                     ; 206 	LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"   CONFIG OK");
 392  00e2 ae00e6        	ldw	x,#L722
 393  00e5 89            	pushw	x
 394  00e6 4b00          	push	#0
 395  00e8 ae9001        	ldw	x,#36865
 396  00eb cd0000        	call	_LCD_PrintString
 398  00ee 5b03          	addw	sp,#3
 399                     ; 207 	LED_Switch_off(RED_LED);
 401  00f0 a604          	ld	a,#4
 402  00f2 cd0000        	call	_LED_Switch_off
 404                     ; 208 	Wait_Display(WAIT_500ms);
 406  00f5 ae01f4        	ldw	x,#500
 407  00f8 cd0000        	call	_Wait_Display
 409                     ; 213 	status=CR95HF_Idle_Detector_Calibration(&Protocol_Settings, &Idle_Config);
 411  00fb ae0015        	ldw	x,#_Idle_Config
 412  00fe 89            	pushw	x
 413  00ff ae0019        	ldw	x,#_Protocol_Settings
 414  0102 cd0000        	call	_CR95HF_Idle_Detector_Calibration
 416  0105 85            	popw	x
 417  0106 6b02          	ld	(OFST-1,sp),a
 418                     ; 217 	if(flag_status==RESET)
 420  0108 0d01          	tnz	(OFST-2,sp)
 421  010a 261b          	jrne	L132
 422                     ; 219 		LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"  EEPROM LOCKED");
 424  010c ae00d6        	ldw	x,#L332
 425  010f 89            	pushw	x
 426  0110 4b00          	push	#0
 427  0112 ae8001        	ldw	x,#32769
 428  0115 cd0000        	call	_LCD_PrintString
 430  0118 5b03          	addw	sp,#3
 431                     ; 220 		LED_Switch_on(RED_LED); // activate red LED flag
 433  011a a604          	ld	a,#4
 434  011c cd0000        	call	_LED_Switch_on
 436                     ; 221 		Wait_Display(WAIT_1s);
 438  011f ae03e8        	ldw	x,#1000
 439  0122 cd0000        	call	_Wait_Display
 442  0125 2002          	jra	L532
 443  0127               L132:
 444                     ; 225 		status=CR95HF_SUCCESS_CODE;
 446  0127 0f02          	clr	(OFST-1,sp)
 447  0129               L532:
 448                     ; 229 	if(SPI_or_UART_Communication==SPI_INTERFACE_SELECTED)
 450  0129 b600          	ld	a,_SPI_or_UART_Communication
 451  012b a101          	cp	a,#1
 452  012d 2603          	jrne	L732
 453                     ; 231 		CR95HF_IRQ_in_Interrupt();
 455  012f cd0000        	call	_CR95HF_IRQ_in_Interrupt
 457  0132               L732:
 458                     ; 234 		return status;
 460  0132 7b02          	ld	a,(OFST-1,sp)
 463  0134 5b03          	addw	sp,#3
 464  0136 81            	ret
 497                     ; 244 static void Communication_test_and_recovering_procedure(void)
 497                     ; 245 {
 498                     	switch	.text
 499  0137               L36_Communication_test_and_recovering_procedure:
 503                     ; 248 	if(CR95HF_Echo()==CR95HF_SUCCESS_CODE)
 505  0137 cd0000        	call	_CR95HF_Echo
 507  013a 4d            	tnz	a
 508  013b 2604          	jrne	L152
 509                     ; 250 		communication_watchdog=INIT_VALUE;// CR95HF still can
 511  013d 3f00          	clr	_communication_watchdog
 513  013f 2036          	jra	L352
 514  0141               L152:
 515                     ; 255 		delay_10us_base(WAIT_100us);
 517  0141 ae000a        	ldw	x,#10
 518  0144 cd0000        	call	_delay_10us_base
 520                     ; 256 		if(CR95HF_Echo()==CR95HF_SUCCESS_CODE)
 522  0147 cd0000        	call	_CR95HF_Echo
 524  014a 4d            	tnz	a
 525  014b 2604          	jrne	L552
 526                     ; 258 			communication_watchdog=INIT_VALUE;// CR95HF answered
 528  014d 3f00          	clr	_communication_watchdog
 530  014f 2026          	jra	L352
 531  0151               L552:
 532                     ; 263 			LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"MCU<->CR95HF ERR");
 534  0151 ae00c5        	ldw	x,#L162
 535  0154 89            	pushw	x
 536  0155 4b00          	push	#0
 537  0157 ae9001        	ldw	x,#36865
 538  015a cd0000        	call	_LCD_PrintString
 540  015d 5b03          	addw	sp,#3
 541                     ; 264 			delay_ms(WAIT_500ms);
 543  015f ae01f4        	ldw	x,#500
 544  0162 cd0000        	call	_delay_ms
 546                     ; 266 			if(SPI_or_UART_Communication==SPI_INTERFACE_SELECTED)
 548  0165 b600          	ld	a,_SPI_or_UART_Communication
 549  0167 a101          	cp	a,#1
 550  0169 260c          	jrne	L352
 551                     ; 268 				CR95HF_SPIReset();// Reset the CR95HF
 553  016b cd0000        	call	_CR95HF_SPIReset
 555                     ; 269 				CR95HF_IRQ_in_Interrupt();
 557  016e cd0000        	call	_CR95HF_IRQ_in_Interrupt
 559                     ; 270 				delay_ms(WAIT_3ms);
 561  0171 ae0003        	ldw	x,#3
 562  0174 cd0000        	call	_delay_ms
 564  0177               L352:
 565                     ; 274 }
 568  0177 81            	ret
 571                     	bsct
 572  0001               L562_counter:
 573  0001 00            	dc.b	0
 574  0002               L762_buffer:
 575  0002 00            	dc.b	0
 637                     ; 282 static void Display_Motion(u8 speed)
 637                     ; 283 {
 638                     	switch	.text
 639  0178               L16_Display_Motion:
 641  0178 88            	push	a
 642  0179 88            	push	a
 643       00000001      OFST:	set	1
 646                     ; 287 	if(Protocol_Settings.protocol_in_use==CR95HF_PROT_SEL_FIELDOFF)
 648  017a 3d19          	tnz	_Protocol_Settings
 649  017c 2606          	jrne	L333
 650                     ; 288 		character='.';
 652  017e a62e          	ld	a,#46
 653  0180 6b01          	ld	(OFST+0,sp),a
 655  0182 2004          	jra	L533
 656  0184               L333:
 657                     ; 290 		character=')';
 659  0184 a629          	ld	a,#41
 660  0186 6b01          	ld	(OFST+0,sp),a
 661  0188               L533:
 662                     ; 294 	if(speed<buffer)
 664  0188 7b02          	ld	a,(OFST+1,sp)
 665  018a b102          	cp	a,L762_buffer
 666  018c 2402          	jruge	L733
 667                     ; 295 		buffer=INIT_VALUE; // reinitialize buffer 
 669  018e 3f02          	clr	L762_buffer
 670  0190               L733:
 671                     ; 297 	if((speed-buffer)==INIT_VALUE)
 673  0190 7b02          	ld	a,(OFST+1,sp)
 674  0192 5f            	clrw	x
 675  0193 b002          	sub	a,L762_buffer
 676  0195 2401          	jrnc	L41
 677  0197 5a            	decw	x
 678  0198               L41:
 679  0198 02            	rlwa	x,a
 680  0199 5d            	tnzw	x
 681  019a 2606          	jrne	L143
 682                     ; 299 		counter++; // increment counter to display next dot
 684  019c 3c01          	inc	L562_counter
 685                     ; 300 		buffer=INIT_VALUE; // reinitialize buffer 
 687  019e 3f02          	clr	L762_buffer
 689  01a0 2002          	jra	L343
 690  01a2               L143:
 691                     ; 305 		buffer++; /// increment buffer for the next call
 693  01a2 3c02          	inc	L762_buffer
 694  01a4               L343:
 695                     ; 307 	LCD_SetCursorPos(LCD_LINE1, LCD_FIRST_DOT);
 697  01a4 ae8006        	ldw	x,#32774
 698  01a7 cd0000        	call	_LCD_SetCursorPos
 700                     ; 308 	switch( counter )
 702  01aa b601          	ld	a,L562_counter
 704                     ; 331 		break;
 705  01ac 4a            	dec	a
 706  01ad 2719          	jreq	L172
 707  01af 4a            	dec	a
 708  01b0 271d          	jreq	L372
 709  01b2 4a            	dec	a
 710  01b3 2726          	jreq	L572
 711  01b5               L772:
 712                     ; 326 		default  : 
 712                     ; 327 			counter=INIT_VALUE;
 714  01b5 3f01          	clr	L562_counter
 715                     ; 328 			LCD_PrintChar(' ');
 717  01b7 a620          	ld	a,#32
 718  01b9 cd0000        	call	_LCD_PrintChar
 720                     ; 329 			LCD_PrintChar(' ');
 722  01bc a620          	ld	a,#32
 723  01be cd0000        	call	_LCD_PrintChar
 725                     ; 330 			LCD_PrintChar(' ');
 727  01c1 a620          	ld	a,#32
 728  01c3 cd0000        	call	_LCD_PrintChar
 730                     ; 331 		break;
 732  01c6 201e          	jra	L743
 733  01c8               L172:
 734                     ; 310 		case 0x01 : 
 734                     ; 311 			
 734                     ; 312 			LCD_PrintChar(character);
 736  01c8 7b01          	ld	a,(OFST+0,sp)
 737  01ca cd0000        	call	_LCD_PrintChar
 739                     ; 313 		break;
 741  01cd 2017          	jra	L743
 742  01cf               L372:
 743                     ; 315 		case 0x02 :
 743                     ; 316 			LCD_PrintChar(character);
 745  01cf 7b01          	ld	a,(OFST+0,sp)
 746  01d1 cd0000        	call	_LCD_PrintChar
 748                     ; 317 			LCD_PrintChar(character);
 750  01d4 7b01          	ld	a,(OFST+0,sp)
 751  01d6 cd0000        	call	_LCD_PrintChar
 753                     ; 318 		break;
 755  01d9 200b          	jra	L743
 756  01db               L572:
 757                     ; 320 		case 0x03 : 
 757                     ; 321 		
 757                     ; 322 			LCD_SetCursorPos(LCD_LINE1, LCD_THIRD_DOT);
 759  01db ae8007        	ldw	x,#32775
 760  01de cd0000        	call	_LCD_SetCursorPos
 762                     ; 323 			LCD_PrintChar(character);
 764  01e1 7b01          	ld	a,(OFST+0,sp)
 765  01e3 cd0000        	call	_LCD_PrintChar
 767                     ; 324 		break;
 769  01e6               L743:
 770                     ; 335 }
 773  01e6 85            	popw	x
 774  01e7 81            	ret
 833                     ; 344 static u8 ISO15693_Detect_Tag(void)
 833                     ; 345 {
 834                     	switch	.text
 835  01e8               L153_ISO15693_Detect_Tag:
 837  01e8 5204          	subw	sp,#4
 838       00000004      OFST:	set	4
 841                     ; 349 	u8 Mask_length_bits=INIT_VALUE;
 843  01ea 0f01          	clr	(OFST-3,sp)
 844                     ; 351 	u8 AFI_Tag= INIT_VALUE; 
 846  01ec 0f02          	clr	(OFST-2,sp)
 847                     ; 354 	Mask[0]=0x46;// LSB of the UID
 849  01ee a646          	ld	a,#70
 850  01f0 6b03          	ld	(OFST-1,sp),a
 851                     ; 355 	Mask[1]=0x0B;
 853  01f2 a60b          	ld	a,#11
 854  01f4 6b04          	ld	(OFST+0,sp),a
 855                     ; 358 		ISO15693_Request_Flags_Inventory=ComputeByte(
 855                     ; 359 		ISO15693_BIT3SET_BIT8_RFU,
 855                     ; 360 		ISO15693_BIT3SET_BIT7_OPTIONFLAG_RESET,
 855                     ; 361 		ISO15693_BIT3SET_BIT6_16_SLOTS,//ISO15693_BIT3SET_BIT6_1_SLOT
 855                     ; 362 		ISO15693_BIT3SET_BIT5_AFI_NOT_PRESENT,//ISO15693_BIT3SET_BIT5_AFI_PRESENT
 855                     ; 363 		ISO15693_BIT4_NO_PROTOCOL_EXTENSION,
 855                     ; 364 		ISO15693_BIT3_INVENTORY_FLAG_SET,
 855                     ; 365 		ISO15693_BIT2_LOW_DATARATE,//ISO15693_BIT2_HIGH_DATARATE
 855                     ; 366 		ISO15693_BIT1_SINGLE_SUBCARRIER//ISO15693_BIT1_DUAL_SUBCARRIERS
 855                     ; 367 		);
 857  01f6 4b00          	push	#0
 858  01f8 4b00          	push	#0
 859  01fa 4b04          	push	#4
 860  01fc 4b00          	push	#0
 861  01fe 4b00          	push	#0
 862  0200 4b00          	push	#0
 863  0202 5f            	clrw	x
 864  0203 cd0000        	call	_ComputeByte
 866  0206 5b06          	addw	sp,#6
 867  0208 b720          	ld	_ISO15693_Request_Flags_Inventory,a
 868                     ; 370 		return LRIXK_Inventory(&MyTag15693,ISO15693_Request_Flags_Inventory,AFI_Tag,Mask_length_bits,Mask, &ISO15693_Inventory_16slots_Nb_UID_Retrieved);
 870  020a ae001e        	ldw	x,#_ISO15693_Inventory_16slots_Nb_UID_Retrieved
 871  020d 89            	pushw	x
 872  020e 96            	ldw	x,sp
 873  020f 1c0005        	addw	x,#OFST+1
 874  0212 89            	pushw	x
 875  0213 7b05          	ld	a,(OFST+1,sp)
 876  0215 88            	push	a
 877  0216 7b07          	ld	a,(OFST+3,sp)
 878  0218 88            	push	a
 879  0219 3b0020        	push	_ISO15693_Request_Flags_Inventory
 880  021c ae0022        	ldw	x,#_MyTag15693
 881  021f cd0000        	call	_LRIXK_Inventory
 883  0222 5b07          	addw	sp,#7
 886  0224 5b04          	addw	sp,#4
 887  0226 81            	ret
 948                     ; 379 static void TagHunting (void)
 948                     ; 380 {	
 949                     	switch	.text
 950  0227               L55_TagHunting:
 952  0227 5209          	subw	sp,#9
 953       00000009      OFST:	set	9
 956                     ; 389 	if(ISO15693_Detect_Tag()==ISO15693_SUCCESS_CODE)
 958  0229 adbd          	call	L153_ISO15693_Detect_Tag
 960  022b 4d            	tnz	a
 961  022c 267c          	jrne	L324
 962                     ; 391 		LED_Switch_on(GREEN_LED);// activate GREEN
 964  022e a601          	ld	a,#1
 965  0230 cd0000        	call	_LED_Switch_on
 967                     ; 392 		LED_Switch_off(BLUE_LED);// deactivate BLUE LED
 969  0233 a608          	ld	a,#8
 970  0235 cd0000        	call	_LED_Switch_off
 972                     ; 396 		ISO15693_Request_Flags=ComputeByte(
 972                     ; 397 		ISO15693_BIT3RESET_BIT8_RFU,
 972                     ; 398 		ISO15693_BIT3RESET_BIT7_OPTIONFLAG_SET,
 972                     ; 399 		ISO15693_BIT3RESET_BIT6_REQUEST_ADDRESSED,
 972                     ; 400 		ISO15693_BIT3RESET_BIT5_REQUEST_TAG_NOT_SELECTED,
 972                     ; 401 		ISO15693_BIT4_PROTOCOL_EXTENSION,//ISO15693_BIT4_NO_PROTOCOL_EXTENSION 
 972                     ; 402 		ISO15693_BIT3_INVENTORY_FLAG_RESET,
 972                     ; 403 		ISO15693_BIT2_LOW_DATARATE,
 972                     ; 404 		ISO15693_BIT1_SINGLE_SUBCARRIER
 972                     ; 405 		);
 974  0238 4b00          	push	#0
 975  023a 4b00          	push	#0
 976  023c 4b00          	push	#0
 977  023e 4b08          	push	#8
 978  0240 4b00          	push	#0
 979  0242 4b20          	push	#32
 980  0244 ae0040        	ldw	x,#64
 981  0247 cd0000        	call	_ComputeByte
 983  024a 5b06          	addw	sp,#6
 984  024c b721          	ld	_ISO15693_Request_Flags,a
 985                     ; 408 		Tag_counter=ISO15693_Inventory_16slots_Nb_UID_Retrieved; // Store the number of tags seen
 987  024e b61e          	ld	a,_ISO15693_Inventory_16slots_Nb_UID_Retrieved
 988  0250 6b09          	ld	(OFST+0,sp),a
 990  0252 2050          	jra	L134
 991  0254               L524:
 992                     ; 411 			Resp_status= ISO15693_Get_UID_from_EEPROM(Tag_1,Tag_counter);
 994  0254 7b09          	ld	a,(OFST+0,sp)
 995  0256 88            	push	a
 996  0257 96            	ldw	x,sp
 997  0258 1c0002        	addw	x,#OFST-7
 998  025b cd0000        	call	_ISO15693_Get_UID_from_EEPROM
1000  025e 5b01          	addw	sp,#1
1001  0260 b700          	ld	_Resp_status,a
1002                     ; 412 			Resp_status=M24LRXX_Get_System_Info(&MyTag15693, ISO15693_Request_Flags,Tag_1);
1004  0262 96            	ldw	x,sp
1005  0263 1c0001        	addw	x,#OFST-8
1006  0266 89            	pushw	x
1007  0267 3b0021        	push	_ISO15693_Request_Flags
1008  026a ae0022        	ldw	x,#_MyTag15693
1009  026d cd0000        	call	_M24LRXX_Get_System_Info
1011  0270 5b03          	addw	sp,#3
1012  0272 b700          	ld	_Resp_status,a
1013                     ; 413 			if(Resp_status!= M24LRXX_SUCCESS_CODE)
1015  0274 3d00          	tnz	_Resp_status
1016  0276 2728          	jreq	L534
1017                     ; 415 				ISO15693_Request_Flags=ComputeByte(
1017                     ; 416 				ISO15693_BIT3RESET_BIT8_RFU,
1017                     ; 417 				ISO15693_BIT3RESET_BIT7_OPTIONFLAG_SET,
1017                     ; 418 				ISO15693_BIT3RESET_BIT6_REQUEST_ADDRESSED,
1017                     ; 419 				ISO15693_BIT3RESET_BIT5_REQUEST_TAG_NOT_SELECTED,
1017                     ; 420 				ISO15693_BIT4_NO_PROTOCOL_EXTENSION,
1017                     ; 421 				ISO15693_BIT3_INVENTORY_FLAG_RESET,
1017                     ; 422 				ISO15693_BIT2_LOW_DATARATE,
1017                     ; 423 				ISO15693_BIT1_SINGLE_SUBCARRIER);
1019  0278 4b00          	push	#0
1020  027a 4b00          	push	#0
1021  027c 4b00          	push	#0
1022  027e 4b00          	push	#0
1023  0280 4b00          	push	#0
1024  0282 4b20          	push	#32
1025  0284 ae0040        	ldw	x,#64
1026  0287 cd0000        	call	_ComputeByte
1028  028a 5b06          	addw	sp,#6
1029  028c b721          	ld	_ISO15693_Request_Flags,a
1030                     ; 424 				Resp_status=LRIXK_Get_System_Info(&MyTag15693, ISO15693_Request_Flags,Tag_1);
1032  028e 96            	ldw	x,sp
1033  028f 1c0001        	addw	x,#OFST-8
1034  0292 89            	pushw	x
1035  0293 3b0021        	push	_ISO15693_Request_Flags
1036  0296 ae0022        	ldw	x,#_MyTag15693
1037  0299 cd0000        	call	_LRIXK_Get_System_Info
1039  029c 5b03          	addw	sp,#3
1040  029e b700          	ld	_Resp_status,a
1041  02a0               L534:
1042                     ; 429 			ISO15693_Display_Tag_Answer_Inventory_GetSys_Info();
1044  02a0 ad65          	call	L56_ISO15693_Display_Tag_Answer_Inventory_GetSys_Info
1046                     ; 430 			Tag_counter--;
1046                     ; 431 		}
1046                     ; 432 		
1046                     ; 433 	}
1046                     ; 434 	else 
1046                     ; 435 	{
1046                     ; 436 		if(Protocol_Settings.protocol_in_use==CR95HF_PROT_SEL_FIELDOFF)
1046                     ; 437 		{
1046                     ; 438 			LCD_DisplayLogo(LCD_LOGOTYPE_LINE1_LEFT_CORNER );
1046                     ; 439 			LCD_Print(" CR95HF ");
1046                     ; 440 			LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"## Field off ##");
1046                     ; 441 			Display_Motion(LOW_SPEED_DISPLAY_MOTION);
1046                     ; 442 			LED_Switch_on(YELLOW_LED);// activate  Yellow LED
1046                     ; 443 			LED_Switch_off(BLUE_LED);// deactivate  blue LED
1046                     ; 444 		}
1046                     ; 445 		else
1046                     ; 446 		{
1046                     ; 447 			LCD_DisplayLogo(LCD_LOGOTYPE_LINE1_LEFT_CORNER );
1046                     ; 448 			LCD_Print(" CR95HF ");
1046                     ; 449 			LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"##  No tag   ##");
1046                     ; 450 			Display_Motion(DEFAULT_SPEED_DISPLAY_MOTION);
1046                     ; 451 			LED_Switch_on(BLUE_LED);// activate  BLUE LED
1046                     ; 452 			LED_Switch_off(YELLOW_LED);// deactivate  Yellow LED
1046                     ; 453 		}
1046                     ; 454 			
1046                     ; 455 		LED_Switch_off(GREEN_LED);// deactivate GREEN LED
1046                     ; 456 			
1046                     ; 457 	}
1046                     ; 458 }		
1046                     ; 459 
1046                     ; 460 
1046                     ; 461 // Some display functions
1046                     ; 462 
1046                     ; 463 /**  
1046                     ; 464 * @brief  This function displays the UID retrieved by the Inventory command.If the several contactless tag answered then only the number of contactless tags seen is displayed   
1046                     ; 465 * @param void : no paramter expected, all data are retrieved from the MyTag15693 structure and ISO15693_Request_Flags
1046                     ; 466 * @retval	void : no return value		
1046                     ; 467 */
1046                     ; 468 static void ISO15693_Display_Tag_Answer_Inventory_GetSys_Info(void) 
1046                     ; 469 {
1046                     ; 470 	if(MyTag15693.command_ok==ISO15693_SUCCESS_CODE)
1046                     ; 471 	{
1046                     ; 472 		LCD_Clear();
1046                     ; 473 		if(ISO15693_Get_Slots_Flag(ISO15693_Request_Flags_Inventory)==ISO15693_1_SLOT)
1046                     ; 474 		{
1046                     ; 475 			ISO15693_Display_Tag_ICREF(MyTag15693.ICRef, LCD_LINE1);
1046                     ; 476 			ISO15693_Display_Tag_UID(MyTag15693.UID_Tag,LCD_LINE2);		
1046                     ; 477 		}		
1046                     ; 478 		else
1046                     ; 479 		{
1046                     ; 480 			// If there is only one tag display its UID
1046                     ; 481 			if(ISO15693_Inventory_16slots_Nb_UID_Retrieved==1)
1046                     ; 482 			{
1046                     ; 483 				// If the ICRef is known then the name of the contacless is overwritten on line 1 of the LCD screen 
1046                     ; 484 				ISO15693_Display_Tag_ICREF(MyTag15693.ICRef, LCD_LINE1);
1046                     ; 485 				ISO15693_Display_Tag_UID(MyTag15693.UID_Tag,LCD_LINE2);
1046                     ; 486 			}
1046                     ; 487 			else // Several contactless tag answereed the inventory command
1046                     ; 488 			{
1046                     ; 489 				LCD_SetCursorPos(LCD_LINE1, LCD_STARTLEFTCORNER);
1046                     ; 490 				// Display the number of contactless tag seen
1046                     ; 491 				LCD_PrintString(LCD_LINE1,DISABLE,ENABLE," TAGS SEEN: ");
1046                     ; 492 				LCD_PrintDec(ISO15693_Inventory_16slots_Nb_UID_Retrieved);
1046                     ; 493 			}
1046                     ; 494 		}
1046                     ; 495 	}
1046                     ; 496 	// in this case the command Get Syst Info failed but the inventory passed. Note that the Get system Info is not aninventory command therefor only the UID is available display it
1046                     ; 497 	else
1046                     ; 498 	{
1046                     ; 499 		LCD_Clear();
1046                     ; 500 		// Display the UID without the MSB 'EO'
1046                     ; 501 		LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"   TAG UID");
1046                     ; 502 		ISO15693_Display_Tag_UID(MyTag15693.UID_Tag,LCD_LINE2);
1046                     ; 503 	}
1046                     ; 504 }
1046                     ; 505 
1046                     ; 506 
1046                     ; 507 
1046                     ; 508 /**  
1046                     ; 509 * @brief  This function displays the Unique IDendtifier of the contactless tag. EO and constructor on first line others bytes on the  second line.Note that EO is not displayed as it is common to all contactless tags.   
1046                     ; 510 * @param UID : pointer on the UID ( ISO15693Tag.UID for example)
1046                     ; 511 * @param Line : line on the LCD screen used for the display
1046                     ; 512 * @retval	void : no return value		
1046                     ; 513 */
1046                     ; 514 static void ISO15693_Display_Tag_UID(const u8* UID, const u8 Line)
1046                     ; 515 {
1046                     ; 516 	u8 UID_cursor=ISO15693_UID_SIZE;// Starting from MSB
1046                     ; 517 	UID_cursor--;// strating from UID[7]
1046                     ; 518 	UID_cursor--;// Masking EO
1046                     ; 519 	LCD_SetCursorPos(Line, LCD_STARTLEFTCORNER);
1046                     ; 520 	// Note that as EO is common to all contactless tags the byte is not displayed
1046                     ; 521 	// Print other bytes 6-1 as counter is unsigned 0-1=F => infinite loop
1046                     ; 522 	while(UID_cursor!=INIT_VALUE)
1046                     ; 523 	{
1046                     ; 524 		LCD_PrintHex2(UID[UID_cursor--]);
1046                     ; 525 	}
1046                     ; 526 	LCD_PrintHex2(UID[UID_cursor]);//UID cursor =0 at this level
1046                     ; 527 }
1046                     ; 528 
1046                     ; 529 
1046                     ; 530 /**  
1046                     ; 531 * @brief  This function displays the name of the product using the ICRef. Only products identified in ISO15693_display_answer.h have their name displayed, for others the field is displayed as is.
1046                     ; 532 * @param Tag_ICRef : the Icref of the product
1046                     ; 533 * @param Line: Line to display Icref on the screen
1046                     ; 534 * @retval	ISO15693_DISPLAY_UNHANDLED : no display done	
1046                     ; 535 * @retval	ISO15693_DISPLAY_HANDLED : a display was done			
1046                     ; 536 */
1046                     ; 537 static u8 ISO15693_Display_Tag_ICREF(const u8 Tag_ICRef, const u8 Line)
1046                     ; 538 {
1046                     ; 539 	u8 status=ISO15693_DISPLAY_UNHANDLED;
1046                     ; 540 	u8 ICRef_6MSB=Tag_ICRef&MASK_ICREF_6MSB;// retrieve only the 6 MSB bits
1046                     ; 541 	LCD_SetCursorPos(Line, LCD_STARTLEFTCORNER);
1046                     ; 542 	// Check if Icref is different from the init value i.e the manufacturer is ST and ICref has been filled in.
1046                     ; 543 	if( Tag_ICRef!= ISO15693_STRUCT_INITVALUE)
1046                     ; 544 	{
1046                     ; 545 		if(ICRef_6MSB==LRI1K)
1046                     ; 546 		{
1046                     ; 547 			LCD_PrintString(Line,ENABLE,DISABLE, LRI1K_TEXT );
1046                     ; 548 		}
1046                     ; 549 		else
1046                     ; 550 		{
1046                     ; 551 			if(ICRef_6MSB==LRI2K)
1046                     ; 552 			{
1046                     ; 553 				LCD_PrintString(Line,ENABLE,DISABLE, LRI2K_TEXT );
1046                     ; 554 			}
1046                     ; 555 			else
1046                     ; 556 			{
1046                     ; 557 				if(ICRef_6MSB==LRIS2K)
1046                     ; 558 				{
1046                     ; 559 					LCD_PrintString(Line,ENABLE,DISABLE, LRIS2K_TEXT );
1046                     ; 560 				}
1046                     ; 561 				else
1046                     ; 562 				{
1046                     ; 563 					if(ICRef_6MSB==LRIS64K)
1046                     ; 564 					{
1046                     ; 565 						LCD_PrintString(Line,ENABLE,DISABLE, LRIS64K_TEXT );
1046                     ; 566 					}
1046                     ; 567 					else
1046                     ; 568 					{
1046                     ; 569 						if(ICRef_6MSB==M24LR64_R)
1046                     ; 570 						{
1046                     ; 571 							LCD_PrintString(Line,ENABLE,DISABLE, M24LR64_R_TEXT );
1046                     ; 572 						}
1046                     ; 573 						else
1046                     ; 574 						{
1046                     ; 575 							if(ICRef_6MSB==M24LRXX_E)
1046                     ; 576 							{
1046                     ; 577 								LCD_PrintString(Line,ENABLE,DISABLE, M24LRXX_E_TEXT );
1046                     ; 578 								// the two LSB bits indicates the size of the devices
1046                     ; 579 								if(Tag_ICRef==M24LR16_E)
1046                     ; 580 									LCD_PrintString(Line,ENABLE,DISABLE, M24LR16_E_TEXT );
1046                     ; 581 									
1046                     ; 582 							}
1046                     ; 583 							else
1046                     ; 584 							{
1046                     ; 585 								LCD_PrintString(Line,DISABLE,ENABLE,"ICREF: " );
1046                     ; 586 								LCD_PrintHex2(Tag_ICRef);
1046                     ; 587 							}
1046                     ; 588 						}
1046                     ; 589 					}		
1046                     ; 590 				}
1046                     ; 591 			}
1046                     ; 592 		}
1046                     ; 593 		status=ISO15693_DISPLAY_HANDLED;
1046                     ; 594 	}
1046                     ; 595 	return status;
1046                     ; 596 }
1046                     ; 597 
1046                     ; 598 
1046                     ; 599 
1046                     ; 600 /**  
1046                     ; 601 * @brief  This function displays the memsize of the tag. 
1046                     ; 602 * @param MemSize : pointer on data containing the size
1046                     ; 603 * @param Line: Line to display Icref on the screen
1046                     ; 604 * @retval	ISO15693_DISPLAY_UNHANDLED : no display done	
1046                     ; 605 * @retval	ISO15693_DISPLAY_HANDLED : a display was done			
1046                     ; 606 */
1046                     ; 607 static u8 ISO15693_Display_Tag_MemSize(const u8* MemSize, const u8 Number_of_Bytes_MemSize, const u8 Line)
1046                     ; 608 {
1046                     ; 609 	u32 size;//to retrieve number up to 1023 for memory size
1046                     ; 610 	// Begin display
1046                     ; 611 	LCD_SetCursorPos(Line, LCD_STARTLEFTCORNER);
1046                     ; 612 	LCD_PrintString(Line,DISABLE,ENABLE,"MEMORY: " );
1046                     ; 613 	// Compute size
1046                     ; 614 	size= ISO15693_Get_MemSize_kbits(MemSize,Number_of_Bytes_MemSize);
1046                     ; 615 	if(size==INIT_VALUE)// if the size is less than 1kbits
1046                     ; 616 	{
1046                     ; 617 		size=ISO15693_Get_MemSize_bits(MemSize,Number_of_Bytes_MemSize);
1046                     ; 618 		LCD_PrintDec7(size);// Display =size in bits
1046                     ; 619 		LCD_PrintString(Line,DISABLE,ENABLE," b" );
1046                     ; 620 	}
1046                     ; 621 	else
1046                     ; 622 	{
1046                     ; 623 		LCD_PrintDec(size);// Display =size in kbits
1046                     ; 624 		LCD_PrintString(Line,DISABLE,ENABLE," kb" );
1046                     ; 625 	}
1046                     ; 626 	return ISO15693_DISPLAY_HANDLED;
1046                     ; 627 }
1046                     ; 628 
1046                     ; 629 /******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/
1048  02a2 0a09          	dec	(OFST+0,sp)
1049  02a4               L134:
1050                     ; 409 		while (Tag_counter!=INIT_VALUE)
1050                     ; 410 		{
1050                     ; 411 			Resp_status= ISO15693_Get_UID_from_EEPROM(Tag_1,Tag_counter);
1050                     ; 412 			Resp_status=M24LRXX_Get_System_Info(&MyTag15693, ISO15693_Request_Flags,Tag_1);
1050                     ; 413 			if(Resp_status!= M24LRXX_SUCCESS_CODE)
1050                     ; 414 			{
1050                     ; 415 				ISO15693_Request_Flags=ComputeByte(
1050                     ; 416 				ISO15693_BIT3RESET_BIT8_RFU,
1050                     ; 417 				ISO15693_BIT3RESET_BIT7_OPTIONFLAG_SET,
1050                     ; 418 				ISO15693_BIT3RESET_BIT6_REQUEST_ADDRESSED,
1050                     ; 419 				ISO15693_BIT3RESET_BIT5_REQUEST_TAG_NOT_SELECTED,
1050                     ; 420 				ISO15693_BIT4_NO_PROTOCOL_EXTENSION,
1050                     ; 421 				ISO15693_BIT3_INVENTORY_FLAG_RESET,
1050                     ; 422 				ISO15693_BIT2_LOW_DATARATE,
1050                     ; 423 				ISO15693_BIT1_SINGLE_SUBCARRIER);
1050                     ; 424 				Resp_status=LRIXK_Get_System_Info(&MyTag15693, ISO15693_Request_Flags,Tag_1);
1050                     ; 425 			}
1050                     ; 426 		
1050                     ; 427 			
1050                     ; 428 			// Make some display
1050                     ; 429 			ISO15693_Display_Tag_Answer_Inventory_GetSys_Info();
1050                     ; 430 			Tag_counter--;
1052  02a4 0d09          	tnz	(OFST+0,sp)
1053  02a6 26ac          	jrne	L524
1055  02a8 205a          	jra	L734
1056  02aa               L324:
1057                     ; 436 		if(Protocol_Settings.protocol_in_use==CR95HF_PROT_SEL_FIELDOFF)
1059  02aa 3d19          	tnz	_Protocol_Settings
1060  02ac 262a          	jrne	L144
1061                     ; 438 			LCD_DisplayLogo(LCD_LOGOTYPE_LINE1_LEFT_CORNER );
1063  02ae a680          	ld	a,#128
1064  02b0 cd0000        	call	_LCD_DisplayLogo
1066                     ; 439 			LCD_Print(" CR95HF ");
1068  02b3 ae00bc        	ldw	x,#L344
1069  02b6 cd0000        	call	_LCD_Print
1071                     ; 440 			LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"## Field off ##");
1073  02b9 ae00ac        	ldw	x,#L544
1074  02bc 89            	pushw	x
1075  02bd 4b00          	push	#0
1076  02bf ae9001        	ldw	x,#36865
1077  02c2 cd0000        	call	_LCD_PrintString
1079  02c5 5b03          	addw	sp,#3
1080                     ; 441 			Display_Motion(LOW_SPEED_DISPLAY_MOTION);
1082  02c7 a608          	ld	a,#8
1083  02c9 cd0178        	call	L16_Display_Motion
1085                     ; 442 			LED_Switch_on(YELLOW_LED);// activate  Yellow LED
1087  02cc a602          	ld	a,#2
1088  02ce cd0000        	call	_LED_Switch_on
1090                     ; 443 			LED_Switch_off(BLUE_LED);// deactivate  blue LED
1092  02d1 a608          	ld	a,#8
1093  02d3 cd0000        	call	_LED_Switch_off
1096  02d6 2027          	jra	L744
1097  02d8               L144:
1098                     ; 447 			LCD_DisplayLogo(LCD_LOGOTYPE_LINE1_LEFT_CORNER );
1100  02d8 a680          	ld	a,#128
1101  02da cd0000        	call	_LCD_DisplayLogo
1103                     ; 448 			LCD_Print(" CR95HF ");
1105  02dd ae00bc        	ldw	x,#L344
1106  02e0 cd0000        	call	_LCD_Print
1108                     ; 449 			LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"##  No tag   ##");
1110  02e3 ae009c        	ldw	x,#L154
1111  02e6 89            	pushw	x
1112  02e7 4b00          	push	#0
1113  02e9 ae9001        	ldw	x,#36865
1114  02ec cd0000        	call	_LCD_PrintString
1116  02ef 5b03          	addw	sp,#3
1117                     ; 450 			Display_Motion(DEFAULT_SPEED_DISPLAY_MOTION);
1119  02f1 4f            	clr	a
1120  02f2 cd0178        	call	L16_Display_Motion
1122                     ; 451 			LED_Switch_on(BLUE_LED);// activate  BLUE LED
1124  02f5 a608          	ld	a,#8
1125  02f7 cd0000        	call	_LED_Switch_on
1127                     ; 452 			LED_Switch_off(YELLOW_LED);// deactivate  Yellow LED
1129  02fa a602          	ld	a,#2
1130  02fc cd0000        	call	_LED_Switch_off
1132  02ff               L744:
1133                     ; 455 		LED_Switch_off(GREEN_LED);// deactivate GREEN LED
1135  02ff a601          	ld	a,#1
1136  0301 cd0000        	call	_LED_Switch_off
1138  0304               L734:
1139                     ; 458 }		
1142  0304 5b09          	addw	sp,#9
1143  0306 81            	ret
1178                     ; 468 static void ISO15693_Display_Tag_Answer_Inventory_GetSys_Info(void) 
1178                     ; 469 {
1179                     	switch	.text
1180  0307               L56_ISO15693_Display_Tag_Answer_Inventory_GetSys_Info:
1184                     ; 470 	if(MyTag15693.command_ok==ISO15693_SUCCESS_CODE)
1186  0307 3d22          	tnz	_MyTag15693
1187  0309 2654          	jrne	L364
1188                     ; 472 		LCD_Clear();
1190  030b cd0000        	call	_LCD_Clear
1192                     ; 473 		if(ISO15693_Get_Slots_Flag(ISO15693_Request_Flags_Inventory)==ISO15693_1_SLOT)
1194  030e b620          	ld	a,_ISO15693_Request_Flags_Inventory
1195  0310 cd0000        	call	_ISO15693_Get_Slots_Flag
1197  0313 a101          	cp	a,#1
1198  0315 2613          	jrne	L564
1199                     ; 475 			ISO15693_Display_Tag_ICREF(MyTag15693.ICRef, LCD_LINE1);
1201  0317 ae0080        	ldw	x,#128
1202  031a b644          	ld	a,_MyTag15693+34
1203  031c 95            	ld	xh,a
1204  031d cd03b1        	call	L17_ISO15693_Display_Tag_ICREF
1206                     ; 476 			ISO15693_Display_Tag_UID(MyTag15693.UID_Tag,LCD_LINE2);		
1208  0320 4b90          	push	#144
1209  0322 ae003a        	ldw	x,#_MyTag15693+24
1210  0325 ad52          	call	L76_ISO15693_Display_Tag_UID
1212  0327 84            	pop	a
1214  0328 204e          	jra	L774
1215  032a               L564:
1216                     ; 481 			if(ISO15693_Inventory_16slots_Nb_UID_Retrieved==1)
1218  032a b61e          	ld	a,_ISO15693_Inventory_16slots_Nb_UID_Retrieved
1219  032c a101          	cp	a,#1
1220  032e 2612          	jrne	L174
1221                     ; 484 				ISO15693_Display_Tag_ICREF(MyTag15693.ICRef, LCD_LINE1);
1223  0330 ae0080        	ldw	x,#128
1224  0333 b644          	ld	a,_MyTag15693+34
1225  0335 95            	ld	xh,a
1226  0336 ad79          	call	L17_ISO15693_Display_Tag_ICREF
1228                     ; 485 				ISO15693_Display_Tag_UID(MyTag15693.UID_Tag,LCD_LINE2);
1230  0338 4b90          	push	#144
1231  033a ae003a        	ldw	x,#_MyTag15693+24
1232  033d ad3a          	call	L76_ISO15693_Display_Tag_UID
1234  033f 84            	pop	a
1236  0340 2036          	jra	L774
1237  0342               L174:
1238                     ; 489 				LCD_SetCursorPos(LCD_LINE1, LCD_STARTLEFTCORNER);
1240  0342 ae8000        	ldw	x,#32768
1241  0345 cd0000        	call	_LCD_SetCursorPos
1243                     ; 491 				LCD_PrintString(LCD_LINE1,DISABLE,ENABLE," TAGS SEEN: ");
1245  0348 ae008f        	ldw	x,#L574
1246  034b 89            	pushw	x
1247  034c 4b01          	push	#1
1248  034e ae8000        	ldw	x,#32768
1249  0351 cd0000        	call	_LCD_PrintString
1251  0354 5b03          	addw	sp,#3
1252                     ; 492 				LCD_PrintDec(ISO15693_Inventory_16slots_Nb_UID_Retrieved);
1254  0356 b61e          	ld	a,_ISO15693_Inventory_16slots_Nb_UID_Retrieved
1255  0358 5f            	clrw	x
1256  0359 97            	ld	xl,a
1257  035a cd0000        	call	_LCD_PrintDec
1259  035d 2019          	jra	L774
1260  035f               L364:
1261                     ; 499 		LCD_Clear();
1263  035f cd0000        	call	_LCD_Clear
1265                     ; 501 		LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"   TAG UID");
1267  0362 ae0084        	ldw	x,#L105
1268  0365 89            	pushw	x
1269  0366 4b00          	push	#0
1270  0368 ae8001        	ldw	x,#32769
1271  036b cd0000        	call	_LCD_PrintString
1273  036e 5b03          	addw	sp,#3
1274                     ; 502 		ISO15693_Display_Tag_UID(MyTag15693.UID_Tag,LCD_LINE2);
1276  0370 4b90          	push	#144
1277  0372 ae003a        	ldw	x,#_MyTag15693+24
1278  0375 ad02          	call	L76_ISO15693_Display_Tag_UID
1280  0377 84            	pop	a
1281  0378               L774:
1282                     ; 504 }
1285  0378 81            	ret
1341                     ; 514 static void ISO15693_Display_Tag_UID(const u8* UID, const u8 Line)
1341                     ; 515 {
1342                     	switch	.text
1343  0379               L76_ISO15693_Display_Tag_UID:
1345  0379 89            	pushw	x
1346  037a 88            	push	a
1347       00000001      OFST:	set	1
1350                     ; 516 	u8 UID_cursor=ISO15693_UID_SIZE;// Starting from MSB
1352  037b a608          	ld	a,#8
1353  037d 6b01          	ld	(OFST+0,sp),a
1354                     ; 517 	UID_cursor--;// strating from UID[7]
1356  037f 0a01          	dec	(OFST+0,sp)
1357                     ; 518 	UID_cursor--;// Masking EO
1359  0381 0a01          	dec	(OFST+0,sp)
1360                     ; 519 	LCD_SetCursorPos(Line, LCD_STARTLEFTCORNER);
1362  0383 5f            	clrw	x
1363  0384 7b06          	ld	a,(OFST+5,sp)
1364  0386 95            	ld	xh,a
1365  0387 cd0000        	call	_LCD_SetCursorPos
1368  038a 200f          	jra	L335
1369  038c               L135:
1370                     ; 524 		LCD_PrintHex2(UID[UID_cursor--]);
1372  038c 7b01          	ld	a,(OFST+0,sp)
1373  038e 97            	ld	xl,a
1374  038f 0a01          	dec	(OFST+0,sp)
1375  0391 9f            	ld	a,xl
1376  0392 5f            	clrw	x
1377  0393 97            	ld	xl,a
1378  0394 72fb02        	addw	x,(OFST+1,sp)
1379  0397 f6            	ld	a,(x)
1380  0398 cd0000        	call	_LCD_PrintHex2
1382  039b               L335:
1383                     ; 522 	while(UID_cursor!=INIT_VALUE)
1385  039b 0d01          	tnz	(OFST+0,sp)
1386  039d 26ed          	jrne	L135
1387                     ; 526 	LCD_PrintHex2(UID[UID_cursor]);//UID cursor =0 at this level
1389  039f 7b02          	ld	a,(OFST+1,sp)
1390  03a1 97            	ld	xl,a
1391  03a2 7b03          	ld	a,(OFST+2,sp)
1392  03a4 1b01          	add	a,(OFST+0,sp)
1393  03a6 2401          	jrnc	L62
1394  03a8 5c            	incw	x
1395  03a9               L62:
1396  03a9 02            	rlwa	x,a
1397  03aa f6            	ld	a,(x)
1398  03ab cd0000        	call	_LCD_PrintHex2
1400                     ; 527 }
1403  03ae 5b03          	addw	sp,#3
1404  03b0 81            	ret
1469                     ; 537 static u8 ISO15693_Display_Tag_ICREF(const u8 Tag_ICRef, const u8 Line)
1469                     ; 538 {
1470                     	switch	.text
1471  03b1               L17_ISO15693_Display_Tag_ICREF:
1473  03b1 89            	pushw	x
1474  03b2 89            	pushw	x
1475       00000002      OFST:	set	2
1478                     ; 539 	u8 status=ISO15693_DISPLAY_UNHANDLED;
1480  03b3 a601          	ld	a,#1
1481  03b5 6b01          	ld	(OFST-1,sp),a
1482                     ; 540 	u8 ICRef_6MSB=Tag_ICRef&MASK_ICREF_6MSB;// retrieve only the 6 MSB bits
1484  03b7 9e            	ld	a,xh
1485  03b8 a4fc          	and	a,#252
1486  03ba 6b02          	ld	(OFST+0,sp),a
1487                     ; 541 	LCD_SetCursorPos(Line, LCD_STARTLEFTCORNER);
1489  03bc 5f            	clrw	x
1490  03bd 7b04          	ld	a,(OFST+2,sp)
1491  03bf 95            	ld	xh,a
1492  03c0 cd0000        	call	_LCD_SetCursorPos
1494                     ; 543 	if( Tag_ICRef!= ISO15693_STRUCT_INITVALUE)
1496  03c3 7b03          	ld	a,(OFST+1,sp)
1497  03c5 a1ec          	cp	a,#236
1498  03c7 2603          	jrne	L23
1499  03c9 cc0492        	jp	L175
1500  03cc               L23:
1501                     ; 545 		if(ICRef_6MSB==LRI1K)
1503  03cc 7b02          	ld	a,(OFST+0,sp)
1504  03ce a140          	cp	a,#64
1505  03d0 2615          	jrne	L375
1506                     ; 547 			LCD_PrintString(Line,ENABLE,DISABLE, LRI1K_TEXT );
1508  03d2 ae0075        	ldw	x,#L575
1509  03d5 89            	pushw	x
1510  03d6 4b00          	push	#0
1511  03d8 ae0001        	ldw	x,#1
1512  03db 7b07          	ld	a,(OFST+5,sp)
1513  03dd 95            	ld	xh,a
1514  03de cd0000        	call	_LCD_PrintString
1516  03e1 5b03          	addw	sp,#3
1518  03e3 ac900490      	jpf	L775
1519  03e7               L375:
1520                     ; 551 			if(ICRef_6MSB==LRI2K)
1522  03e7 7b02          	ld	a,(OFST+0,sp)
1523  03e9 a120          	cp	a,#32
1524  03eb 2614          	jrne	L106
1525                     ; 553 				LCD_PrintString(Line,ENABLE,DISABLE, LRI2K_TEXT );
1527  03ed ae0066        	ldw	x,#L306
1528  03f0 89            	pushw	x
1529  03f1 4b00          	push	#0
1530  03f3 ae0001        	ldw	x,#1
1531  03f6 7b07          	ld	a,(OFST+5,sp)
1532  03f8 95            	ld	xh,a
1533  03f9 cd0000        	call	_LCD_PrintString
1535  03fc 5b03          	addw	sp,#3
1537  03fe cc0490        	jra	L775
1538  0401               L106:
1539                     ; 557 				if(ICRef_6MSB==LRIS2K)
1541  0401 7b02          	ld	a,(OFST+0,sp)
1542  0403 a128          	cp	a,#40
1543  0405 2613          	jrne	L706
1544                     ; 559 					LCD_PrintString(Line,ENABLE,DISABLE, LRIS2K_TEXT );
1546  0407 ae0057        	ldw	x,#L116
1547  040a 89            	pushw	x
1548  040b 4b00          	push	#0
1549  040d ae0001        	ldw	x,#1
1550  0410 7b07          	ld	a,(OFST+5,sp)
1551  0412 95            	ld	xh,a
1552  0413 cd0000        	call	_LCD_PrintString
1554  0416 5b03          	addw	sp,#3
1556  0418 2076          	jra	L775
1557  041a               L706:
1558                     ; 563 					if(ICRef_6MSB==LRIS64K)
1560  041a 7b02          	ld	a,(OFST+0,sp)
1561  041c a144          	cp	a,#68
1562  041e 2613          	jrne	L516
1563                     ; 565 						LCD_PrintString(Line,ENABLE,DISABLE, LRIS64K_TEXT );
1565  0420 ae0048        	ldw	x,#L716
1566  0423 89            	pushw	x
1567  0424 4b00          	push	#0
1568  0426 ae0001        	ldw	x,#1
1569  0429 7b07          	ld	a,(OFST+5,sp)
1570  042b 95            	ld	xh,a
1571  042c cd0000        	call	_LCD_PrintString
1573  042f 5b03          	addw	sp,#3
1575  0431 205d          	jra	L775
1576  0433               L516:
1577                     ; 569 						if(ICRef_6MSB==M24LR64_R)
1579  0433 7b02          	ld	a,(OFST+0,sp)
1580  0435 a12c          	cp	a,#44
1581  0437 2613          	jrne	L326
1582                     ; 571 							LCD_PrintString(Line,ENABLE,DISABLE, M24LR64_R_TEXT );
1584  0439 ae0038        	ldw	x,#L526
1585  043c 89            	pushw	x
1586  043d 4b00          	push	#0
1587  043f ae0001        	ldw	x,#1
1588  0442 7b07          	ld	a,(OFST+5,sp)
1589  0444 95            	ld	xh,a
1590  0445 cd0000        	call	_LCD_PrintString
1592  0448 5b03          	addw	sp,#3
1594  044a 2044          	jra	L775
1595  044c               L326:
1596                     ; 575 							if(ICRef_6MSB==M24LRXX_E)
1598  044c 7b02          	ld	a,(OFST+0,sp)
1599  044e a14c          	cp	a,#76
1600  0450 262a          	jrne	L136
1601                     ; 577 								LCD_PrintString(Line,ENABLE,DISABLE, M24LRXX_E_TEXT );
1603  0452 ae0028        	ldw	x,#L336
1604  0455 89            	pushw	x
1605  0456 4b00          	push	#0
1606  0458 ae0001        	ldw	x,#1
1607  045b 7b07          	ld	a,(OFST+5,sp)
1608  045d 95            	ld	xh,a
1609  045e cd0000        	call	_LCD_PrintString
1611  0461 5b03          	addw	sp,#3
1612                     ; 579 								if(Tag_ICRef==M24LR16_E)
1614  0463 7b03          	ld	a,(OFST+1,sp)
1615  0465 a14e          	cp	a,#78
1616  0467 2627          	jrne	L775
1617                     ; 580 									LCD_PrintString(Line,ENABLE,DISABLE, M24LR16_E_TEXT );
1619  0469 ae0018        	ldw	x,#L736
1620  046c 89            	pushw	x
1621  046d 4b00          	push	#0
1622  046f ae0001        	ldw	x,#1
1623  0472 7b07          	ld	a,(OFST+5,sp)
1624  0474 95            	ld	xh,a
1625  0475 cd0000        	call	_LCD_PrintString
1627  0478 5b03          	addw	sp,#3
1628  047a 2014          	jra	L775
1629  047c               L136:
1630                     ; 585 								LCD_PrintString(Line,DISABLE,ENABLE,"ICREF: " );
1632  047c ae0010        	ldw	x,#L346
1633  047f 89            	pushw	x
1634  0480 4b01          	push	#1
1635  0482 5f            	clrw	x
1636  0483 7b07          	ld	a,(OFST+5,sp)
1637  0485 95            	ld	xh,a
1638  0486 cd0000        	call	_LCD_PrintString
1640  0489 5b03          	addw	sp,#3
1641                     ; 586 								LCD_PrintHex2(Tag_ICRef);
1643  048b 7b03          	ld	a,(OFST+1,sp)
1644  048d cd0000        	call	_LCD_PrintHex2
1646  0490               L775:
1647                     ; 593 		status=ISO15693_DISPLAY_HANDLED;
1649  0490 0f01          	clr	(OFST-1,sp)
1650  0492               L175:
1651                     ; 595 	return status;
1653  0492 7b01          	ld	a,(OFST-1,sp)
1656  0494 5b04          	addw	sp,#4
1657  0496 81            	ret
1727                     ; 607 static u8 ISO15693_Display_Tag_MemSize(const u8* MemSize, const u8 Number_of_Bytes_MemSize, const u8 Line)
1727                     ; 608 {
1728                     	switch	.text
1729  0497               L37_ISO15693_Display_Tag_MemSize:
1731  0497 89            	pushw	x
1732  0498 5204          	subw	sp,#4
1733       00000004      OFST:	set	4
1736                     ; 611 	LCD_SetCursorPos(Line, LCD_STARTLEFTCORNER);
1738  049a 5f            	clrw	x
1739  049b 7b0a          	ld	a,(OFST+6,sp)
1740  049d 95            	ld	xh,a
1741  049e cd0000        	call	_LCD_SetCursorPos
1743                     ; 612 	LCD_PrintString(Line,DISABLE,ENABLE,"MEMORY: " );
1745  04a1 ae0007        	ldw	x,#L776
1746  04a4 89            	pushw	x
1747  04a5 4b01          	push	#1
1748  04a7 5f            	clrw	x
1749  04a8 7b0d          	ld	a,(OFST+9,sp)
1750  04aa 95            	ld	xh,a
1751  04ab cd0000        	call	_LCD_PrintString
1753  04ae 5b03          	addw	sp,#3
1754                     ; 614 	size= ISO15693_Get_MemSize_kbits(MemSize,Number_of_Bytes_MemSize);
1756  04b0 7b09          	ld	a,(OFST+5,sp)
1757  04b2 88            	push	a
1758  04b3 1e06          	ldw	x,(OFST+2,sp)
1759  04b5 cd0000        	call	_ISO15693_Get_MemSize_kbits
1761  04b8 84            	pop	a
1762  04b9 cd0000        	call	c_uitolx
1764  04bc 96            	ldw	x,sp
1765  04bd 1c0001        	addw	x,#OFST-3
1766  04c0 cd0000        	call	c_rtol
1768                     ; 615 	if(size==INIT_VALUE)// if the size is less than 1kbits
1770  04c3 96            	ldw	x,sp
1771  04c4 1c0001        	addw	x,#OFST-3
1772  04c7 cd0000        	call	c_lzmp
1774  04ca 262c          	jrne	L107
1775                     ; 617 		size=ISO15693_Get_MemSize_bits(MemSize,Number_of_Bytes_MemSize);
1777  04cc 7b09          	ld	a,(OFST+5,sp)
1778  04ce 88            	push	a
1779  04cf 1e06          	ldw	x,(OFST+2,sp)
1780  04d1 cd0000        	call	_ISO15693_Get_MemSize_bits
1782  04d4 84            	pop	a
1783  04d5 96            	ldw	x,sp
1784  04d6 1c0001        	addw	x,#OFST-3
1785  04d9 cd0000        	call	c_rtol
1787                     ; 618 		LCD_PrintDec7(size);// Display =size in bits
1789  04dc 1e03          	ldw	x,(OFST-1,sp)
1790  04de 89            	pushw	x
1791  04df 1e03          	ldw	x,(OFST-1,sp)
1792  04e1 89            	pushw	x
1793  04e2 cd0000        	call	_LCD_PrintDec7
1795  04e5 5b04          	addw	sp,#4
1796                     ; 619 		LCD_PrintString(Line,DISABLE,ENABLE," b" );
1798  04e7 ae0004        	ldw	x,#L307
1799  04ea 89            	pushw	x
1800  04eb 4b01          	push	#1
1801  04ed 5f            	clrw	x
1802  04ee 7b0d          	ld	a,(OFST+9,sp)
1803  04f0 95            	ld	xh,a
1804  04f1 cd0000        	call	_LCD_PrintString
1806  04f4 5b03          	addw	sp,#3
1808  04f6 2014          	jra	L507
1809  04f8               L107:
1810                     ; 623 		LCD_PrintDec(size);// Display =size in kbits
1812  04f8 1e03          	ldw	x,(OFST-1,sp)
1813  04fa cd0000        	call	_LCD_PrintDec
1815                     ; 624 		LCD_PrintString(Line,DISABLE,ENABLE," kb" );
1817  04fd ae0000        	ldw	x,#L707
1818  0500 89            	pushw	x
1819  0501 4b01          	push	#1
1820  0503 5f            	clrw	x
1821  0504 7b0d          	ld	a,(OFST+9,sp)
1822  0506 95            	ld	xh,a
1823  0507 cd0000        	call	_LCD_PrintString
1825  050a 5b03          	addw	sp,#3
1826  050c               L507:
1827                     ; 626 	return ISO15693_DISPLAY_HANDLED;
1829  050c 4f            	clr	a
1832  050d 5b06          	addw	sp,#6
1833  050f 81            	ret
2122                     	xdef	_main
2123                     	xdef	_Resp_status
2124                     	switch	.ubsct
2125  0000               _CR95HF_response:
2126  0000 000000000000  	ds.b	21
2127                     	xdef	_CR95HF_response
2128  0015               _Idle_Config:
2129  0015 00000000      	ds.b	4
2130                     	xdef	_Idle_Config
2131  0019               _Protocol_Settings:
2132  0019 0000000000    	ds.b	5
2133                     	xdef	_Protocol_Settings
2134  001e               _ISO15693_Inventory_16slots_Nb_UID_Retrieved:
2135  001e 00            	ds.b	1
2136                     	xdef	_ISO15693_Inventory_16slots_Nb_UID_Retrieved
2137  001f               _ISO15693_ProtocolSelect_Parameters:
2138  001f 00            	ds.b	1
2139                     	xdef	_ISO15693_ProtocolSelect_Parameters
2140  0020               _ISO15693_Request_Flags_Inventory:
2141  0020 00            	ds.b	1
2142                     	xdef	_ISO15693_Request_Flags_Inventory
2143  0021               _ISO15693_Request_Flags:
2144  0021 00            	ds.b	1
2145                     	xdef	_ISO15693_Request_Flags
2146  0022               _MyTag15693:
2147  0022 000000000000  	ds.b	38
2148                     	xdef	_MyTag15693
2149                     	xref.b	_SPI_or_UART_Communication
2150                     	xref.b	_communication_watchdog
2151                     	xref	_Wait_Display
2152                     	xref	_Select_Protocol_ISO15693
2153                     	xref	_RunUserApplication
2154                     	xref	_M24LRXX_Get_System_Info
2155                     	xref	_LRIXK_Get_System_Info
2156                     	xref	_LRIXK_Inventory
2157                     	xref	_ISO15693_Get_UID_from_EEPROM
2158                     	xref	_ISO15693_Get_MemSize_bits
2159                     	xref	_ISO15693_Get_MemSize_kbits
2160                     	xref	_ISO15693_Get_Slots_Flag
2161                     	xref	_CR95HF_Idle_Detector_Calibration
2162                     	xref	_CR95HF_ProtocolSelect
2163                     	xref	_CR95HF_Echo
2164                     	xref	_CR95HF_IDN
2165                     	xref	_CR95HF_IRQ_in_Interrupt
2166                     	xref	_CR95HF_SPIReset
2167                     	xref	_ComputeByte
2168                     	xref	_LED_Switch_off
2169                     	xref	_LED_Switch_on
2170                     	xref	_Board_Init_Display
2171                     	xref	_Board_Init_Board
2172                     	xref	_delay_10us_base
2173                     	xref	_delay_ms
2174                     	xref	_LCD_Print
2175                     	xref	_LCD_PrintDec
2176                     	xref	_LCD_PrintDec7
2177                     	xref	_LCD_PrintHex2
2178                     	xref	_LCD_DisplayLogo
2179                     	xref	_LCD_PrintString
2180                     	xref	_LCD_PrintChar
2181                     	xref	_LCD_SetCursorPos
2182                     	xref	_LCD_Clear
2183                     	xref	_FLASH_GetFlagStatus
2184                     .const:	section	.text
2185  0000               L707:
2186  0000 206b6200      	dc.b	" kb",0
2187  0004               L307:
2188  0004 206200        	dc.b	" b",0
2189  0007               L776:
2190  0007 4d454d4f5259  	dc.b	"MEMORY: ",0
2191  0010               L346:
2192  0010 49435245463a  	dc.b	"ICREF: ",0
2193  0018               L736:
2194  0018 2a2a204d3234  	dc.b	"** M24LR16-E **",0
2195  0028               L336:
2196  0028 2a2a204d3234  	dc.b	"** M24LRXX-E **",0
2197  0038               L526:
2198  0038 2a2a204d3234  	dc.b	"** M24LR64-R **",0
2199  0048               L716:
2200  0048 202a2a204c52  	dc.b	" ** LRIS64k **",0
2201  0057               L116:
2202  0057 202a2a20204c  	dc.b	" **  LRIS2k **",0
2203  0066               L306:
2204  0066 202a2a20204c  	dc.b	" **  LRI2k  **",0
2205  0075               L575:
2206  0075 202a2a20204c  	dc.b	" **  LRI1k  **",0
2207  0084               L105:
2208  0084 202020544147  	dc.b	"   TAG UID",0
2209  008f               L574:
2210  008f 205441475320  	dc.b	" TAGS SEEN: ",0
2211  009c               L154:
2212  009c 232320204e6f  	dc.b	"##  No tag   ##",0
2213  00ac               L544:
2214  00ac 232320466965  	dc.b	"## Field off ##",0
2215  00bc               L344:
2216  00bc 204352393548  	dc.b	" CR95HF ",0
2217  00c5               L162:
2218  00c5 4d43553c2d3e  	dc.b	"MCU<->CR95HF ERR",0
2219  00d6               L332:
2220  00d6 202045455052  	dc.b	"  EEPROM LOCKED",0
2221  00e6               L722:
2222  00e6 202020434f4e  	dc.b	"   CONFIG OK",0
2223  00f3               L522:
2224  00f3 212320434647  	dc.b	"!# CFG ERR  #!",0
2225  0102               L512:
2226  0102 232320204563  	dc.b	"##  Echo KO  ##",0
2227  0112               L302:
2228  0112 232320202055  	dc.b	"##   UART    ##",0
2229  0122               L771:
2230  0122 202020202049  	dc.b	"     IRQ_in",0
2231  012e               L571:
2232  012e 232320202020  	dc.b	"##    SPI    ##",0
2252                     	xref	c_lzmp
2253                     	xref	c_rtol
2254                     	xref	c_uitolx
2255                     	end
