   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.9.10 - 10 Feb 2011
   3                     ; Generator (Limited) V4.3.6 - 15 Feb 2011
 110                     ; 1365 void RTC_WakeUpClockConfig(RTC_WakeUpClock_TypeDef RTC_WakeUpClock)
 110                     ; 1366 {
 112                     	switch	.text
 113  0000               _RTC_WakeUpClockConfig:
 115  0000 88            	push	a
 116       00000000      OFST:	set	0
 119                     ; 1369   assert_param(IS_RTC_WAKEUP_CLOCK(RTC_WakeUpClock));
 121                     ; 1372   RTC->WPR = 0xCA;
 123  0001 35ca5159      	mov	20825,#202
 124                     ; 1373   RTC->WPR = 0x53;
 126  0005 35535159      	mov	20825,#83
 127                     ; 1376   RTC->CR2 &= (uint8_t)~RTC_CR2_WUTE;
 129  0009 72155149      	bres	20809,#2
 130                     ; 1379   RTC->CR1 &= (uint8_t)~RTC_CR1_WUCKSEL;
 132  000d c65148        	ld	a,20808
 133  0010 a4f8          	and	a,#248
 134  0012 c75148        	ld	20808,a
 135                     ; 1382   RTC->CR1 |= (uint8_t)RTC_WakeUpClock;
 137  0015 c65148        	ld	a,20808
 138  0018 1a01          	or	a,(OFST+1,sp)
 139  001a c75148        	ld	20808,a
 140                     ; 1385   RTC->WPR = 0xFF; 
 142  001d 35ff5159      	mov	20825,#255
 143                     ; 1386 }
 146  0021 84            	pop	a
 147  0022 81            	ret
 182                     ; 1396 void RTC_SetWakeUpCounter(uint16_t RTC_WakeupCounter)
 182                     ; 1397 {
 183                     	switch	.text
 184  0023               _RTC_SetWakeUpCounter:
 188                     ; 1399   RTC->WPR = 0xCA;
 190  0023 35ca5159      	mov	20825,#202
 191                     ; 1400   RTC->WPR = 0x53;
 193  0027 35535159      	mov	20825,#83
 194                     ; 1404   RTC->WUTRH = (uint8_t)(RTC_WakeupCounter >> 8);
 196  002b 9e            	ld	a,xh
 197  002c c75154        	ld	20820,a
 198                     ; 1405   RTC->WUTRL = (uint8_t)(RTC_WakeupCounter);
 200  002f 9f            	ld	a,xl
 201  0030 c75155        	ld	20821,a
 202                     ; 1408   RTC->WPR = 0xFF; 
 204  0033 35ff5159      	mov	20825,#255
 205                     ; 1409 }
 208  0037 81            	ret
 303                     ; 1438 ErrorStatus RTC_WakeUpCmd(FunctionalState NewState)
 303                     ; 1439 {
 304                     	switch	.text
 305  0038               _RTC_WakeUpCmd:
 307  0038 5203          	subw	sp,#3
 308       00000003      OFST:	set	3
 311                     ; 1440   ErrorStatus status = ERROR;
 313                     ; 1441   uint16_t wutwfcount = 0;
 315  003a 5f            	clrw	x
 316  003b 1f02          	ldw	(OFST-1,sp),x
 317                     ; 1444   assert_param(IS_FUNCTIONAL_STATE(NewState));
 319                     ; 1447   RTC->WPR = 0xCA;
 321  003d 35ca5159      	mov	20825,#202
 322                     ; 1448   RTC->WPR = 0x53;
 324  0041 35535159      	mov	20825,#83
 325                     ; 1450   if (NewState != DISABLE)
 327  0045 4d            	tnz	a
 328  0046 2711          	jreq	L731
 329                     ; 1453     RTC->CR2 |= (uint8_t)RTC_CR2_WUTE;
 331  0048 72145149      	bset	20809,#2
 332                     ; 1455     status = SUCCESS;
 334  004c a601          	ld	a,#1
 335  004e 6b01          	ld	(OFST-2,sp),a
 337  0050               L141:
 338                     ; 1480   RTC->WPR = 0xFF; 
 340  0050 35ff5159      	mov	20825,#255
 341                     ; 1483   return (ErrorStatus)status;
 343  0054 7b01          	ld	a,(OFST-2,sp)
 346  0056 5b03          	addw	sp,#3
 347  0058 81            	ret
 348  0059               L731:
 349                     ; 1460     RTC->CR2 &= (uint8_t)~RTC_CR2_WUTE;
 351  0059 72155149      	bres	20809,#2
 353  005d 2007          	jra	L541
 354  005f               L341:
 355                     ; 1465       wutwfcount++;
 357  005f 1e02          	ldw	x,(OFST-1,sp)
 358  0061 1c0001        	addw	x,#1
 359  0064 1f02          	ldw	(OFST-1,sp),x
 360  0066               L541:
 361                     ; 1463     while (((RTC->ISR1 & RTC_ISR1_WUTWF) == RESET) && ( wutwfcount != WUTWF_TIMEOUT))
 363  0066 c6514c        	ld	a,20812
 364  0069 a504          	bcp	a,#4
 365  006b 2607          	jrne	L151
 367  006d 1e02          	ldw	x,(OFST-1,sp)
 368  006f a3ffff        	cpw	x,#65535
 369  0072 26eb          	jrne	L341
 370  0074               L151:
 371                     ; 1469     if ((RTC->ISR1 & RTC_ISR1_WUTWF) == RESET)
 373  0074 c6514c        	ld	a,20812
 374  0077 a504          	bcp	a,#4
 375  0079 2604          	jrne	L351
 376                     ; 1471       status = ERROR;
 378  007b 0f01          	clr	(OFST-2,sp)
 380  007d 20d1          	jra	L141
 381  007f               L351:
 382                     ; 1475       status = SUCCESS;
 384  007f a601          	ld	a,#1
 385  0081 6b01          	ld	(OFST-2,sp),a
 386  0083 20cb          	jra	L141
 458                     ; 2061 void RTC_ITConfig(RTC_IT_TypeDef RTC_IT, FunctionalState NewState)
 458                     ; 2062 {
 459                     	switch	.text
 460  0085               _RTC_ITConfig:
 462  0085 89            	pushw	x
 463       00000000      OFST:	set	0
 466                     ; 2064   assert_param(IS_RTC_CONFIG_IT(RTC_IT));
 468                     ; 2065   assert_param(IS_FUNCTIONAL_STATE(NewState));
 470                     ; 2068   RTC->WPR = 0xCA;
 472  0086 35ca5159      	mov	20825,#202
 473                     ; 2069   RTC->WPR = 0x53;
 475  008a 35535159      	mov	20825,#83
 476                     ; 2071   if (NewState != DISABLE)
 478  008e 0d05          	tnz	(OFST+5,sp)
 479  0090 2715          	jreq	L312
 480                     ; 2074     RTC->CR2 |= (uint8_t)((uint16_t)RTC_IT & (uint16_t)0x00F0);
 482  0092 9f            	ld	a,xl
 483  0093 a4f0          	and	a,#240
 484  0095 ca5149        	or	a,20809
 485  0098 c75149        	ld	20809,a
 486                     ; 2075     RTC->TCR1 |= (uint8_t)((uint16_t)RTC_IT & RTC_TCR1_TAMPIE);
 488  009b 7b02          	ld	a,(OFST+2,sp)
 489  009d a401          	and	a,#1
 490  009f ca516c        	or	a,20844
 491  00a2 c7516c        	ld	20844,a
 493  00a5 2016          	jra	L512
 494  00a7               L312:
 495                     ; 2080     RTC->CR2  &= (uint8_t)~(uint8_t)((uint16_t)RTC_IT & (uint16_t)0x00F0);
 497  00a7 7b02          	ld	a,(OFST+2,sp)
 498  00a9 a4f0          	and	a,#240
 499  00ab 43            	cpl	a
 500  00ac c45149        	and	a,20809
 501  00af c75149        	ld	20809,a
 502                     ; 2081     RTC->TCR1 &= (uint8_t)~(uint8_t)((uint16_t)RTC_IT & (uint16_t)RTC_TCR1_TAMPIE);
 504  00b2 7b02          	ld	a,(OFST+2,sp)
 505  00b4 a401          	and	a,#1
 506  00b6 43            	cpl	a
 507  00b7 c4516c        	and	a,20844
 508  00ba c7516c        	ld	20844,a
 509  00bd               L512:
 510                     ; 2085   RTC->WPR = 0xFF; 
 512  00bd 35ff5159      	mov	20825,#255
 513                     ; 2086 }
 516  00c1 85            	popw	x
 517  00c2 81            	ret
 553                     ; 2178 void RTC_ClearITPendingBit(RTC_IT_TypeDef RTC_IT)
 553                     ; 2179 {
 554                     	switch	.text
 555  00c3               _RTC_ClearITPendingBit:
 559                     ; 2181   assert_param(IS_RTC_CLEAR_IT((uint16_t)RTC_IT));
 561                     ; 2184   RTC->ISR2 = (uint8_t)~(uint8_t)((uint16_t)RTC_IT >> 4);
 563  00c3 54            	srlw	x
 564  00c4 54            	srlw	x
 565  00c5 54            	srlw	x
 566  00c6 54            	srlw	x
 567  00c7 9f            	ld	a,xl
 568  00c8 43            	cpl	a
 569  00c9 c7514d        	ld	20813,a
 570                     ; 2185 }
 573  00cc 81            	ret
 586                     	xdef	_RTC_ClearITPendingBit
 587                     	xdef	_RTC_ITConfig
 588                     	xdef	_RTC_WakeUpCmd
 589                     	xdef	_RTC_SetWakeUpCounter
 590                     	xdef	_RTC_WakeUpClockConfig
 609                     	end
