   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.9.10 - 10 Feb 2011
   3                     ; Generator (Limited) V4.3.6 - 15 Feb 2011
 136                     ; 122 void SPI_DeInit(SPI_TypeDef* SPIx)
 136                     ; 123 {
 138                     	switch	.text
 139  0000               _SPI_DeInit:
 143                     ; 124   SPIx->CR1    = SPI_CR1_RESET_VALUE;
 145  0000 7f            	clr	(x)
 146                     ; 125   SPIx->CR2    = SPI_CR2_RESET_VALUE;
 148  0001 6f01          	clr	(1,x)
 149                     ; 126   SPIx->CR3    = SPI_CR3_RESET_VALUE;
 151  0003 6f02          	clr	(2,x)
 152                     ; 127   SPIx->SR     = SPI_SR_RESET_VALUE;
 154  0005 a602          	ld	a,#2
 155  0007 e703          	ld	(3,x),a
 156                     ; 128   SPIx->CRCPR  = SPI_CRCPR_RESET_VALUE;
 158  0009 a607          	ld	a,#7
 159  000b e705          	ld	(5,x),a
 160                     ; 129 }
 163  000d 81            	ret
 489                     ; 171 void SPI_Init(SPI_TypeDef* SPIx, SPI_FirstBit_TypeDef SPI_FirstBit,
 489                     ; 172               SPI_BaudRatePrescaler_TypeDef SPI_BaudRatePrescaler,
 489                     ; 173               SPI_Mode_TypeDef SPI_Mode, SPI_CPOL_TypeDef SPI_CPOL,
 489                     ; 174               SPI_CPHA_TypeDef SPI_CPHA, SPI_DirectionMode_TypeDef SPI_Data_Direction,
 489                     ; 175               SPI_NSS_TypeDef SPI_Slave_Management, uint8_t CRCPolynomial)
 489                     ; 176 {
 490                     	switch	.text
 491  000e               _SPI_Init:
 493  000e 89            	pushw	x
 494  000f 88            	push	a
 495       00000001      OFST:	set	1
 498                     ; 178   assert_param(IS_SPI_FIRSTBIT(SPI_FirstBit));
 500                     ; 179   assert_param(IS_SPI_BAUDRATE_PRESCALER(SPI_BaudRatePrescaler));
 502                     ; 180   assert_param(IS_SPI_MODE(SPI_Mode));
 504                     ; 181   assert_param(IS_SPI_POLARITY(SPI_CPOL));
 506                     ; 182   assert_param(IS_SPI_PHASE(SPI_CPHA));
 508                     ; 183   assert_param(IS_SPI_DATA_DIRECTION(SPI_Data_Direction));
 510                     ; 184   assert_param(IS_SPI_SLAVEMANAGEMENT(SPI_Slave_Management));
 512                     ; 185   assert_param(IS_SPI_CRC_POLYNOMIAL(CRCPolynomial));
 514                     ; 188   SPIx->CR1 = (uint8_t)((uint8_t)((uint8_t)SPI_FirstBit |
 514                     ; 189                                   (uint8_t)SPI_BaudRatePrescaler) |
 514                     ; 190                         (uint8_t)((uint8_t)SPI_CPOL |
 514                     ; 191                                   SPI_CPHA));
 516  0010 7b09          	ld	a,(OFST+8,sp)
 517  0012 1a0a          	or	a,(OFST+9,sp)
 518  0014 6b01          	ld	(OFST+0,sp),a
 519  0016 7b06          	ld	a,(OFST+5,sp)
 520  0018 1a07          	or	a,(OFST+6,sp)
 521  001a 1a01          	or	a,(OFST+0,sp)
 522  001c 1e02          	ldw	x,(OFST+1,sp)
 523  001e f7            	ld	(x),a
 524                     ; 194   SPIx->CR2 = (uint8_t)((uint8_t)(SPI_Data_Direction) | (uint8_t)(SPI_Slave_Management));
 526  001f 7b0b          	ld	a,(OFST+10,sp)
 527  0021 1a0c          	or	a,(OFST+11,sp)
 528  0023 1e02          	ldw	x,(OFST+1,sp)
 529  0025 e701          	ld	(1,x),a
 530                     ; 196   if (SPI_Mode == SPI_Mode_Master)
 532  0027 7b08          	ld	a,(OFST+7,sp)
 533  0029 a104          	cp	a,#4
 534  002b 260a          	jrne	L562
 535                     ; 198     SPIx->CR2 |= (uint8_t)SPI_CR2_SSI;
 537  002d 1e02          	ldw	x,(OFST+1,sp)
 538  002f e601          	ld	a,(1,x)
 539  0031 aa01          	or	a,#1
 540  0033 e701          	ld	(1,x),a
 542  0035 2008          	jra	L762
 543  0037               L562:
 544                     ; 202     SPIx->CR2 &= (uint8_t)~(SPI_CR2_SSI);
 546  0037 1e02          	ldw	x,(OFST+1,sp)
 547  0039 e601          	ld	a,(1,x)
 548  003b a4fe          	and	a,#254
 549  003d e701          	ld	(1,x),a
 550  003f               L762:
 551                     ; 206   SPIx->CR1 |= (uint8_t)(SPI_Mode);
 553  003f 1e02          	ldw	x,(OFST+1,sp)
 554  0041 f6            	ld	a,(x)
 555  0042 1a08          	or	a,(OFST+7,sp)
 556  0044 f7            	ld	(x),a
 557                     ; 209   SPIx->CRCPR = (uint8_t)CRCPolynomial;
 559  0045 7b0d          	ld	a,(OFST+12,sp)
 560  0047 1e02          	ldw	x,(OFST+1,sp)
 561  0049 e705          	ld	(5,x),a
 562                     ; 210 }
 565  004b 5b03          	addw	sp,#3
 566  004d 81            	ret
 633                     ; 219 void SPI_Cmd(SPI_TypeDef* SPIx, FunctionalState NewState)
 633                     ; 220 {
 634                     	switch	.text
 635  004e               _SPI_Cmd:
 637  004e 89            	pushw	x
 638       00000000      OFST:	set	0
 641                     ; 222   assert_param(IS_FUNCTIONAL_STATE(NewState));
 643                     ; 224   if (NewState != DISABLE)
 645  004f 0d05          	tnz	(OFST+5,sp)
 646  0051 2706          	jreq	L523
 647                     ; 226     SPIx->CR1 |= SPI_CR1_SPE; /* Enable the SPI peripheral*/
 649  0053 f6            	ld	a,(x)
 650  0054 aa40          	or	a,#64
 651  0056 f7            	ld	(x),a
 653  0057 2006          	jra	L723
 654  0059               L523:
 655                     ; 230     SPIx->CR1 &= (uint8_t)(~SPI_CR1_SPE); /* Disable the SPI peripheral*/
 657  0059 1e01          	ldw	x,(OFST+1,sp)
 658  005b f6            	ld	a,(x)
 659  005c a4bf          	and	a,#191
 660  005e f7            	ld	(x),a
 661  005f               L723:
 662                     ; 232 }
 665  005f 85            	popw	x
 666  0060 81            	ret
 712                     ; 313 void SPI_SendData(SPI_TypeDef* SPIx, uint8_t Data)
 712                     ; 314 {
 713                     	switch	.text
 714  0061               _SPI_SendData:
 716  0061 89            	pushw	x
 717       00000000      OFST:	set	0
 720                     ; 315   SPIx->DR = Data; /* Write in the DR register the data to be sent*/
 722  0062 7b05          	ld	a,(OFST+5,sp)
 723  0064 1e01          	ldw	x,(OFST+1,sp)
 724  0066 e704          	ld	(4,x),a
 725                     ; 316 }
 728  0068 85            	popw	x
 729  0069 81            	ret
 766                     ; 323 uint8_t SPI_ReceiveData(SPI_TypeDef* SPIx)
 766                     ; 324 {
 767                     	switch	.text
 768  006a               _SPI_ReceiveData:
 772                     ; 325   return ((uint8_t)SPIx->DR); /* Return the data in the DR register*/
 774  006a e604          	ld	a,(4,x)
 777  006c 81            	ret
 910                     ; 657 FlagStatus SPI_GetFlagStatus(SPI_TypeDef* SPIx, SPI_FLAG_TypeDef SPI_FLAG)
 910                     ; 658 {
 911                     	switch	.text
 912  006d               _SPI_GetFlagStatus:
 914  006d 89            	pushw	x
 915  006e 88            	push	a
 916       00000001      OFST:	set	1
 919                     ; 659   FlagStatus status = RESET;
 921                     ; 661   assert_param(IS_SPI_FLAG(SPI_FLAG));
 923                     ; 664   if ((SPIx->SR & (uint8_t)SPI_FLAG) != (uint8_t)RESET)
 925  006f e603          	ld	a,(3,x)
 926  0071 1506          	bcp	a,(OFST+5,sp)
 927  0073 2706          	jreq	L754
 928                     ; 666     status = SET; /* SPI_FLAG is set */
 930  0075 a601          	ld	a,#1
 931  0077 6b01          	ld	(OFST+0,sp),a
 933  0079 2002          	jra	L164
 934  007b               L754:
 935                     ; 670     status = RESET; /* SPI_FLAG is reset*/
 937  007b 0f01          	clr	(OFST+0,sp)
 938  007d               L164:
 939                     ; 674   return status;
 941  007d 7b01          	ld	a,(OFST+0,sp)
 944  007f 5b03          	addw	sp,#3
 945  0081 81            	ret
 992                     ; 692 void SPI_ClearFlag(SPI_TypeDef* SPIx, SPI_FLAG_TypeDef SPI_FLAG)
 992                     ; 693 {
 993                     	switch	.text
 994  0082               _SPI_ClearFlag:
 996  0082 89            	pushw	x
 997       00000000      OFST:	set	0
1000                     ; 694   assert_param(IS_SPI_CLEAR_FLAG(SPI_FLAG));
1002                     ; 696   SPIx->SR = (uint8_t)(~SPI_FLAG);
1004  0083 7b05          	ld	a,(OFST+5,sp)
1005  0085 43            	cpl	a
1006  0086 1e01          	ldw	x,(OFST+1,sp)
1007  0088 e703          	ld	(3,x),a
1008                     ; 697 }
1011  008a 85            	popw	x
1012  008b 81            	ret
1025                     	xdef	_SPI_ClearFlag
1026                     	xdef	_SPI_GetFlagStatus
1027                     	xdef	_SPI_ReceiveData
1028                     	xdef	_SPI_SendData
1029                     	xdef	_SPI_Cmd
1030                     	xdef	_SPI_Init
1031                     	xdef	_SPI_DeInit
1050                     	end
