   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.9.10 - 10 Feb 2011
   3                     ; Generator (Limited) V4.3.6 - 15 Feb 2011
 163                     ; 142 void USART_DeInit(USART_TypeDef* USARTx)
 163                     ; 143 {
 165                     	switch	.text
 166  0000               _USART_DeInit:
 170                     ; 147   (void) USARTx->SR;
 172  0000 f6            	ld	a,(x)
 173                     ; 148   (void) USARTx->DR;
 175  0001 e601          	ld	a,(1,x)
 176                     ; 150   USARTx->BRR2 = USART_BRR2_RESET_VALUE;  /* Set USART_BRR2 to reset value 0x00 */
 178  0003 6f03          	clr	(3,x)
 179                     ; 151   USARTx->BRR1 = USART_BRR1_RESET_VALUE;  /* Set USART_BRR1 to reset value 0x00 */
 181  0005 6f02          	clr	(2,x)
 182                     ; 153   USARTx->CR1 = USART_CR1_RESET_VALUE;  /* Set USART_CR1 to reset value 0x00 */
 184  0007 6f04          	clr	(4,x)
 185                     ; 154   USARTx->CR2 = USART_CR2_RESET_VALUE;  /* Set USART_CR2 to reset value 0x00 */
 187  0009 6f05          	clr	(5,x)
 188                     ; 155   USARTx->CR3 = USART_CR3_RESET_VALUE;  /* Set USART_CR3 to reset value 0x00 */
 190  000b 6f06          	clr	(6,x)
 191                     ; 156   USARTx->CR4 = USART_CR4_RESET_VALUE;  /* Set USART_CR4 to reset value 0x00 */
 193  000d 6f07          	clr	(7,x)
 194                     ; 157 }
 197  000f 81            	ret
 389                     ; 186 void USART_Init(USART_TypeDef* USARTx, uint32_t BaudRate, USART_WordLength_TypeDef
 389                     ; 187                 USART_WordLength, USART_StopBits_TypeDef USART_StopBits,
 389                     ; 188                 USART_Parity_TypeDef USART_Parity,  USART_Mode_TypeDef USART_Mode)
 389                     ; 189 {
 390                     	switch	.text
 391  0010               _USART_Init:
 393  0010 89            	pushw	x
 394  0011 5204          	subw	sp,#4
 395       00000004      OFST:	set	4
 398                     ; 190   uint32_t BaudRate_Mantissa = 0;
 400                     ; 193   assert_param(IS_USART_BAUDRATE(BaudRate));
 402                     ; 195   assert_param(IS_USART_WORDLENGTH(USART_WordLength));
 404                     ; 197   assert_param(IS_USART_STOPBITS(USART_StopBits));
 406                     ; 199   assert_param(IS_USART_PARITY(USART_Parity));
 408                     ; 201   assert_param(IS_USART_MODE(USART_Mode));
 410                     ; 204   USARTx->CR1 &= (uint8_t)(~(USART_CR1_PCEN | USART_CR1_PS | USART_CR1_M));
 412  0013 e604          	ld	a,(4,x)
 413  0015 a4e9          	and	a,#233
 414  0017 e704          	ld	(4,x),a
 415                     ; 207   USARTx->CR1 |= (uint8_t)((uint8_t)USART_WordLength | (uint8_t)USART_Parity);
 417  0019 7b0d          	ld	a,(OFST+9,sp)
 418  001b 1a0f          	or	a,(OFST+11,sp)
 419  001d ea04          	or	a,(4,x)
 420  001f e704          	ld	(4,x),a
 421                     ; 210   USARTx->CR3 &= (uint8_t)(~USART_CR3_STOP);
 423  0021 e606          	ld	a,(6,x)
 424  0023 a4cf          	and	a,#207
 425  0025 e706          	ld	(6,x),a
 426                     ; 212   USARTx->CR3 |= (uint8_t)USART_StopBits;
 428  0027 e606          	ld	a,(6,x)
 429  0029 1a0e          	or	a,(OFST+10,sp)
 430  002b e706          	ld	(6,x),a
 431                     ; 215   USARTx->BRR1 &= (uint8_t)(~USART_BRR1_DIVM);
 433  002d 6f02          	clr	(2,x)
 434                     ; 217   USARTx->BRR2 &= (uint8_t)(~USART_BRR2_DIVM);
 436  002f e603          	ld	a,(3,x)
 437  0031 a40f          	and	a,#15
 438  0033 e703          	ld	(3,x),a
 439                     ; 219   USARTx->BRR2 &= (uint8_t)(~USART_BRR2_DIVF);
 441  0035 e603          	ld	a,(3,x)
 442  0037 a4f0          	and	a,#240
 443  0039 e703          	ld	(3,x),a
 444                     ; 221   BaudRate_Mantissa  = (uint32_t)(CLK_GetClockFreq() / BaudRate );
 446  003b cd0000        	call	_CLK_GetClockFreq
 448  003e 96            	ldw	x,sp
 449  003f 1c0009        	addw	x,#OFST+5
 450  0042 cd0000        	call	c_ludv
 452  0045 96            	ldw	x,sp
 453  0046 1c0001        	addw	x,#OFST-3
 454  0049 cd0000        	call	c_rtol
 456                     ; 223   USARTx->BRR2 = (uint8_t)((BaudRate_Mantissa >> (uint8_t)8) & (uint8_t)0xF0);
 458  004c 7b03          	ld	a,(OFST-1,sp)
 459  004e a4f0          	and	a,#240
 460  0050 1e05          	ldw	x,(OFST+1,sp)
 461  0052 e703          	ld	(3,x),a
 462                     ; 225   USARTx->BRR2 |= (uint8_t)(BaudRate_Mantissa & (uint8_t)0x0F);
 464  0054 1e05          	ldw	x,(OFST+1,sp)
 465  0056 7b04          	ld	a,(OFST+0,sp)
 466  0058 a40f          	and	a,#15
 467  005a ea03          	or	a,(3,x)
 468  005c e703          	ld	(3,x),a
 469                     ; 227   USARTx->BRR1 = (uint8_t)(BaudRate_Mantissa >> (uint8_t)4);
 471  005e 96            	ldw	x,sp
 472  005f 1c0001        	addw	x,#OFST-3
 473  0062 cd0000        	call	c_ltor
 475  0065 a604          	ld	a,#4
 476  0067 cd0000        	call	c_lursh
 478  006a b603          	ld	a,c_lreg+3
 479  006c 1e05          	ldw	x,(OFST+1,sp)
 480  006e e702          	ld	(2,x),a
 481                     ; 230   USARTx->CR2 &= (uint8_t)~(USART_CR2_TEN | USART_CR2_REN);
 483  0070 1e05          	ldw	x,(OFST+1,sp)
 484  0072 e605          	ld	a,(5,x)
 485  0074 a4f3          	and	a,#243
 486  0076 e705          	ld	(5,x),a
 487                     ; 232   USARTx->CR2 |= (uint8_t)USART_Mode;
 489  0078 1e05          	ldw	x,(OFST+1,sp)
 490  007a e605          	ld	a,(5,x)
 491  007c 1a10          	or	a,(OFST+12,sp)
 492  007e e705          	ld	(5,x),a
 493                     ; 233 }
 496  0080 5b06          	addw	sp,#6
 497  0082 81            	ret
 564                     ; 292 void USART_Cmd(USART_TypeDef* USARTx, FunctionalState NewState)
 564                     ; 293 {
 565                     	switch	.text
 566  0083               _USART_Cmd:
 568  0083 89            	pushw	x
 569       00000000      OFST:	set	0
 572                     ; 294   if (NewState != DISABLE)
 574  0084 0d05          	tnz	(OFST+5,sp)
 575  0086 2708          	jreq	L162
 576                     ; 296     USARTx->CR1 &= (uint8_t)(~USART_CR1_USARTD); /**< USART Enable */
 578  0088 e604          	ld	a,(4,x)
 579  008a a4df          	and	a,#223
 580  008c e704          	ld	(4,x),a
 582  008e 2008          	jra	L362
 583  0090               L162:
 584                     ; 300     USARTx->CR1 |= USART_CR1_USARTD;  /**< USART Disable (for low power consumption) */
 586  0090 1e01          	ldw	x,(OFST+1,sp)
 587  0092 e604          	ld	a,(4,x)
 588  0094 aa20          	or	a,#32
 589  0096 e704          	ld	(4,x),a
 590  0098               L362:
 591                     ; 302 }
 594  0098 85            	popw	x
 595  0099 81            	ret
 632                     ; 380 uint8_t USART_ReceiveData8(USART_TypeDef* USARTx)
 632                     ; 381 {
 633                     	switch	.text
 634  009a               _USART_ReceiveData8:
 638                     ; 382   return USARTx->DR;
 640  009a e601          	ld	a,(1,x)
 643  009c 81            	ret
 689                     ; 403 void USART_SendData8(USART_TypeDef* USARTx, uint8_t Data)
 689                     ; 404 {
 690                     	switch	.text
 691  009d               _USART_SendData8:
 693  009d 89            	pushw	x
 694       00000000      OFST:	set	0
 697                     ; 406   USARTx->DR = Data;
 699  009e 7b05          	ld	a,(OFST+5,sp)
 700  00a0 1e01          	ldw	x,(OFST+1,sp)
 701  00a2 e701          	ld	(1,x),a
 702                     ; 407 }
 705  00a4 85            	popw	x
 706  00a5 81            	ret
 854                     ; 1006 FlagStatus USART_GetFlagStatus(USART_TypeDef* USARTx, USART_FLAG_TypeDef USART_FLAG)
 854                     ; 1007 {
 855                     	switch	.text
 856  00a6               _USART_GetFlagStatus:
 858  00a6 89            	pushw	x
 859  00a7 88            	push	a
 860       00000001      OFST:	set	1
 863                     ; 1008   FlagStatus status = RESET;
 865                     ; 1011   assert_param(IS_USART_FLAG(USART_FLAG));
 867                     ; 1013   if (USART_FLAG == USART_FLAG_SBK)
 869  00a8 1e06          	ldw	x,(OFST+5,sp)
 870  00aa a30101        	cpw	x,#257
 871  00ad 2612          	jrne	L714
 872                     ; 1015     if ((USARTx->CR2 & (uint8_t)USART_FLAG) != (uint8_t)0x00)
 874  00af 1e02          	ldw	x,(OFST+1,sp)
 875  00b1 e605          	ld	a,(5,x)
 876  00b3 1507          	bcp	a,(OFST+6,sp)
 877  00b5 2706          	jreq	L124
 878                     ; 1018       status = SET;
 880  00b7 a601          	ld	a,#1
 881  00b9 6b01          	ld	(OFST+0,sp),a
 883  00bb 2013          	jra	L524
 884  00bd               L124:
 885                     ; 1023       status = RESET;
 887  00bd 0f01          	clr	(OFST+0,sp)
 888  00bf 200f          	jra	L524
 889  00c1               L714:
 890                     ; 1028     if ((USARTx->SR & (uint8_t)USART_FLAG) != (uint8_t)0x00)
 892  00c1 1e02          	ldw	x,(OFST+1,sp)
 893  00c3 f6            	ld	a,(x)
 894  00c4 1507          	bcp	a,(OFST+6,sp)
 895  00c6 2706          	jreq	L724
 896                     ; 1031       status = SET;
 898  00c8 a601          	ld	a,#1
 899  00ca 6b01          	ld	(OFST+0,sp),a
 901  00cc 2002          	jra	L524
 902  00ce               L724:
 903                     ; 1036       status = RESET;
 905  00ce 0f01          	clr	(OFST+0,sp)
 906  00d0               L524:
 907                     ; 1040   return status;
 909  00d0 7b01          	ld	a,(OFST+0,sp)
 912  00d2 5b03          	addw	sp,#3
 913  00d4 81            	ret
 960                     ; 1064 void USART_ClearFlag(USART_TypeDef* USARTx, USART_FLAG_TypeDef USART_FLAG)
 960                     ; 1065 {
 961                     	switch	.text
 962  00d5               _USART_ClearFlag:
 964  00d5 89            	pushw	x
 965       00000000      OFST:	set	0
 968                     ; 1067   assert_param(IS_USART_CLEAR_FLAG(USART_FLAG));
 970                     ; 1069   USARTx->SR = (uint8_t)((uint16_t)~((uint16_t)USART_FLAG));
 972  00d6 7b06          	ld	a,(OFST+6,sp)
 973  00d8 43            	cpl	a
 974  00d9 1e01          	ldw	x,(OFST+1,sp)
 975  00db f7            	ld	(x),a
 976                     ; 1070 }
 979  00dc 85            	popw	x
 980  00dd 81            	ret
 993                     	xdef	_USART_ClearFlag
 994                     	xdef	_USART_GetFlagStatus
 995                     	xdef	_USART_ReceiveData8
 996                     	xdef	_USART_SendData8
 997                     	xdef	_USART_Cmd
 998                     	xdef	_USART_Init
 999                     	xdef	_USART_DeInit
1000                     	xref	_CLK_GetClockFreq
1001                     	xref.b	c_lreg
1002                     	xref.b	c_x
1021                     	xref	c_lursh
1022                     	xref	c_ltor
1023                     	xref	c_rtol
1024                     	xref	c_ludv
1025                     	end
