   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.9.10 - 10 Feb 2011
   3                     ; Generator (Limited) V4.3.6 - 15 Feb 2011
 114                     ; 66 void RunUserApplication (void )
 114                     ; 67 {
 116                     	switch	.text
 117  0000               _RunUserApplication:
 119  0000 5203          	subw	sp,#3
 120       00000003      OFST:	set	3
 123                     ; 71 	u8 deviceID_char=INIT_VALUE; // incrementing counter to display data (string)
 125  0002 0f02          	clr	(OFST-1,sp)
 126                     ; 72 	u8 status=CR95HF_ERROR_CODE;
 128                     ; 73 	u8 status_Tag_seen= FALSE_CODE; // Here TRUE_CODE=EXIT_COMMUNICATION_OK
 130                     ; 76 	value = GetJoystickState ();
 132  0004 cd01af        	call	L11_GetJoystickState
 134  0007 6b01          	ld	(OFST-2,sp),a
 135                     ; 78 	switch (value)
 137  0009 7b01          	ld	a,(OFST-2,sp)
 139                     ; 340 			default : break;
 140  000b a017          	sub	a,#23
 141  000d 2603          	jrne	L6
 142  000f cc00c3        	jp	L12
 143  0012               L6:
 144  0012 a004          	sub	a,#4
 145  0014 2603          	jrne	L01
 146  0016 cc00b7        	jp	L71
 147  0019               L01:
 148  0019 a002          	sub	a,#2
 149  001b 2748          	jreq	L51
 150  001d 4a            	dec	a
 151  001e 2703          	jreq	L21
 152  0020 cc01a0        	jp	L57
 153  0023               L21:
 154                     ; 80 			case JOYSTICK_UPSTATE://up
 154                     ; 81 				// Send an IDN command and display the device ID.
 154                     ; 82 				CR95HF_IDN (&CR95HF_response);
 156  0023 ae0000        	ldw	x,#_CR95HF_response
 157  0026 cd0000        	call	_CR95HF_IDN
 159                     ; 84 				LCD_Clear();// CLear the LCD screen
 161  0029 cd0000        	call	_LCD_Clear
 163                     ; 85 				LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"  Device ID :");
 165  002c ae00e6        	ldw	x,#L77
 166  002f 89            	pushw	x
 167  0030 4b00          	push	#0
 168  0032 ae8001        	ldw	x,#32769
 169  0035 cd0000        	call	_LCD_PrintString
 171  0038 5b03          	addw	sp,#3
 172                     ; 87 				deviceID_ctr=(CR95HF_response.data_length-CR95HF_IDN_ROMCRC_CURSOR);
 174  003a b601          	ld	a,_CR95HF_response+1
 175  003c a002          	sub	a,#2
 176  003e 6b03          	ld	(OFST+0,sp),a
 177                     ; 88 				LCD_SetCursorPos(LCD_LINE2, LCD_STARTLEFTCORNER);//LCD CUSOR IS SET AT LINE LEFT CORNER
 179  0040 ae9000        	ldw	x,#36864
 180  0043 cd0000        	call	_LCD_SetCursorPos
 183  0046 200f          	jra	L301
 184  0048               L101:
 185                     ; 92 					LCD_PrintChar(CR95HF_response.data[deviceID_char++]);
 187  0048 7b02          	ld	a,(OFST-1,sp)
 188  004a 97            	ld	xl,a
 189  004b 0c02          	inc	(OFST-1,sp)
 190  004d 9f            	ld	a,xl
 191  004e 5f            	clrw	x
 192  004f 97            	ld	xl,a
 193  0050 e602          	ld	a,(_CR95HF_response+2,x)
 194  0052 cd0000        	call	_LCD_PrintChar
 196                     ; 93 					deviceID_ctr--;
 198  0055 0a03          	dec	(OFST+0,sp)
 199  0057               L301:
 200                     ; 89 				while(deviceID_ctr)
 202  0057 0d03          	tnz	(OFST+0,sp)
 203  0059 26ed          	jrne	L101
 204                     ; 95 				Wait_Display(WAIT_1s);// Wait for 1 sec and refresh the LDC screen
 206  005b ae03e8        	ldw	x,#1000
 207  005e cd0308        	call	_Wait_Display
 209                     ; 97 			break;
 211  0061 aca001a0      	jpf	L57
 212  0065               L51:
 213                     ; 99 			case JOYSTICK_DOWNSTATE: // down
 213                     ; 100 				// Toggle the RF field 
 213                     ; 101 				LED_Switch_off(BLUE_LED);// switch off Blue LED
 215  0065 a608          	ld	a,#8
 216  0067 cd0000        	call	_LED_Switch_off
 218                     ; 104 				if(Protocol_Settings.protocol_in_use!=CR95HF_PROT_SEL_FIELDOFF)
 220  006a 3d00          	tnz	_Protocol_Settings
 221  006c 2726          	jreq	L701
 222                     ; 107 					status=CR95HF_FieldOff(&Protocol_Settings);
 224  006e ae0000        	ldw	x,#_Protocol_Settings
 225  0071 cd0000        	call	_CR95HF_FieldOff
 227                     ; 108 					LED_Switch_on(YELLOW_LED);// activate  yellow LED
 229  0074 a602          	ld	a,#2
 230  0076 cd0000        	call	_LED_Switch_on
 232                     ; 110 					LCD_Clear();
 234  0079 cd0000        	call	_LCD_Clear
 236                     ; 111 					LCD_PrintString(LCD_LINE1,ENABLE,DISABLE," Field OFF .");
 238  007c ae00d9        	ldw	x,#L111
 239  007f 89            	pushw	x
 240  0080 4b00          	push	#0
 241  0082 ae8001        	ldw	x,#32769
 242  0085 cd0000        	call	_LCD_PrintString
 244  0088 5b03          	addw	sp,#3
 245                     ; 112 					Wait_Display(WAIT_1s);
 247  008a ae03e8        	ldw	x,#1000
 248  008d cd0308        	call	_Wait_Display
 251  0090 aca001a0      	jpf	L57
 252  0094               L701:
 253                     ; 118 					Select_Protocol_ISO15693();
 255  0094 cd02e7        	call	_Select_Protocol_ISO15693
 257                     ; 120 					LCD_Clear();
 259  0097 cd0000        	call	_LCD_Clear
 261                     ; 121 					LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"  Field ON .)))");
 263  009a ae00c9        	ldw	x,#L511
 264  009d 89            	pushw	x
 265  009e 4b00          	push	#0
 266  00a0 ae8001        	ldw	x,#32769
 267  00a3 cd0000        	call	_LCD_PrintString
 269  00a6 5b03          	addw	sp,#3
 270                     ; 122 					Wait_Display(WAIT_1s);
 272  00a8 ae03e8        	ldw	x,#1000
 273  00ab cd0308        	call	_Wait_Display
 275                     ; 123 					LED_Switch_off(YELLOW_LED);// deactivate yellow LED
 277  00ae a602          	ld	a,#2
 278  00b0 cd0000        	call	_LED_Switch_off
 280  00b3 aca001a0      	jpf	L57
 281  00b7               L71:
 282                     ; 129 			case JOYSTICK_LEFTSTATE:// left
 282                     ; 130 			// A calibration of the tag detector is made in order to use the Idle mode and exit it when a tag is presented in the field.
 282                     ; 131 			LED_Switch_off(BLUE_LED); // field is turned off by the procedure turn off the blue LED
 284  00b7 a608          	ld	a,#8
 285  00b9 cd0000        	call	_LED_Switch_off
 287                     ; 133 			Config_tag_detection();
 289  00bc cd01b8        	call	_Config_tag_detection
 291                     ; 136 			break;
 293  00bf aca001a0      	jpf	L57
 294  00c3               L12:
 295                     ; 138 			case JOYSTICK_RIGHTSTATE:// right low power mode
 295                     ; 139 					
 295                     ; 140 			/* The purpose of this mode is to lower down the consumption of the CR95HF and the STM8L. However, if a tag is presented into the operating volume, the CR95HF should be able to detect it and the system should wake up and enter in communication with the contactless tag*/ 
 295                     ; 141 			
 295                     ; 142 			LED_Switch_off(ALL_LED);// consumpt 
 297  00c3 a60f          	ld	a,#15
 298  00c5 cd0000        	call	_LED_Switch_off
 300                     ; 144 			LCD_Clear();
 302  00c8 cd0000        	call	_LCD_Clear
 304                     ; 145 			LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"Turn into Idle");
 306  00cb ae00ba        	ldw	x,#L711
 307  00ce 89            	pushw	x
 308  00cf 4b00          	push	#0
 309  00d1 ae8001        	ldw	x,#32769
 310  00d4 cd0000        	call	_LCD_PrintString
 312  00d7 5b03          	addw	sp,#3
 313                     ; 146 			delay_ms(WAIT_500ms);
 315  00d9 ae01f4        	ldw	x,#500
 316  00dc cd0000        	call	_delay_ms
 318                     ; 147 			LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"Search for tag");
 320  00df ae00ab        	ldw	x,#L121
 321  00e2 89            	pushw	x
 322  00e3 4b00          	push	#0
 323  00e5 ae8001        	ldw	x,#32769
 324  00e8 cd0000        	call	_LCD_PrintString
 326  00eb 5b03          	addw	sp,#3
 327                     ; 148 			delay_ms(WAIT_1s);
 329  00ed ae03e8        	ldw	x,#1000
 330  00f0 cd0000        	call	_delay_ms
 332                     ; 150 			CR95HF_FieldOff(&Protocol_Settings);
 334  00f3 ae0000        	ldw	x,#_Protocol_Settings
 335  00f6 cd0000        	call	_CR95HF_FieldOff
 337                     ; 264 			LCD_PrintString(LCD_LINE2,ENABLE,DISABLE," Wait Mode #3");
 339  00f9 ae009d        	ldw	x,#L321
 340  00fc 89            	pushw	x
 341  00fd 4b00          	push	#0
 342  00ff ae9001        	ldw	x,#36865
 343  0102 cd0000        	call	_LCD_PrintString
 345  0105 5b03          	addw	sp,#3
 346  0107               L521:
 347                     ; 268 				GPIO_Init(SPI_IRQ_IN_GPIO_PORT,SPI_IRQ_IN_GPIO_PIN ,GPIO_Mode_In_FL_IT );
 349  0107 4b20          	push	#32
 350  0109 4b04          	push	#4
 351  010b ae500a        	ldw	x,#20490
 352  010e cd0000        	call	_GPIO_Init
 354  0111 85            	popw	x
 355                     ; 270 				EXTI_SetPinSensitivity(EXTI_Pin_2,EXTI_Trigger_Falling);  
 357  0112 ae0402        	ldw	x,#1026
 358  0115 cd0000        	call	_EXTI_SetPinSensitivity
 360                     ; 288 				CR95HF_TagDetecting (	CR95HF_IDLE_WAKEUP_IRQIN | CR95HF_IDLE_WAKEUP_TIMER,
 360                     ; 289 															IDLE_TEST_WUP_256ms,
 360                     ; 290 															CR95HF_IDLE_LFOFREQ_32K ,
 360                     ; 291 															Idle_Config.dacDataL,
 360                     ; 292 															Idle_Config.dacDataH,
 360                     ; 293 															IDLE_TEST_MAXSLEEP_20_TRIALS,
 360                     ; 294 															&Idle_Config);
 362  0118 ae0000        	ldw	x,#_Idle_Config
 363  011b 89            	pushw	x
 364  011c 4b13          	push	#19
 365  011e 3b0002        	push	_Idle_Config+2
 366  0121 3b0001        	push	_Idle_Config+1
 367  0124 4b00          	push	#0
 368  0126 ae0920        	ldw	x,#2336
 369  0129 cd0000        	call	_CR95HF_TagDetecting
 371  012c 5b06          	addw	sp,#6
 372                     ; 297 				halt();
 375  012e 8e            halt
 377                     ; 299 				LED_Switch_on(YELLOW_LED);// activate yellow LED to make a blink
 380  012f a602          	ld	a,#2
 381  0131 cd0000        	call	_LED_Switch_on
 383                     ; 301 				GPIO_Init(SPI_IRQ_IN_GPIO_PORT,SPI_IRQ_IN_GPIO_PIN ,GPIO_Mode_In_PU_No_IT);
 385  0134 4b40          	push	#64
 386  0136 4b04          	push	#4
 387  0138 ae500a        	ldw	x,#20490
 388  013b cd0000        	call	_GPIO_Init
 390  013e 85            	popw	x
 391                     ; 302 				EXTI_DeInit();// disable external interrupt
 393  013f cd0000        	call	_EXTI_DeInit
 395                     ; 304 				status=CR95HF_Wait_Wake_up_from_Idle(&CR95HF_response,&Idle_Config,CR95HF_NUMBER_OF_WAITING_PERIOD);
 397  0142 4b01          	push	#1
 398  0144 ae0000        	ldw	x,#_Idle_Config
 399  0147 89            	pushw	x
 400  0148 ae0000        	ldw	x,#_CR95HF_response
 401  014b cd0000        	call	_CR95HF_Wait_Wake_up_from_Idle
 403  014e 5b03          	addw	sp,#3
 404                     ; 305 				status=CR95HF_Echo();// try to communicate
 406  0150 cd0000        	call	_CR95HF_Echo
 408  0153 6b02          	ld	(OFST-1,sp),a
 409                     ; 307 				status_Tag_seen=CR95HF_Is_Tag_Detected_Wake_up_Condition(Idle_Config.last_reason_of_wakeup);
 411  0155 b603          	ld	a,_Idle_Config+3
 412  0157 cd0000        	call	_CR95HF_Is_Tag_Detected_Wake_up_Condition
 414  015a 6b03          	ld	(OFST+0,sp),a
 415                     ; 308 				LED_Switch_off(YELLOW_LED);// switch off the yellow LED
 417  015c a602          	ld	a,#2
 418  015e cd0000        	call	_LED_Switch_off
 420                     ; 310 			while(status==CR95HF_SUCCESS_CODE && status_Tag_seen!=TRUE_CODE);
 422  0161 0d02          	tnz	(OFST-1,sp)
 423  0163 2604          	jrne	L331
 425  0165 0d03          	tnz	(OFST+0,sp)
 426  0167 269e          	jrne	L521
 427  0169               L331:
 428                     ; 315 			if(status_Tag_seen==TRUE_CODE) // CR95HF woke up because of tag detection
 430  0169 0d03          	tnz	(OFST+0,sp)
 431  016b 262d          	jrne	L531
 432                     ; 317 				CR95HF_Echo();// Check the communication
 434  016d cd0000        	call	_CR95HF_Echo
 436                     ; 318 				LCD_Clear();// Refresh Display
 438  0170 cd0000        	call	_LCD_Clear
 440                     ; 319 				LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"  Tag seen ");
 442  0173 ae0091        	ldw	x,#L731
 443  0176 89            	pushw	x
 444  0177 4b00          	push	#0
 445  0179 ae8001        	ldw	x,#32769
 446  017c cd0000        	call	_LCD_PrintString
 448  017f 5b03          	addw	sp,#3
 449                     ; 321 				GPIO_Init(SPI_IRQ_IN_GPIO_PORT,SPI_IRQ_IN_GPIO_PIN ,GPIO_Mode_In_PU_No_IT);
 451  0181 4b40          	push	#64
 452  0183 4b04          	push	#4
 453  0185 ae500a        	ldw	x,#20490
 454  0188 cd0000        	call	_GPIO_Init
 456  018b 85            	popw	x
 457                     ; 322 				EXTI_DeInit();
 459  018c cd0000        	call	_EXTI_DeInit
 461                     ; 323 				Wait_Display(WAIT_500ms);
 463  018f ae01f4        	ldw	x,#500
 464  0192 cd0308        	call	_Wait_Display
 466                     ; 324 				Select_Protocol_ISO15693();
 468  0195 cd02e7        	call	_Select_Protocol_ISO15693
 471  0198 2006          	jra	L57
 472  019a               L531:
 473                     ; 328 				Wait_Display(WAIT_500ms);
 475  019a ae01f4        	ldw	x,#500
 476  019d cd0308        	call	_Wait_Display
 478  01a0               L32:
 479                     ; 335 			case JOYSTICK_SELSTATE:// sel
 479                     ; 336 				// Add further action here
 479                     ; 337 	
 479                     ; 338 			break;
 481  01a0               L52:
 482                     ; 340 			default : break;
 484  01a0               L57:
 485                     ; 342 	if(value==JOYSTICK_NO_BUTTON_PRESSED)
 487  01a0 7b01          	ld	a,(OFST-2,sp)
 488  01a2 a11f          	cp	a,#31
 489  01a4 2606          	jrne	L341
 490                     ; 344 		delay_ms(WAIT_10ms);
 492  01a6 ae000a        	ldw	x,#10
 493  01a9 cd0000        	call	_delay_ms
 495  01ac               L341:
 496                     ; 348 }
 499  01ac 5b03          	addw	sp,#3
 500  01ae 81            	ret
 524                     ; 355 	static u8 GetJoystickState (void)
 524                     ; 356 {
 525                     	switch	.text
 526  01af               L11_GetJoystickState:
 530                     ; 358 	return ((GPIO_ReadInputData(JOYSTICK_GPIO_PORT)& JOYSTICK_NO_BUTTON_PRESSED)); 
 532  01af ae501e        	ldw	x,#20510
 533  01b2 cd0000        	call	_GPIO_ReadInputData
 535  01b5 a41f          	and	a,#31
 538  01b7 81            	ret
 596                     ; 367 void Config_tag_detection(void)
 596                     ; 368 {
 597                     	switch	.text
 598  01b8               _Config_tag_detection:
 600  01b8 89            	pushw	x
 601       00000002      OFST:	set	2
 604                     ; 369 	u8 status=CR95HF_ERROR_CODE;
 606                     ; 370 	u8 time_counter=6;// .
 608  01b9 a606          	ld	a,#6
 609  01bb 6b02          	ld	(OFST+0,sp),a
 610                     ; 371 	LED_Switch_on(ALL_LED);// activate  all LED
 612  01bd a60f          	ld	a,#15
 613  01bf cd0000        	call	_LED_Switch_on
 615                     ; 372 	LCD_PrintString(LCD_LINE1,ENABLE,DISABLE," TAG Detection");
 617  01c2 ae0082        	ldw	x,#L771
 618  01c5 89            	pushw	x
 619  01c6 4b00          	push	#0
 620  01c8 ae8001        	ldw	x,#32769
 621  01cb cd0000        	call	_LCD_PrintString
 623  01ce 5b03          	addw	sp,#3
 624                     ; 373 	LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"  Calibration");
 626  01d0 ae0074        	ldw	x,#L102
 627  01d3 89            	pushw	x
 628  01d4 4b00          	push	#0
 629  01d6 ae9001        	ldw	x,#36865
 630  01d9 cd0000        	call	_LCD_PrintString
 632  01dc 5b03          	addw	sp,#3
 633                     ; 374 	Wait_Display(WAIT_500ms);
 635  01de ae01f4        	ldw	x,#500
 636  01e1 cd0308        	call	_Wait_Display
 638                     ; 375 	LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"  Clear Field");
 640  01e4 ae0066        	ldw	x,#L302
 641  01e7 89            	pushw	x
 642  01e8 4b00          	push	#0
 643  01ea ae8001        	ldw	x,#32769
 644  01ed cd0000        	call	_LCD_PrintString
 646  01f0 5b03          	addw	sp,#3
 647                     ; 376 	status=CR95HF_Idle_Detector_Calibration(&Protocol_Settings, &Idle_Config);
 649  01f2 ae0000        	ldw	x,#_Idle_Config
 650  01f5 89            	pushw	x
 651  01f6 ae0000        	ldw	x,#_Protocol_Settings
 652  01f9 cd0000        	call	_CR95HF_Idle_Detector_Calibration
 654  01fc 85            	popw	x
 655  01fd 6b01          	ld	(OFST-1,sp),a
 656                     ; 377 	if(status==CR95HF_SUCCESS_CODE)
 658  01ff 0d01          	tnz	(OFST-1,sp)
 659  0201 2703          	jreq	L02
 660  0203 cc02cd        	jp	L502
 661  0206               L02:
 662                     ; 379 		LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"Calibration OK");
 664  0206 ae0057        	ldw	x,#L702
 665  0209 89            	pushw	x
 666  020a 4b00          	push	#0
 667  020c ae8001        	ldw	x,#32769
 668  020f cd0000        	call	_LCD_PrintString
 670  0212 5b03          	addw	sp,#3
 671                     ; 380 		Wait_Display(WAIT_500ms);
 673  0214 ae01f4        	ldw	x,#500
 674  0217 cd0308        	call	_Wait_Display
 676                     ; 381 		LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"##   CHECK   ##");
 678  021a ae0047        	ldw	x,#L112
 679  021d 89            	pushw	x
 680  021e 4b00          	push	#0
 681  0220 ae8001        	ldw	x,#32769
 682  0223 cd0000        	call	_LCD_PrintString
 684  0226 5b03          	addw	sp,#3
 685                     ; 382 		LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"# Clear Field #");
 687  0228 ae0037        	ldw	x,#L312
 688  022b 89            	pushw	x
 689  022c 4b00          	push	#0
 690  022e ae9001        	ldw	x,#36865
 691  0231 cd0000        	call	_LCD_PrintString
 693  0234 5b03          	addw	sp,#3
 694                     ; 383 		delay_ms(WAIT_1s);
 696  0236 ae03e8        	ldw	x,#1000
 697  0239 cd0000        	call	_delay_ms
 699                     ; 384 		LCD_PrintString(LCD_LINE1,ENABLE,DISABLE," Test clr field");
 701  023c ae0027        	ldw	x,#L512
 702  023f 89            	pushw	x
 703  0240 4b00          	push	#0
 704  0242 ae8001        	ldw	x,#32769
 705  0245 cd0000        	call	_LCD_PrintString
 707  0248 5b03          	addw	sp,#3
 708                     ; 386 		LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"    ......  ");
 710  024a ae001a        	ldw	x,#L712
 711  024d 89            	pushw	x
 712  024e 4b00          	push	#0
 713  0250 ae9001        	ldw	x,#36865
 714  0253 cd0000        	call	_LCD_PrintString
 716  0256 5b03          	addw	sp,#3
 717                     ; 387 		LCD_SetCursorPos(LCD_LINE2, (LCD_STARTLEFTCORNER+2));
 719  0258 ae9002        	ldw	x,#36866
 720  025b cd0000        	call	_LCD_SetCursorPos
 722                     ; 391 		CR95HF_Idle(	CR95HF_IDLE_WAKEUP_TIMER | CR95HF_IDLE_WAKEUP_TAG_DETECTION,
 722                     ; 392 												CR95HF_DETECTOR_CALIBRATION_EnterCtrl_L,
 722                     ; 393 												CR95HF_DETECTOR_CALIBRATION_EnterCtrl_H,
 722                     ; 394 												CR95HF_DETECTOR_CALIBRATION_WUCtrl_L,
 722                     ; 395 												CR95HF_DETECTOR_CALIBRATION_WUCtrl_H,
 722                     ; 396 												CR95HF_IDLE_LEAVE_CTRL_L,
 722                     ; 397 												CR95HF_IDLE_LEAVE_CTRL_H ,
 722                     ; 398 												IDLE_TEST_WUP_160ms,
 722                     ; 399 												CR95HF_IDLE_OSC_START,
 722                     ; 400 												CR95HF_IDLE_DAC_START,
 722                     ; 401 												Idle_Config.dacDataL,
 722                     ; 402 												Idle_Config.dacDataH,
 722                     ; 403 												CR95HF_IDLE_SWING_CNT,
 722                     ; 404 												IDLE_TEST_MAXSLEEP_32_TRIALS,
 722                     ; 405 												&Idle_Config);
 724  025e ae0000        	ldw	x,#_Idle_Config
 725  0261 89            	pushw	x
 726  0262 4b1f          	push	#31
 727  0264 4b3f          	push	#63
 728  0266 3b0002        	push	_Idle_Config+2
 729  0269 3b0001        	push	_Idle_Config+1
 730  026c 4b60          	push	#96
 731  026e 4b60          	push	#96
 732  0270 4b14          	push	#20
 733  0272 4b00          	push	#0
 734  0274 4b18          	push	#24
 735  0276 4b01          	push	#1
 736  0278 4b79          	push	#121
 737  027a 4b00          	push	#0
 738  027c ae0321        	ldw	x,#801
 739  027f cd0000        	call	_CR95HF_Idle
 741  0282 5b0e          	addw	sp,#14
 743  0284 200d          	jra	L322
 744  0286               L122:
 745                     ; 409 					delay_ms(WAIT_1s);
 747  0286 ae03e8        	ldw	x,#1000
 748  0289 cd0000        	call	_delay_ms
 750                     ; 410 					LCD_PrintChar(' ');// Erase each dot one by one
 752  028c a620          	ld	a,#32
 753  028e cd0000        	call	_LCD_PrintChar
 755                     ; 411 					time_counter--; // decrement remaining time
 757  0291 0a02          	dec	(OFST+0,sp)
 758  0293               L322:
 759                     ; 407 		while(time_counter!=INIT_VALUE)
 761  0293 0d02          	tnz	(OFST+0,sp)
 762  0295 26ef          	jrne	L122
 763                     ; 416 		status=CR95HF_Wait_Wake_up_from_Idle(&CR95HF_response,&Idle_Config,CR95HF_NUMBER_OF_WAITING_PERIOD);
 765  0297 4b01          	push	#1
 766  0299 ae0000        	ldw	x,#_Idle_Config
 767  029c 89            	pushw	x
 768  029d ae0000        	ldw	x,#_CR95HF_response
 769  02a0 cd0000        	call	_CR95HF_Wait_Wake_up_from_Idle
 771  02a3 5b03          	addw	sp,#3
 772                     ; 417 		if(CR95HF_Is_Timeout_Wake_up_Condition(Idle_Config.last_reason_of_wakeup)==TRUE_CODE)
 774  02a5 b603          	ld	a,_Idle_Config+3
 775  02a7 cd0000        	call	_CR95HF_Is_Timeout_Wake_up_Condition
 777  02aa 4d            	tnz	a
 778  02ab 2610          	jrne	L722
 779                     ; 419 			LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"Calibration OK");	
 781  02ad ae0057        	ldw	x,#L702
 782  02b0 89            	pushw	x
 783  02b1 4b00          	push	#0
 784  02b3 ae8001        	ldw	x,#32769
 785  02b6 cd0000        	call	_LCD_PrintString
 787  02b9 5b03          	addw	sp,#3
 789  02bb 201e          	jra	L532
 790  02bd               L722:
 791                     ; 423 			LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"Calibration ERR");
 793  02bd ae000a        	ldw	x,#L332
 794  02c0 89            	pushw	x
 795  02c1 4b00          	push	#0
 796  02c3 ae8001        	ldw	x,#32769
 797  02c6 cd0000        	call	_LCD_PrintString
 799  02c9 5b03          	addw	sp,#3
 800  02cb 200e          	jra	L532
 801  02cd               L502:
 802                     ; 426 		LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"Calibration ERR");
 804  02cd ae000a        	ldw	x,#L332
 805  02d0 89            	pushw	x
 806  02d1 4b00          	push	#0
 807  02d3 ae8001        	ldw	x,#32769
 808  02d6 cd0000        	call	_LCD_PrintString
 810  02d9 5b03          	addw	sp,#3
 811  02db               L532:
 812                     ; 428 	LED_Switch_off(ALL_LED);// deactivate  all LED
 814  02db a60f          	ld	a,#15
 815  02dd cd0000        	call	_LED_Switch_off
 817                     ; 429 	Wait_Display(WAIT_500ms);
 819  02e0 ae01f4        	ldw	x,#500
 820  02e3 ad23          	call	_Wait_Display
 822                     ; 430 }
 825  02e5 85            	popw	x
 826  02e6 81            	ret
 854                     ; 441 u8 Select_Protocol_ISO15693(void)
 854                     ; 442 {
 855                     	switch	.text
 856  02e7               _Select_Protocol_ISO15693:
 860                     ; 444 	ISO15693_ProtocolSelect_Parameters = CR95HF_ISO15693_ComputeParameterByte_ProtocolSelect
 860                     ; 445 	(CR95HF_BIT7_6_RFU,
 860                     ; 446 	CR95HF_BIT4_5_DATARATE_6KBITS,//CR95HF_BIT4_5_DATARATE_26KBITS, CR95HF_BIT4_5_DATARATE_52KBITS
 860                     ; 447 	CR95HF_BIT3_WAIT_FOR_SOF,//CR95HF_BIT3_RESPECT312_DELAY
 860                     ; 448 	CR95HF_BIT2_MODULATION_10,//CR95HF_BIT2_MODULATION_100
 860                     ; 449 	CR95HF_BIT1_SINGLE_CARRIER);//CR95HF_BIT1_DUAL_CARRIERS
 862  02e7 4b00          	push	#0
 863  02e9 4b04          	push	#4
 864  02eb 4b08          	push	#8
 865  02ed ae0020        	ldw	x,#32
 866  02f0 cd0000        	call	_CR95HF_ISO15693_ComputeParameterByte_ProtocolSelect
 868  02f3 5b03          	addw	sp,#3
 869  02f5 b700          	ld	_ISO15693_ProtocolSelect_Parameters,a
 870                     ; 451 	return CR95HF_ProtocolSelect(CR95HF_PROT_SEL_ISO15693, CR95HF_PARAMETERSLENGTH_PROT_ISO15693, & ISO15693_ProtocolSelect_Parameters, &Protocol_Settings);
 872  02f7 ae0000        	ldw	x,#_Protocol_Settings
 873  02fa 89            	pushw	x
 874  02fb ae0000        	ldw	x,#_ISO15693_ProtocolSelect_Parameters
 875  02fe 89            	pushw	x
 876  02ff ae0101        	ldw	x,#257
 877  0302 cd0000        	call	_CR95HF_ProtocolSelect
 879  0305 5b04          	addw	sp,#4
 882  0307 81            	ret
 920                     ; 461 void Wait_Display(u16 Time)
 920                     ; 462 {
 921                     	switch	.text
 922  0308               _Wait_Display:
 926                     ; 463 	delay_ms(Time);// Wait
 928  0308 cd0000        	call	_delay_ms
 930                     ; 464 	LCD_Clear(); // Clear and display logo
 932  030b cd0000        	call	_LCD_Clear
 934                     ; 465 	LCD_DisplayLogo(LCD_LOGOTYPE_LINE1_LEFT_CORNER );
 936  030e a680          	ld	a,#128
 937  0310 cd0000        	call	_LCD_DisplayLogo
 939                     ; 466 	LCD_Print(" CR95HF  ");
 941  0313 ae0000        	ldw	x,#L562
 942  0316 cd0000        	call	_LCD_Print
 944                     ; 467 }
 947  0319 81            	ret
 960                     	xref.b	_ISO15693_ProtocolSelect_Parameters
 961                     	xref.b	_CR95HF_response
 962                     	xref.b	_Protocol_Settings
 963                     	xref.b	_Idle_Config
 964                     	xdef	_Wait_Display
 965                     	xdef	_Select_Protocol_ISO15693
 966                     	xdef	_Config_tag_detection
 967                     	xdef	_RunUserApplication
 968                     	xref	_LED_Switch_off
 969                     	xref	_LED_Switch_on
 970                     	xref	_CR95HF_Wait_Wake_up_from_Idle
 971                     	xref	_CR95HF_Idle_Detector_Calibration
 972                     	xref	_CR95HF_Is_Timeout_Wake_up_Condition
 973                     	xref	_CR95HF_Is_Tag_Detected_Wake_up_Condition
 974                     	xref	_CR95HF_ISO15693_ComputeParameterByte_ProtocolSelect
 975                     	xref	_CR95HF_TagDetecting
 976                     	xref	_CR95HF_FieldOff
 977                     	xref	_CR95HF_Idle
 978                     	xref	_CR95HF_ProtocolSelect
 979                     	xref	_CR95HF_Echo
 980                     	xref	_CR95HF_IDN
 981                     	xref	_delay_ms
 982                     	xref	_LCD_Print
 983                     	xref	_LCD_DisplayLogo
 984                     	xref	_LCD_PrintString
 985                     	xref	_LCD_PrintChar
 986                     	xref	_LCD_SetCursorPos
 987                     	xref	_LCD_Clear
 988                     	xref	_GPIO_ReadInputData
 989                     	xref	_GPIO_Init
 990                     	xref	_EXTI_SetPinSensitivity
 991                     	xref	_EXTI_DeInit
 992                     .const:	section	.text
 993  0000               L562:
 994  0000 204352393548  	dc.b	" CR95HF  ",0
 995  000a               L332:
 996  000a 43616c696272  	dc.b	"Calibration ERR",0
 997  001a               L712:
 998  001a 202020202e2e  	dc.b	"    ......  ",0
 999  0027               L512:
1000  0027 205465737420  	dc.b	" Test clr field",0
1001  0037               L312:
1002  0037 2320436c6561  	dc.b	"# Clear Field #",0
1003  0047               L112:
1004  0047 232320202043  	dc.b	"##   CHECK   ##",0
1005  0057               L702:
1006  0057 43616c696272  	dc.b	"Calibration OK",0
1007  0066               L302:
1008  0066 2020436c6561  	dc.b	"  Clear Field",0
1009  0074               L102:
1010  0074 202043616c69  	dc.b	"  Calibration",0
1011  0082               L771:
1012  0082 205441472044  	dc.b	" TAG Detection",0
1013  0091               L731:
1014  0091 202054616720  	dc.b	"  Tag seen ",0
1015  009d               L321:
1016  009d 205761697420  	dc.b	" Wait Mode #3",0
1017  00ab               L121:
1018  00ab 536561726368  	dc.b	"Search for tag",0
1019  00ba               L711:
1020  00ba 5475726e2069  	dc.b	"Turn into Idle",0
1021  00c9               L511:
1022  00c9 20204669656c  	dc.b	"  Field ON .)))",0
1023  00d9               L111:
1024  00d9 204669656c64  	dc.b	" Field OFF .",0
1025  00e6               L77:
1026  00e6 202044657669  	dc.b	"  Device ID :",0
1046                     	end
