   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.9.10 - 10 Feb 2011
   3                     ; Generator (Limited) V4.3.6 - 15 Feb 2011
  60                     ; 33 void CR95HF_Wait_Display(u16 time)
  60                     ; 34 {
  62                     	switch	.text
  63  0000               _CR95HF_Wait_Display:
  67                     ; 35 	delay_ms(time);// Wait time ms
  69  0000 cd0000        	call	_delay_ms
  71                     ; 36 	LCD_Clear(); // Clear the screen and display logo
  73  0003 cd0000        	call	_LCD_Clear
  75                     ; 37 	LCD_DisplayLogo(LCD_LOGOTYPE_LINE1_LEFT_CORNER);
  77  0006 a680          	ld	a,#128
  78  0008 cd0000        	call	_LCD_DisplayLogo
  80                     ; 38 	LCD_Print(" CR95HF  ");
  82  000b ae0114        	ldw	x,#L53
  83  000e cd0000        	call	_LCD_Print
  85                     ; 39 }
  88  0011 81            	ret
 192                     ; 48 u8 CR95HF_LCD_Print_Answer_IDN(const CR95HF_ResponseReceiving* Response)
 192                     ; 49 {
 193                     	switch	.text
 194  0012               _CR95HF_LCD_Print_Answer_IDN:
 196  0012 89            	pushw	x
 197  0013 89            	pushw	x
 198       00000002      OFST:	set	2
 201                     ; 50 	u8 status=CR95HF_DISPLAY_UNHANDLED;// to check if  display is done
 203  0014 0f02          	clr	(OFST+0,sp)
 204                     ; 52 	u8 i=INIT_VALUE; // counter  into the response
 206  0016 0f01          	clr	(OFST-1,sp)
 207                     ; 54 	if( CR95HF_Display_Enabled== CR95HF_DISPLAY_ALL) 
 209  0018 3d00          	tnz	_CR95HF_Display_Enabled
 210  001a 2703          	jreq	L01
 211  001c cc00ad        	jp	L701
 212  001f               L01:
 213                     ; 56 		status=CR95HF_Display_answer_commandStatus(Response->resp_code, CR95HF_CMD_IDN);
 215  001f ae0001        	ldw	x,#1
 216  0022 1603          	ldw	y,(OFST+1,sp)
 217  0024 90f6          	ld	a,(y)
 218  0026 95            	ld	xh,a
 219  0027 cd0491        	call	_CR95HF_Display_answer_commandStatus
 221  002a 6b02          	ld	(OFST+0,sp),a
 222                     ; 57 		if(Response->resp_code == CR95HF_IDN_SUCCESS_CODE)
 224  002c 1e03          	ldw	x,(OFST+1,sp)
 225  002e 7d            	tnz	(x)
 226  002f 2703          	jreq	L21
 227  0031 cc00bf        	jp	L521
 228  0034               L21:
 229                     ; 60 			LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"  Device ID :");
 231  0034 ae0106        	ldw	x,#L311
 232  0037 89            	pushw	x
 233  0038 4b00          	push	#0
 234  003a ae8001        	ldw	x,#32769
 235  003d cd0000        	call	_LCD_PrintString
 237  0040 5b03          	addw	sp,#3
 238                     ; 62 			deviceID_ctr=(Response->data_length-CR95HF_IDN_ROMCRC_CURSOR);
 240  0042 1e03          	ldw	x,(OFST+1,sp)
 241  0044 e601          	ld	a,(1,x)
 242  0046 a002          	sub	a,#2
 243  0048 6b02          	ld	(OFST+0,sp),a
 244                     ; 63 			LCD_SetCursorPos(LCD_LINE2, LCD_STARTLEFTCORNER);//LCD CUSOR IS SET AT LINE LEFT CORNER
 246  004a ae9000        	ldw	x,#36864
 247  004d cd0000        	call	_LCD_SetCursorPos
 250  0050 2012          	jra	L711
 251  0052               L511:
 252                     ; 67 				LCD_PrintChar(Response->data[i++]);// i is the string counter
 254  0052 7b01          	ld	a,(OFST-1,sp)
 255  0054 97            	ld	xl,a
 256  0055 0c01          	inc	(OFST-1,sp)
 257  0057 9f            	ld	a,xl
 258  0058 5f            	clrw	x
 259  0059 97            	ld	xl,a
 260  005a 72fb03        	addw	x,(OFST+1,sp)
 261  005d e602          	ld	a,(2,x)
 262  005f cd0000        	call	_LCD_PrintChar
 264                     ; 68 				deviceID_ctr--;
 266  0062 0a02          	dec	(OFST+0,sp)
 267  0064               L711:
 268                     ; 64 			while(deviceID_ctr)
 270  0064 0d02          	tnz	(OFST+0,sp)
 271  0066 26ea          	jrne	L511
 272                     ; 70 			CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec 
 274  0068 ae03e8        	ldw	x,#1000
 275  006b ad93          	call	_CR95HF_Wait_Display
 277                     ; 71 			LCD_SetCursorPos(LCD_LINE1, LCD_STARTLEFTCORNER);
 279  006d ae8000        	ldw	x,#32768
 280  0070 cd0000        	call	_LCD_SetCursorPos
 282                     ; 73 			LCD_PrintString(LCD_LINE1,DISABLE,ENABLE,"CRC ROM: ");
 284  0073 ae00fc        	ldw	x,#L321
 285  0076 89            	pushw	x
 286  0077 4b01          	push	#1
 287  0079 ae8000        	ldw	x,#32768
 288  007c cd0000        	call	_LCD_PrintString
 290  007f 5b03          	addw	sp,#3
 291                     ; 74 			LCD_PrintHex2(Response->data[i++]);// i is already set at the right location in the data field thanks to previos incrementation
 293  0081 7b01          	ld	a,(OFST-1,sp)
 294  0083 97            	ld	xl,a
 295  0084 0c01          	inc	(OFST-1,sp)
 296  0086 9f            	ld	a,xl
 297  0087 5f            	clrw	x
 298  0088 97            	ld	xl,a
 299  0089 72fb03        	addw	x,(OFST+1,sp)
 300  008c e602          	ld	a,(2,x)
 301  008e cd0000        	call	_LCD_PrintHex2
 303                     ; 75 			LCD_PrintHex2(Response->data[i++]);
 305  0091 7b01          	ld	a,(OFST-1,sp)
 306  0093 97            	ld	xl,a
 307  0094 0c01          	inc	(OFST-1,sp)
 308  0096 9f            	ld	a,xl
 309  0097 5f            	clrw	x
 310  0098 97            	ld	xl,a
 311  0099 72fb03        	addw	x,(OFST+1,sp)
 312  009c e602          	ld	a,(2,x)
 313  009e cd0000        	call	_LCD_PrintHex2
 315                     ; 76 			status=CR95HF_DISPLAY_HANDLED;
 317  00a1 a601          	ld	a,#1
 318  00a3 6b02          	ld	(OFST+0,sp),a
 319                     ; 77 			CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec 
 321  00a5 ae03e8        	ldw	x,#1000
 322  00a8 cd0000        	call	_CR95HF_Wait_Display
 324  00ab 2012          	jra	L521
 325  00ad               L701:
 326                     ; 83 		if(Response->resp_code!=CR95HF_PROTOCOL_SUCCESS_CODE)
 328  00ad 1e03          	ldw	x,(OFST+1,sp)
 329  00af 7d            	tnz	(x)
 330  00b0 270d          	jreq	L521
 331                     ; 85 			status=CR95HF_Display_error_commandStatus(Response->resp_code,CR95HF_CMD_IDN);// Display only error
 333  00b2 ae0001        	ldw	x,#1
 334  00b5 1603          	ldw	y,(OFST+1,sp)
 335  00b7 90f6          	ld	a,(y)
 336  00b9 95            	ld	xh,a
 337  00ba cd04dc        	call	_CR95HF_Display_error_commandStatus
 339  00bd 6b02          	ld	(OFST+0,sp),a
 340  00bf               L521:
 341                     ; 88 	return status;// return if any display was done
 343  00bf 7b02          	ld	a,(OFST+0,sp)
 346  00c1 5b04          	addw	sp,#4
 347  00c3 81            	ret
 441                     ; 99 u8 CR95HF_LCD_Print_Answer_Protocol_Select(const u8 Response_Resp_code,const CR95HF_Protocol_Config* Protocol_Settings)
 441                     ; 100 {
 442                     	switch	.text
 443  00c4               _CR95HF_LCD_Print_Answer_Protocol_Select:
 445  00c4 88            	push	a
 446  00c5 88            	push	a
 447       00000001      OFST:	set	1
 450                     ; 101 	u8 status=CR95HF_DISPLAY_UNHANDLED;// to check if  display is done
 452  00c6 0f01          	clr	(OFST+0,sp)
 453                     ; 104 	if( CR95HF_Display_Enabled== CR95HF_DISPLAY_ALL) 
 455  00c8 3d00          	tnz	_CR95HF_Display_Enabled
 456  00ca 2703          	jreq	L61
 457  00cc cc0162        	jp	L571
 458  00cf               L61:
 459                     ; 106 		status=CR95HF_Display_answer_commandStatus(Response_Resp_code, CR95HF_CMD_PROT_SEL);
 461  00cf ae0002        	ldw	x,#2
 462  00d2 95            	ld	xh,a
 463  00d3 cd0491        	call	_CR95HF_Display_answer_commandStatus
 465  00d6 6b01          	ld	(OFST+0,sp),a
 466                     ; 107 		if(Response_Resp_code==CR95HF_SUCCESS_CODE)
 468  00d8 0d02          	tnz	(OFST+1,sp)
 469  00da 2703          	jreq	L02
 470  00dc cc0171        	jp	L722
 471  00df               L02:
 472                     ; 111 			LCD_SetCursorPos(LCD_LINE1, LCD_STARTLEFTCORNER);
 474  00df ae8000        	ldw	x,#32768
 475  00e2 cd0000        	call	_LCD_SetCursorPos
 477                     ; 112 			LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"   Protocol: ");
 479  00e5 ae00ee        	ldw	x,#L102
 480  00e8 89            	pushw	x
 481  00e9 4b00          	push	#0
 482  00eb ae8001        	ldw	x,#32769
 483  00ee cd0000        	call	_LCD_PrintString
 485  00f1 5b03          	addw	sp,#3
 486                     ; 114 			if(Protocol_Settings->protocol_in_use==CR95HF_PROT_SEL_FIELDOFF)
 488  00f3 1e05          	ldw	x,(OFST+4,sp)
 489  00f5 7d            	tnz	(x)
 490  00f6 260e          	jrne	L302
 491                     ; 115 				LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"   Field Off");
 493  00f8 ae00e1        	ldw	x,#L502
 494  00fb 89            	pushw	x
 495  00fc 4b00          	push	#0
 496  00fe ae9001        	ldw	x,#36865
 497  0101 cd0000        	call	_LCD_PrintString
 499  0104 5b03          	addw	sp,#3
 500  0106               L302:
 501                     ; 117 			if(Protocol_Settings->protocol_in_use==CR95HF_PROT_SEL_ISO15693)
 503  0106 1e05          	ldw	x,(OFST+4,sp)
 504  0108 f6            	ld	a,(x)
 505  0109 a101          	cp	a,#1
 506  010b 260e          	jrne	L702
 507                     ; 118 				LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"   ISO15693");
 509  010d ae00d5        	ldw	x,#L112
 510  0110 89            	pushw	x
 511  0111 4b00          	push	#0
 512  0113 ae9001        	ldw	x,#36865
 513  0116 cd0000        	call	_LCD_PrintString
 515  0119 5b03          	addw	sp,#3
 516  011b               L702:
 517                     ; 120 			if(Protocol_Settings->protocol_in_use==CR95HF_PROT_SEL_ISO14443_A)
 519  011b 1e05          	ldw	x,(OFST+4,sp)
 520  011d f6            	ld	a,(x)
 521  011e a102          	cp	a,#2
 522  0120 260e          	jrne	L312
 523                     ; 121 				LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"  ISO14443-A");
 525  0122 ae00c8        	ldw	x,#L512
 526  0125 89            	pushw	x
 527  0126 4b00          	push	#0
 528  0128 ae9001        	ldw	x,#36865
 529  012b cd0000        	call	_LCD_PrintString
 531  012e 5b03          	addw	sp,#3
 532  0130               L312:
 533                     ; 123 			if(Protocol_Settings->protocol_in_use==CR95HF_PROT_SEL_ISO14443_B)
 535  0130 1e05          	ldw	x,(OFST+4,sp)
 536  0132 f6            	ld	a,(x)
 537  0133 a103          	cp	a,#3
 538  0135 260e          	jrne	L712
 539                     ; 124 				LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"  ISO14443-B");
 541  0137 ae00bb        	ldw	x,#L122
 542  013a 89            	pushw	x
 543  013b 4b00          	push	#0
 544  013d ae9001        	ldw	x,#36865
 545  0140 cd0000        	call	_LCD_PrintString
 547  0143 5b03          	addw	sp,#3
 548  0145               L712:
 549                     ; 126 			if(Protocol_Settings->protocol_in_use==CR95HF_PROT_SEL_FELICA)
 551  0145 1e05          	ldw	x,(OFST+4,sp)
 552  0147 f6            	ld	a,(x)
 553  0148 a104          	cp	a,#4
 554  014a 260e          	jrne	L322
 555                     ; 127 				LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"    FELICA");
 557  014c ae00b0        	ldw	x,#L522
 558  014f 89            	pushw	x
 559  0150 4b00          	push	#0
 560  0152 ae9001        	ldw	x,#36865
 561  0155 cd0000        	call	_LCD_PrintString
 563  0158 5b03          	addw	sp,#3
 564  015a               L322:
 565                     ; 129 			CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec
 567  015a ae03e8        	ldw	x,#1000
 568  015d cd0000        	call	_CR95HF_Wait_Display
 570  0160 200f          	jra	L722
 571  0162               L571:
 572                     ; 135 		if(Response_Resp_code!=CR95HF_PROTOCOL_SUCCESS_CODE)
 574  0162 0d02          	tnz	(OFST+1,sp)
 575  0164 270b          	jreq	L722
 576                     ; 137 			status=CR95HF_Display_error_commandStatus(Response_Resp_code,CR95HF_CMD_PROT_SEL);// Display only error
 578  0166 ae0002        	ldw	x,#2
 579  0169 7b02          	ld	a,(OFST+1,sp)
 580  016b 95            	ld	xh,a
 581  016c cd04dc        	call	_CR95HF_Display_error_commandStatus
 583  016f 6b01          	ld	(OFST+0,sp),a
 584  0171               L722:
 585                     ; 140 	return status;// return if any display was done
 587  0171 7b01          	ld	a,(OFST+0,sp)
 590  0173 85            	popw	x
 591  0174 81            	ret
 638                     ; 152 u8 CR95HF_LCD_Print_Answer_Send_Recv(const u8 Response_resp_code)
 638                     ; 153 {
 639                     	switch	.text
 640  0175               _CR95HF_LCD_Print_Answer_Send_Recv:
 642  0175 88            	push	a
 643  0176 88            	push	a
 644       00000001      OFST:	set	1
 647                     ; 154 	u8 status=CR95HF_DISPLAY_UNHANDLED;// to check if  display is done
 649  0177 0f01          	clr	(OFST+0,sp)
 650                     ; 158 	if( CR95HF_Display_Enabled== CR95HF_DISPLAY_ALL) 
 652  0179 3d00          	tnz	_CR95HF_Display_Enabled
 653  017b 260b          	jrne	L552
 654                     ; 160 		status=CR95HF_Display_answer_commandStatus(Response_resp_code, CR95HF_CMD_SEND_REC);
 656  017d ae0004        	ldw	x,#4
 657  0180 95            	ld	xh,a
 658  0181 cd0491        	call	_CR95HF_Display_answer_commandStatus
 660  0184 6b01          	ld	(OFST+0,sp),a
 662  0186 202e          	jra	L752
 663  0188               L552:
 664                     ; 165 		if(Response_resp_code!=CR95HF_SUCCESS_CODE)
 666  0188 0d02          	tnz	(OFST+1,sp)
 667  018a 272a          	jreq	L752
 668                     ; 168 			if(CR95HF_Display_Enabled==CR95HF_DISPLAY_ONLY_ERROR_EXCEPT_EXPECTED_TIMEOUT)
 670  018c b600          	ld	a,_CR95HF_Display_Enabled
 671  018e a102          	cp	a,#2
 672  0190 2619          	jrne	L362
 673                     ; 171 				if ((Response_resp_code!=CR95HF_ERROR_NOTAG_OR_TIMEOUT )
 673                     ; 172 				&& (Response_resp_code!=CR95HF_ERROR_INVALID_SOF))
 675  0192 7b02          	ld	a,(OFST+1,sp)
 676  0194 a187          	cp	a,#135
 677  0196 271e          	jreq	L752
 679  0198 7b02          	ld	a,(OFST+1,sp)
 680  019a a188          	cp	a,#136
 681  019c 2718          	jreq	L752
 682                     ; 174 					status=CR95HF_Display_error_commandStatus(Response_resp_code,CR95HF_CMD_SEND_REC);
 684  019e ae0004        	ldw	x,#4
 685  01a1 7b02          	ld	a,(OFST+1,sp)
 686  01a3 95            	ld	xh,a
 687  01a4 cd04dc        	call	_CR95HF_Display_error_commandStatus
 689  01a7 6b01          	ld	(OFST+0,sp),a
 690  01a9 200b          	jra	L752
 691  01ab               L362:
 692                     ; 179 				status=CR95HF_Display_error_commandStatus(Response_resp_code,CR95HF_CMD_SEND_REC);
 694  01ab ae0004        	ldw	x,#4
 695  01ae 7b02          	ld	a,(OFST+1,sp)
 696  01b0 95            	ld	xh,a
 697  01b1 cd04dc        	call	_CR95HF_Display_error_commandStatus
 699  01b4 6b01          	ld	(OFST+0,sp),a
 700  01b6               L752:
 701                     ; 183 	return status;// return if any display was done
 703  01b6 7b01          	ld	a,(OFST+0,sp)
 706  01b8 85            	popw	x
 707  01b9 81            	ret
 769                     ; 194 u8 CR95HF_LCD_Print_Answer_Idle(const u8 Response_Resp_code,const  u8 WakeUpFlags)
 769                     ; 195 {
 770                     	switch	.text
 771  01ba               _CR95HF_LCD_Print_Answer_Idle:
 773  01ba 89            	pushw	x
 774  01bb 88            	push	a
 775       00000001      OFST:	set	1
 778                     ; 196 	u8 status=CR95HF_DISPLAY_UNHANDLED;// to check if  display is done
 780  01bc 0f01          	clr	(OFST+0,sp)
 781                     ; 199 	if( CR95HF_Display_Enabled== CR95HF_DISPLAY_ALL) 
 783  01be 3d00          	tnz	_CR95HF_Display_Enabled
 784  01c0 2703          	jreq	L62
 785  01c2 cc0279        	jp	L713
 786  01c5               L62:
 787                     ; 201 		status=CR95HF_Display_answer_commandStatus(Response_Resp_code, CR95HF_CMD_IDLE);
 789  01c5 ae0007        	ldw	x,#7
 790  01c8 7b02          	ld	a,(OFST+1,sp)
 791  01ca 95            	ld	xh,a
 792  01cb cd0491        	call	_CR95HF_Display_answer_commandStatus
 794  01ce 6b01          	ld	(OFST+0,sp),a
 795                     ; 202 		if(Response_Resp_code==CR95HF_SUCCESS_CODE)
 797  01d0 0d02          	tnz	(OFST+1,sp)
 798  01d2 2703          	jreq	L03
 799  01d4 cc0288        	jp	L743
 800  01d7               L03:
 801                     ; 206 			LCD_PrintString(LCD_LINE1,ENABLE,DISABLE," Wake-up on: ");
 803  01d7 ae00a2        	ldw	x,#L323
 804  01da 89            	pushw	x
 805  01db 4b00          	push	#0
 806  01dd ae8001        	ldw	x,#32769
 807  01e0 cd0000        	call	_LCD_PrintString
 809  01e3 5b03          	addw	sp,#3
 810                     ; 207 			CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec
 812  01e5 ae03e8        	ldw	x,#1000
 813  01e8 cd0000        	call	_CR95HF_Wait_Display
 815                     ; 209 			if(CR95HF_Is_IRQin_Interrupt_Wake_up_Condition(WakeUpFlags)==TRUE_CODE)
 817  01eb 7b03          	ld	a,(OFST+2,sp)
 818  01ed cd0000        	call	_CR95HF_Is_IRQin_Interrupt_Wake_up_Condition
 820  01f0 4d            	tnz	a
 821  01f1 2614          	jrne	L523
 822                     ; 211 				LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"   IRQ_IN");
 824  01f3 ae0098        	ldw	x,#L723
 825  01f6 89            	pushw	x
 826  01f7 4b00          	push	#0
 827  01f9 ae9001        	ldw	x,#36865
 828  01fc cd0000        	call	_LCD_PrintString
 830  01ff 5b03          	addw	sp,#3
 831                     ; 212 				CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec
 833  0201 ae03e8        	ldw	x,#1000
 834  0204 cd0000        	call	_CR95HF_Wait_Display
 836  0207               L523:
 837                     ; 216 			if(CR95HF_Is_NSS_Interrupt_Wake_up_Condition(WakeUpFlags)==TRUE_CODE)
 839  0207 7b03          	ld	a,(OFST+2,sp)
 840  0209 cd0000        	call	_CR95HF_Is_NSS_Interrupt_Wake_up_Condition
 842  020c 4d            	tnz	a
 843  020d 2614          	jrne	L133
 844                     ; 218 				LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"   NSS");
 846  020f ae0091        	ldw	x,#L333
 847  0212 89            	pushw	x
 848  0213 4b00          	push	#0
 849  0215 ae9001        	ldw	x,#36865
 850  0218 cd0000        	call	_LCD_PrintString
 852  021b 5b03          	addw	sp,#3
 853                     ; 219 				CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec
 855  021d ae03e8        	ldw	x,#1000
 856  0220 cd0000        	call	_CR95HF_Wait_Display
 858  0223               L133:
 859                     ; 222 			if(CR95HF_Is_NSS_Interrupt_Wake_up_Condition(WakeUpFlags)==TRUE_CODE)
 861  0223 7b03          	ld	a,(OFST+2,sp)
 862  0225 cd0000        	call	_CR95HF_Is_NSS_Interrupt_Wake_up_Condition
 864  0228 4d            	tnz	a
 865  0229 2614          	jrne	L533
 866                     ; 224 				LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"   NSS");
 868  022b ae0091        	ldw	x,#L333
 869  022e 89            	pushw	x
 870  022f 4b00          	push	#0
 871  0231 ae9001        	ldw	x,#36865
 872  0234 cd0000        	call	_LCD_PrintString
 874  0237 5b03          	addw	sp,#3
 875                     ; 225 				CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec
 877  0239 ae03e8        	ldw	x,#1000
 878  023c cd0000        	call	_CR95HF_Wait_Display
 880  023f               L533:
 881                     ; 228 			if(CR95HF_Is_Tag_Detected_Wake_up_Condition(WakeUpFlags)==TRUE_CODE)
 883  023f 7b03          	ld	a,(OFST+2,sp)
 884  0241 cd0000        	call	_CR95HF_Is_Tag_Detected_Wake_up_Condition
 886  0244 4d            	tnz	a
 887  0245 2614          	jrne	L733
 888                     ; 230 				LCD_PrintString(LCD_LINE2,ENABLE,DISABLE," TAG DETECTED");
 890  0247 ae0083        	ldw	x,#L143
 891  024a 89            	pushw	x
 892  024b 4b00          	push	#0
 893  024d ae9001        	ldw	x,#36865
 894  0250 cd0000        	call	_LCD_PrintString
 896  0253 5b03          	addw	sp,#3
 897                     ; 231 				CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec
 899  0255 ae03e8        	ldw	x,#1000
 900  0258 cd0000        	call	_CR95HF_Wait_Display
 902  025b               L733:
 903                     ; 234 			if(CR95HF_Is_Timeout_Wake_up_Condition(WakeUpFlags)==TRUE_CODE)
 905  025b 7b03          	ld	a,(OFST+2,sp)
 906  025d cd0000        	call	_CR95HF_Is_Timeout_Wake_up_Condition
 908  0260 4d            	tnz	a
 909  0261 2625          	jrne	L743
 910                     ; 236 				LCD_PrintString(LCD_LINE2,ENABLE,DISABLE,"   TIME OUT");
 912  0263 ae0077        	ldw	x,#L543
 913  0266 89            	pushw	x
 914  0267 4b00          	push	#0
 915  0269 ae9001        	ldw	x,#36865
 916  026c cd0000        	call	_LCD_PrintString
 918  026f 5b03          	addw	sp,#3
 919                     ; 237 				CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec
 921  0271 ae03e8        	ldw	x,#1000
 922  0274 cd0000        	call	_CR95HF_Wait_Display
 924  0277 200f          	jra	L743
 925  0279               L713:
 926                     ; 244 		if(Response_Resp_code!=CR95HF_SUCCESS_CODE)
 928  0279 0d02          	tnz	(OFST+1,sp)
 929  027b 270b          	jreq	L743
 930                     ; 246 			status=CR95HF_Display_error_commandStatus(Response_Resp_code,CR95HF_CMD_IDLE);
 932  027d ae0007        	ldw	x,#7
 933  0280 7b02          	ld	a,(OFST+1,sp)
 934  0282 95            	ld	xh,a
 935  0283 cd04dc        	call	_CR95HF_Display_error_commandStatus
 937  0286 6b01          	ld	(OFST+0,sp),a
 938  0288               L743:
 939                     ; 250 	return status;// return if any display was done
 941  0288 7b01          	ld	a,(OFST+0,sp)
 944  028a 5b03          	addw	sp,#3
 945  028c 81            	ret
1008                     ; 261 u8 CR95HF_LCD_Print_Answer_RD_REG(const CR95HF_ResponseReceiving* Response)
1008                     ; 262 {
1009                     	switch	.text
1010  028d               _CR95HF_LCD_Print_Answer_RD_REG:
1012  028d 89            	pushw	x
1013  028e 89            	pushw	x
1014       00000002      OFST:	set	2
1017                     ; 263 	u8 status=CR95HF_DISPLAY_UNHANDLED;// to check if  display is done
1019  028f 0f01          	clr	(OFST-1,sp)
1020                     ; 264 	u8 display_counter=INIT_VALUE; // counter to display results
1022  0291 0f02          	clr	(OFST+0,sp)
1023                     ; 267 	if( CR95HF_Display_Enabled== CR95HF_DISPLAY_ALL) 
1025  0293 3d00          	tnz	_CR95HF_Display_Enabled
1026  0295 2703          	jreq	L43
1027  0297 cc0327        	jp	L304
1028  029a               L43:
1029                     ; 269 		status=CR95HF_Display_answer_commandStatus(Response->resp_code, CR95HF_CMD_RDREG);
1031  029a ae0008        	ldw	x,#8
1032  029d 1603          	ldw	y,(OFST+1,sp)
1033  029f 90f6          	ld	a,(y)
1034  02a1 95            	ld	xh,a
1035  02a2 cd0491        	call	_CR95HF_Display_answer_commandStatus
1037  02a5 6b01          	ld	(OFST-1,sp),a
1038                     ; 270 		if(Response->resp_code==CR95HF_SUCCESS_CODE)
1040  02a7 1e03          	ldw	x,(OFST+1,sp)
1041  02a9 7d            	tnz	(x)
1042  02aa 2703          	jreq	L63
1043  02ac cc0339        	jp	L324
1044  02af               L63:
1045                     ; 273 			LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"Register read:");
1047  02af ae0068        	ldw	x,#L704
1048  02b2 89            	pushw	x
1049  02b3 4b00          	push	#0
1050  02b5 ae8001        	ldw	x,#32769
1051  02b8 cd0000        	call	_LCD_PrintString
1053  02bb 5b03          	addw	sp,#3
1054                     ; 274 			LCD_SetCursorPos(LCD_LINE2, LCD_STARTLEFTCORNER);
1056  02bd ae9000        	ldw	x,#36864
1057  02c0 cd0000        	call	_LCD_SetCursorPos
1059                     ; 275 			LCD_PrintHex2(Response->data[display_counter++]);// display register's data
1061  02c3 7b02          	ld	a,(OFST+0,sp)
1062  02c5 97            	ld	xl,a
1063  02c6 0c02          	inc	(OFST+0,sp)
1064  02c8 9f            	ld	a,xl
1065  02c9 5f            	clrw	x
1066  02ca 97            	ld	xl,a
1067  02cb 72fb03        	addw	x,(OFST+1,sp)
1068  02ce e602          	ld	a,(2,x)
1069  02d0 cd0000        	call	_LCD_PrintHex2
1071                     ; 276 			CR95HF_Wait_Display(WAIT_1s);
1073  02d3 ae03e8        	ldw	x,#1000
1074  02d6 cd0000        	call	_CR95HF_Wait_Display
1077  02d9 2042          	jra	L314
1078  02db               L114:
1079                     ; 281 				LCD_SetCursorPos(LCD_LINE1, LCD_STARTLEFTCORNER);
1081  02db ae8000        	ldw	x,#32768
1082  02de cd0000        	call	_LCD_SetCursorPos
1084                     ; 282 				LCD_PrintHex2(Response->data[display_counter++]);// display register's data
1086  02e1 7b02          	ld	a,(OFST+0,sp)
1087  02e3 97            	ld	xl,a
1088  02e4 0c02          	inc	(OFST+0,sp)
1089  02e6 9f            	ld	a,xl
1090  02e7 5f            	clrw	x
1091  02e8 97            	ld	xl,a
1092  02e9 72fb03        	addw	x,(OFST+1,sp)
1093  02ec e602          	ld	a,(2,x)
1094  02ee cd0000        	call	_LCD_PrintHex2
1096                     ; 284 				if(display_counter<Response->data_length)
1098  02f1 1e03          	ldw	x,(OFST+1,sp)
1099  02f3 e601          	ld	a,(1,x)
1100  02f5 1102          	cp	a,(OFST+0,sp)
1101  02f7 231e          	jrule	L714
1102                     ; 286 					LCD_SetCursorPos(LCD_LINE2, LCD_STARTLEFTCORNER);
1104  02f9 ae9000        	ldw	x,#36864
1105  02fc cd0000        	call	_LCD_SetCursorPos
1107                     ; 287 					LCD_PrintHex2(Response->data[display_counter++]);// display register's data
1109  02ff 7b02          	ld	a,(OFST+0,sp)
1110  0301 97            	ld	xl,a
1111  0302 0c02          	inc	(OFST+0,sp)
1112  0304 9f            	ld	a,xl
1113  0305 5f            	clrw	x
1114  0306 97            	ld	xl,a
1115  0307 72fb03        	addw	x,(OFST+1,sp)
1116  030a e602          	ld	a,(2,x)
1117  030c cd0000        	call	_LCD_PrintHex2
1119                     ; 288 					CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec 
1121  030f ae03e8        	ldw	x,#1000
1122  0312 cd0000        	call	_CR95HF_Wait_Display
1125  0315 2006          	jra	L314
1126  0317               L714:
1127                     ; 291 					CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec 
1129  0317 ae03e8        	ldw	x,#1000
1130  031a cd0000        	call	_CR95HF_Wait_Display
1132  031d               L314:
1133                     ; 279 			while( display_counter<Response->data_length )
1135  031d 1e03          	ldw	x,(OFST+1,sp)
1136  031f e601          	ld	a,(1,x)
1137  0321 1102          	cp	a,(OFST+0,sp)
1138  0323 22b6          	jrugt	L114
1139  0325 2012          	jra	L324
1140  0327               L304:
1141                     ; 298 		if(Response->resp_code!=CR95HF_SUCCESS_CODE)
1143  0327 1e03          	ldw	x,(OFST+1,sp)
1144  0329 7d            	tnz	(x)
1145  032a 270d          	jreq	L324
1146                     ; 300 				status=CR95HF_Display_error_commandStatus(Response->resp_code,CR95HF_CMD_RDREG);
1148  032c ae0008        	ldw	x,#8
1149  032f 1603          	ldw	y,(OFST+1,sp)
1150  0331 90f6          	ld	a,(y)
1151  0333 95            	ld	xh,a
1152  0334 cd04dc        	call	_CR95HF_Display_error_commandStatus
1154  0337 6b01          	ld	(OFST-1,sp),a
1155  0339               L324:
1156                     ; 303 	return status;// return if any display was done
1158  0339 7b01          	ld	a,(OFST-1,sp)
1161  033b 5b04          	addw	sp,#4
1162  033d 81            	ret
1232                     ; 315 u8 CR95HF_LCD_Print_Answer_Modify_Baud_Rate(const u8 Response_Resp_code, const u8 Status,const  u32 MCU_Baud_Rate )
1232                     ; 316 {
1233                     	switch	.text
1234  033e               _CR95HF_LCD_Print_Answer_Modify_Baud_Rate:
1236  033e 89            	pushw	x
1237  033f 88            	push	a
1238       00000001      OFST:	set	1
1241                     ; 317 	u8 status=CR95HF_DISPLAY_UNHANDLED;// to check if  display is done
1243  0340 0f01          	clr	(OFST+0,sp)
1244                     ; 321 	if( CR95HF_Display_Enabled== CR95HF_DISPLAY_ALL) 
1246  0342 3d00          	tnz	_CR95HF_Display_Enabled
1247  0344 2703          	jreq	L24
1248  0346 cc03f6        	jp	L164
1249  0349               L24:
1250                     ; 323 		status=CR95HF_Display_answer_commandStatus(Response_Resp_code, CR95HF_CMD_BAUDRATE);
1252  0349 ae000a        	ldw	x,#10
1253  034c 7b02          	ld	a,(OFST+1,sp)
1254  034e 95            	ld	xh,a
1255  034f cd0491        	call	_CR95HF_Display_answer_commandStatus
1257  0352 6b01          	ld	(OFST+0,sp),a
1258                     ; 324 		if(Response_Resp_code==CR95HF_SUCCESS_CODE)
1260  0354 0d02          	tnz	(OFST+1,sp)
1261  0356 2637          	jrne	L364
1262                     ; 326 			LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"Baud Rate :");
1264  0358 ae005c        	ldw	x,#L564
1265  035b 89            	pushw	x
1266  035c 4b00          	push	#0
1267  035e ae8001        	ldw	x,#32769
1268  0361 cd0000        	call	_LCD_PrintString
1270  0364 5b03          	addw	sp,#3
1271                     ; 327 			LCD_SetCursorPos(LCD_LINE2, LCD_STARTLEFTCORNER);
1273  0366 ae9000        	ldw	x,#36864
1274  0369 cd0000        	call	_LCD_SetCursorPos
1276                     ; 328 			LCD_PrintDec7(MCU_Baud_Rate);
1278  036c 1e08          	ldw	x,(OFST+7,sp)
1279  036e 89            	pushw	x
1280  036f 1e08          	ldw	x,(OFST+7,sp)
1281  0371 89            	pushw	x
1282  0372 cd0000        	call	_LCD_PrintDec7
1284  0375 5b04          	addw	sp,#4
1285                     ; 329 			LCD_PrintString(LCD_LINE2,DISABLE,ENABLE," bps");
1287  0377 ae0057        	ldw	x,#L764
1288  037a 89            	pushw	x
1289  037b 4b01          	push	#1
1290  037d ae9000        	ldw	x,#36864
1291  0380 cd0000        	call	_LCD_PrintString
1293  0383 5b03          	addw	sp,#3
1294                     ; 330 			CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec 
1296  0385 ae03e8        	ldw	x,#1000
1297  0388 cd0000        	call	_CR95HF_Wait_Display
1300  038b ac680468      	jpf	L705
1301  038f               L364:
1302                     ; 336 			if( Status==CR95HF_BAUD_RATE_FAILED_PREVIOUS_VALUE_ON ||
1302                     ; 337 Status==CR95HF_BAUD_RATE_FAILED_DEFAULT_VALUE_ON )
1304  038f 7b03          	ld	a,(OFST+2,sp)
1305  0391 a120          	cp	a,#32
1306  0393 2706          	jreq	L574
1308  0395 7b03          	ld	a,(OFST+2,sp)
1309  0397 a110          	cp	a,#16
1310  0399 2637          	jrne	L374
1311  039b               L574:
1312                     ; 339 				LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"Baud Rate on");
1314  039b ae004a        	ldw	x,#L774
1315  039e 89            	pushw	x
1316  039f 4b00          	push	#0
1317  03a1 ae8001        	ldw	x,#32769
1318  03a4 cd0000        	call	_LCD_PrintString
1320  03a7 5b03          	addw	sp,#3
1321                     ; 340 				LCD_SetCursorPos(LCD_LINE2, LCD_STARTLEFTCORNER);
1323  03a9 ae9000        	ldw	x,#36864
1324  03ac cd0000        	call	_LCD_SetCursorPos
1326                     ; 341 				LCD_PrintDec7(MCU_Baud_Rate);
1328  03af 1e08          	ldw	x,(OFST+7,sp)
1329  03b1 89            	pushw	x
1330  03b2 1e08          	ldw	x,(OFST+7,sp)
1331  03b4 89            	pushw	x
1332  03b5 cd0000        	call	_LCD_PrintDec7
1334  03b8 5b04          	addw	sp,#4
1335                     ; 342 				LCD_PrintString(LCD_LINE2,DISABLE,ENABLE," bps");
1337  03ba ae0057        	ldw	x,#L764
1338  03bd 89            	pushw	x
1339  03be 4b01          	push	#1
1340  03c0 ae9000        	ldw	x,#36864
1341  03c3 cd0000        	call	_LCD_PrintString
1343  03c6 5b03          	addw	sp,#3
1344                     ; 344 				CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec 
1346  03c8 ae03e8        	ldw	x,#1000
1347  03cb cd0000        	call	_CR95HF_Wait_Display
1350  03ce ac680468      	jpf	L705
1351  03d2               L374:
1352                     ; 348 				LCD_PrintString(LCD_LINE1,ENABLE,DISABLE,"MCU<-X->CR95HF");
1354  03d2 ae003b        	ldw	x,#L305
1355  03d5 89            	pushw	x
1356  03d6 4b00          	push	#0
1357  03d8 ae8001        	ldw	x,#32769
1358  03db cd0000        	call	_LCD_PrintString
1360  03de 5b03          	addw	sp,#3
1361                     ; 349 				LCD_PrintString(LCD_LINE2,DISABLE,ENABLE,"Baud Rate ERR");
1363  03e0 ae002d        	ldw	x,#L505
1364  03e3 89            	pushw	x
1365  03e4 4b01          	push	#1
1366  03e6 ae9000        	ldw	x,#36864
1367  03e9 cd0000        	call	_LCD_PrintString
1369  03ec 5b03          	addw	sp,#3
1370                     ; 350 				CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec
1372  03ee ae03e8        	ldw	x,#1000
1373  03f1 cd0000        	call	_CR95HF_Wait_Display
1375  03f4 2072          	jra	L705
1376  03f6               L164:
1377                     ; 357 		if(Response_Resp_code!= CR95HF_SUCCESS_CODE)
1379  03f6 0d02          	tnz	(OFST+1,sp)
1380  03f8 276e          	jreq	L705
1381                     ; 359 			status=CR95HF_Display_error_commandStatus(Response_Resp_code,CR95HF_CMD_BAUDRATE);
1383  03fa ae000a        	ldw	x,#10
1384  03fd 7b02          	ld	a,(OFST+1,sp)
1385  03ff 95            	ld	xh,a
1386  0400 cd04dc        	call	_CR95HF_Display_error_commandStatus
1388  0403 6b01          	ld	(OFST+0,sp),a
1389                     ; 362 			if( Status==CR95HF_BAUD_RATE_FAILED_PREVIOUS_VALUE_ON ||
1389                     ; 363 Status==CR95HF_BAUD_RATE_FAILED_DEFAULT_VALUE_ON )
1391  0405 7b03          	ld	a,(OFST+2,sp)
1392  0407 a120          	cp	a,#32
1393  0409 2706          	jreq	L515
1395  040b 7b03          	ld	a,(OFST+2,sp)
1396  040d a110          	cp	a,#16
1397  040f 2635          	jrne	L315
1398  0411               L515:
1399                     ; 365 				LCD_PrintString(LCD_LINE1,DISABLE,ENABLE,"Baud Rate On");
1401  0411 ae0020        	ldw	x,#L715
1402  0414 89            	pushw	x
1403  0415 4b01          	push	#1
1404  0417 ae8000        	ldw	x,#32768
1405  041a cd0000        	call	_LCD_PrintString
1407  041d 5b03          	addw	sp,#3
1408                     ; 366 				LCD_SetCursorPos(LCD_LINE2, LCD_STARTLEFTCORNER);
1410  041f ae9000        	ldw	x,#36864
1411  0422 cd0000        	call	_LCD_SetCursorPos
1413                     ; 367 				LCD_PrintDec7(MCU_Baud_Rate);
1415  0425 1e08          	ldw	x,(OFST+7,sp)
1416  0427 89            	pushw	x
1417  0428 1e08          	ldw	x,(OFST+7,sp)
1418  042a 89            	pushw	x
1419  042b cd0000        	call	_LCD_PrintDec7
1421  042e 5b04          	addw	sp,#4
1422                     ; 368 				LCD_PrintString(LCD_LINE2,DISABLE,ENABLE," bps");
1424  0430 ae0057        	ldw	x,#L764
1425  0433 89            	pushw	x
1426  0434 4b01          	push	#1
1427  0436 ae9000        	ldw	x,#36864
1428  0439 cd0000        	call	_LCD_PrintString
1430  043c 5b03          	addw	sp,#3
1431                     ; 370 				CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec 
1433  043e ae03e8        	ldw	x,#1000
1434  0441 cd0000        	call	_CR95HF_Wait_Display
1437  0444 2022          	jra	L705
1438  0446               L315:
1439                     ; 374 				LCD_PrintString(LCD_LINE1,DISABLE,ENABLE,"MCU<-X->CR95HF");
1441  0446 ae003b        	ldw	x,#L305
1442  0449 89            	pushw	x
1443  044a 4b01          	push	#1
1444  044c ae8000        	ldw	x,#32768
1445  044f cd0000        	call	_LCD_PrintString
1447  0452 5b03          	addw	sp,#3
1448                     ; 375 				LCD_PrintString(LCD_LINE2,DISABLE,ENABLE,"Baud Rate ERR");
1450  0454 ae002d        	ldw	x,#L505
1451  0457 89            	pushw	x
1452  0458 4b01          	push	#1
1453  045a ae9000        	ldw	x,#36864
1454  045d cd0000        	call	_LCD_PrintString
1456  0460 5b03          	addw	sp,#3
1457                     ; 376 				CR95HF_Wait_Display(WAIT_1s);// Wait for 1 sec
1459  0462 ae03e8        	ldw	x,#1000
1460  0465 cd0000        	call	_CR95HF_Wait_Display
1462  0468               L705:
1463                     ; 380 	return status;// return if any display was done
1465  0468 7b01          	ld	a,(OFST+0,sp)
1468  046a 5b03          	addw	sp,#3
1469  046c 81            	ret
1516                     ; 390 u8 CR95HF_LCD_Print_Answer_Echo(const u8 Response_resp_code)
1516                     ; 391 {
1517                     	switch	.text
1518  046d               _CR95HF_LCD_Print_Answer_Echo:
1520  046d 88            	push	a
1521  046e 88            	push	a
1522       00000001      OFST:	set	1
1525                     ; 392 	u8 status=CR95HF_DISPLAY_UNHANDLED;// to check if  display is done
1527  046f 0f01          	clr	(OFST+0,sp)
1528                     ; 395 	if( CR95HF_Display_Enabled== CR95HF_DISPLAY_ALL) 
1530  0471 3d00          	tnz	_CR95HF_Display_Enabled
1531  0473 260a          	jrne	L545
1532                     ; 397 		status=CR95HF_Display_answer_commandStatus(Response_resp_code, CR95HF_CMD_ECHO);
1534  0475 ae0055        	ldw	x,#85
1535  0478 95            	ld	xh,a
1536  0479 ad16          	call	_CR95HF_Display_answer_commandStatus
1538  047b 6b01          	ld	(OFST+0,sp),a
1540  047d 200e          	jra	L745
1541  047f               L545:
1542                     ; 402 		if(Response_resp_code!=CR95HF_SUCCESS_CODE)
1544  047f 0d02          	tnz	(OFST+1,sp)
1545  0481 270a          	jreq	L745
1546                     ; 404 			status=CR95HF_Display_error_commandStatus(Response_resp_code,CR95HF_CMD_ECHO);// Display only error
1548  0483 ae0055        	ldw	x,#85
1549  0486 7b02          	ld	a,(OFST+1,sp)
1550  0488 95            	ld	xh,a
1551  0489 ad51          	call	_CR95HF_Display_error_commandStatus
1553  048b 6b01          	ld	(OFST+0,sp),a
1554  048d               L745:
1555                     ; 407 	return status;// return if any display was done
1557  048d 7b01          	ld	a,(OFST+0,sp)
1560  048f 85            	popw	x
1561  0490 81            	ret
1620                     ; 417 u8 CR95HF_Display_answer_commandStatus(const u8 Response_resp_code, const u8 CommandCode)
1620                     ; 418 {
1621                     	switch	.text
1622  0491               _CR95HF_Display_answer_commandStatus:
1624  0491 89            	pushw	x
1625  0492 88            	push	a
1626       00000001      OFST:	set	1
1629                     ; 419 	u8 status=CR95HF_DISPLAY_UNHANDLED;// to check if  display is done
1631                     ; 420 	if(Response_resp_code==CR95HF_SUCCESS_CODE  )
1633  0493 9e            	ld	a,xh
1634  0494 4d            	tnz	a
1635  0495 2636          	jrne	L106
1636                     ; 422 		LCD_Clear();// Display "CR95HF "command code" OK"
1638  0497 cd0000        	call	_LCD_Clear
1640                     ; 423 		LCD_SetCursorPos(LCD_LINE1, LCD_STARTLEFTCORNER);
1642  049a ae8000        	ldw	x,#32768
1643  049d cd0000        	call	_LCD_SetCursorPos
1645                     ; 424 		LCD_PrintString(LCD_LINE1,DISABLE,ENABLE,"CR95HF ");
1647  04a0 ae0018        	ldw	x,#L306
1648  04a3 89            	pushw	x
1649  04a4 4b01          	push	#1
1650  04a6 ae8000        	ldw	x,#32768
1651  04a9 cd0000        	call	_LCD_PrintString
1653  04ac 5b03          	addw	sp,#3
1654                     ; 425 		LCD_PrintHex2(CommandCode);
1656  04ae 7b03          	ld	a,(OFST+2,sp)
1657  04b0 cd0000        	call	_LCD_PrintHex2
1659                     ; 426 		LCD_PrintString(LCD_LINE1,DISABLE,ENABLE," OK");
1661  04b3 ae0014        	ldw	x,#L506
1662  04b6 89            	pushw	x
1663  04b7 4b01          	push	#1
1664  04b9 ae8000        	ldw	x,#32768
1665  04bc cd0000        	call	_LCD_PrintString
1667  04bf 5b03          	addw	sp,#3
1668                     ; 427 		status=CR95HF_DISPLAY_HANDLED;
1670  04c1 a601          	ld	a,#1
1671  04c3 6b01          	ld	(OFST+0,sp),a
1672                     ; 428 		CR95HF_Wait_Display(WAIT_1s);// Wait for 1s
1674  04c5 ae03e8        	ldw	x,#1000
1675  04c8 cd0000        	call	_CR95HF_Wait_Display
1678  04cb 200a          	jra	L706
1679  04cd               L106:
1680                     ; 432 		status= CR95HF_Display_error_commandStatus( Response_resp_code, CommandCode);
1682  04cd 7b03          	ld	a,(OFST+2,sp)
1683  04cf 97            	ld	xl,a
1684  04d0 7b02          	ld	a,(OFST+1,sp)
1685  04d2 95            	ld	xh,a
1686  04d3 ad07          	call	_CR95HF_Display_error_commandStatus
1688  04d5 6b01          	ld	(OFST+0,sp),a
1689  04d7               L706:
1690                     ; 435 	return status;
1692  04d7 7b01          	ld	a,(OFST+0,sp)
1695  04d9 5b03          	addw	sp,#3
1696  04db 81            	ret
1754                     ; 446 u8 CR95HF_Display_error_commandStatus(const u8 Response_resp_code,const u8 CommandCode)
1754                     ; 447 {
1755                     	switch	.text
1756  04dc               _CR95HF_Display_error_commandStatus:
1758  04dc 89            	pushw	x
1759  04dd 88            	push	a
1760       00000001      OFST:	set	1
1763                     ; 448 	u8 status=CR95HF_DISPLAY_UNHANDLED;
1765                     ; 449 	LCD_Clear();// Display "CMD C "command code" FAILED" C is for CR95HF
1767  04de cd0000        	call	_LCD_Clear
1769                     ; 450 	LCD_SetCursorPos(LCD_LINE1, LCD_STARTLEFTCORNER);
1771  04e1 ae8000        	ldw	x,#32768
1772  04e4 cd0000        	call	_LCD_SetCursorPos
1774                     ; 451 	LCD_PrintString(LCD_LINE1,DISABLE,ENABLE,"CMD C");
1776  04e7 ae000e        	ldw	x,#L736
1777  04ea 89            	pushw	x
1778  04eb 4b01          	push	#1
1779  04ed ae8000        	ldw	x,#32768
1780  04f0 cd0000        	call	_LCD_PrintString
1782  04f3 5b03          	addw	sp,#3
1783                     ; 452 	LCD_PrintHex2(CommandCode);
1785  04f5 7b03          	ld	a,(OFST+2,sp)
1786  04f7 cd0000        	call	_LCD_PrintHex2
1788                     ; 453 	LCD_PrintString(LCD_LINE1,DISABLE,ENABLE," FAILED");
1790  04fa ae0006        	ldw	x,#L146
1791  04fd 89            	pushw	x
1792  04fe 4b01          	push	#1
1793  0500 ae8000        	ldw	x,#32768
1794  0503 cd0000        	call	_LCD_PrintString
1796  0506 5b03          	addw	sp,#3
1797                     ; 456 	LCD_SetCursorPos(LCD_LINE2, LCD_STARTLEFTCORNER);
1799  0508 ae9000        	ldw	x,#36864
1800  050b cd0000        	call	_LCD_SetCursorPos
1802                     ; 457 	LCD_PrintString(LCD_LINE2,DISABLE,ENABLE,"ERR: ");
1804  050e ae0000        	ldw	x,#L346
1805  0511 89            	pushw	x
1806  0512 4b01          	push	#1
1807  0514 ae9000        	ldw	x,#36864
1808  0517 cd0000        	call	_LCD_PrintString
1810  051a 5b03          	addw	sp,#3
1811                     ; 459 	LCD_PrintHex2(Response_resp_code);
1813  051c 7b02          	ld	a,(OFST+1,sp)
1814  051e cd0000        	call	_LCD_PrintHex2
1816                     ; 460 	CR95HF_Wait_Display(WAIT_1s);// Wait for 1s
1818  0521 ae03e8        	ldw	x,#1000
1819  0524 cd0000        	call	_CR95HF_Wait_Display
1821                     ; 461 	status=CR95HF_DISPLAY_HANDLED;
1823                     ; 462 }
1826  0527 5b03          	addw	sp,#3
1827  0529 81            	ret
1852                     	switch	.ubsct
1853  0000               _CR95HF_Display_Enabled:
1854  0000 00            	ds.b	1
1855                     	xdef	_CR95HF_Display_Enabled
1856                     	xdef	_CR95HF_Display_error_commandStatus
1857                     	xdef	_CR95HF_Display_answer_commandStatus
1858                     	xdef	_CR95HF_LCD_Print_Answer_Echo
1859                     	xdef	_CR95HF_LCD_Print_Answer_Modify_Baud_Rate
1860                     	xdef	_CR95HF_LCD_Print_Answer_RD_REG
1861                     	xdef	_CR95HF_LCD_Print_Answer_Idle
1862                     	xdef	_CR95HF_LCD_Print_Answer_Send_Recv
1863                     	xdef	_CR95HF_LCD_Print_Answer_Protocol_Select
1864                     	xdef	_CR95HF_LCD_Print_Answer_IDN
1865                     	xdef	_CR95HF_Wait_Display
1866                     	xref	_CR95HF_Is_Timeout_Wake_up_Condition
1867                     	xref	_CR95HF_Is_Tag_Detected_Wake_up_Condition
1868                     	xref	_CR95HF_Is_NSS_Interrupt_Wake_up_Condition
1869                     	xref	_CR95HF_Is_IRQin_Interrupt_Wake_up_Condition
1870                     	xref	_delay_ms
1871                     	xref	_LCD_Print
1872                     	xref	_LCD_PrintDec7
1873                     	xref	_LCD_PrintHex2
1874                     	xref	_LCD_DisplayLogo
1875                     	xref	_LCD_PrintString
1876                     	xref	_LCD_PrintChar
1877                     	xref	_LCD_SetCursorPos
1878                     	xref	_LCD_Clear
1879                     .const:	section	.text
1880  0000               L346:
1881  0000 4552523a2000  	dc.b	"ERR: ",0
1882  0006               L146:
1883  0006 204641494c45  	dc.b	" FAILED",0
1884  000e               L736:
1885  000e 434d44204300  	dc.b	"CMD C",0
1886  0014               L506:
1887  0014 204f4b00      	dc.b	" OK",0
1888  0018               L306:
1889  0018 435239354846  	dc.b	"CR95HF ",0
1890  0020               L715:
1891  0020 426175642052  	dc.b	"Baud Rate On",0
1892  002d               L505:
1893  002d 426175642052  	dc.b	"Baud Rate ERR",0
1894  003b               L305:
1895  003b 4d43553c2d58  	dc.b	"MCU<-X->CR95HF",0
1896  004a               L774:
1897  004a 426175642052  	dc.b	"Baud Rate on",0
1898  0057               L764:
1899  0057 2062707300    	dc.b	" bps",0
1900  005c               L564:
1901  005c 426175642052  	dc.b	"Baud Rate :",0
1902  0068               L704:
1903  0068 526567697374  	dc.b	"Register read:",0
1904  0077               L543:
1905  0077 20202054494d  	dc.b	"   TIME OUT",0
1906  0083               L143:
1907  0083 205441472044  	dc.b	" TAG DETECTED",0
1908  0091               L333:
1909  0091 2020204e5353  	dc.b	"   NSS",0
1910  0098               L723:
1911  0098 202020495251  	dc.b	"   IRQ_IN",0
1912  00a2               L323:
1913  00a2 2057616b652d  	dc.b	" Wake-up on: ",0
1914  00b0               L522:
1915  00b0 202020204645  	dc.b	"    FELICA",0
1916  00bb               L122:
1917  00bb 202049534f31  	dc.b	"  ISO14443-B",0
1918  00c8               L512:
1919  00c8 202049534f31  	dc.b	"  ISO14443-A",0
1920  00d5               L112:
1921  00d5 20202049534f  	dc.b	"   ISO15693",0
1922  00e1               L502:
1923  00e1 202020466965  	dc.b	"   Field Off",0
1924  00ee               L102:
1925  00ee 20202050726f  	dc.b	"   Protocol: ",0
1926  00fc               L321:
1927  00fc 43524320524f  	dc.b	"CRC ROM: ",0
1928  0106               L311:
1929  0106 202044657669  	dc.b	"  Device ID :",0
1930  0114               L53:
1931  0114 204352393548  	dc.b	" CR95HF  ",0
1951                     	end
