   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.9.10 - 10 Feb 2011
   3                     ; Generator (Limited) V4.3.6 - 15 Feb 2011
  43                     ; 134 void DMA_GlobalDeInit(void)
  43                     ; 135 {
  45                     	switch	.text
  46  0000               _DMA_GlobalDeInit:
  50                     ; 137   DMA1->GCSR &= (uint8_t)~(DMA_GCSR_GE);
  52  0000 72115070      	bres	20592,#0
  53                     ; 140   DMA1->GCSR  = (uint8_t)DMA_GCSR_RESET_VALUE;
  55  0004 35fc5070      	mov	20592,#252
  56                     ; 141 }
  59  0008 81            	ret
 175                     ; 149 void DMA_DeInit(DMA_Channel_TypeDef* DMA_Channelx)
 175                     ; 150 {
 176                     	switch	.text
 177  0009               _DMA_DeInit:
 179  0009 89            	pushw	x
 180       00000000      OFST:	set	0
 183                     ; 152   assert_param(IS_DMA_CHANNEL(DMA_Channelx));
 185                     ; 155   DMA_Channelx->CCR &= (uint8_t)~(DMA_CCR_CE);
 187  000a f6            	ld	a,(x)
 188  000b a4fe          	and	a,#254
 189  000d f7            	ld	(x),a
 190                     ; 158   DMA_Channelx->CCR  = DMA_CCR_RESET_VALUE;
 192  000e 7f            	clr	(x)
 193                     ; 161   DMA_Channelx->CNBTR = DMA_CNBTR_RESET_VALUE;
 195  000f 6f02          	clr	(2,x)
 196                     ; 164   if (DMA_Channelx == DMA1_Channel3)
 198  0011 a35093        	cpw	x,#20627
 199  0014 2608          	jrne	L501
 200                     ; 166     DMA_Channelx->CPARH  = DMA_C3PARH_RESET_VALUE;
 202  0016 a640          	ld	a,#64
 203  0018 e703          	ld	(3,x),a
 204                     ; 167     DMA_Channelx->CM0EAR = DMA_C3M0EAR_RESET_VALUE;
 206  001a 6f05          	clr	(5,x)
 208  001c 2006          	jra	L701
 209  001e               L501:
 210                     ; 171     DMA_Channelx->CPARH  = DMA_CPARH_RESET_VALUE;
 212  001e 1e01          	ldw	x,(OFST+1,sp)
 213  0020 a652          	ld	a,#82
 214  0022 e703          	ld	(3,x),a
 215  0024               L701:
 216                     ; 173   DMA_Channelx->CPARL  = DMA_CPARL_RESET_VALUE;
 218  0024 1e01          	ldw	x,(OFST+1,sp)
 219  0026 6f04          	clr	(4,x)
 220                     ; 176   DMA_Channelx->CM0ARH = DMA_CM0ARH_RESET_VALUE;
 222  0028 1e01          	ldw	x,(OFST+1,sp)
 223  002a 6f06          	clr	(6,x)
 224                     ; 177   DMA_Channelx->CM0ARL = DMA_CM0ARL_RESET_VALUE;
 226  002c 1e01          	ldw	x,(OFST+1,sp)
 227  002e 6f07          	clr	(7,x)
 228                     ; 180   DMA_Channelx->CSPR = DMA_CSPR_RESET_VALUE;
 230  0030 1e01          	ldw	x,(OFST+1,sp)
 231  0032 6f01          	clr	(1,x)
 232                     ; 181 }
 235  0034 85            	popw	x
 236  0035 81            	ret
 482                     ; 218 void DMA_Init(DMA_Channel_TypeDef* DMA_Channelx,
 482                     ; 219               uint32_t DMA_Memory0BaseAddr,
 482                     ; 220               uint16_t DMA_PeripheralMemory1BaseAddr,
 482                     ; 221               uint8_t DMA_BufferSize,
 482                     ; 222               DMA_DIR_TypeDef DMA_DIR,
 482                     ; 223               DMA_Mode_TypeDef DMA_Mode,
 482                     ; 224               DMA_MemoryIncMode_TypeDef DMA_MemoryIncMode,
 482                     ; 225               DMA_Priority_TypeDef DMA_Priority,
 482                     ; 226               DMA_MemoryDataSize_TypeDef DMA_MemoryDataSize )
 482                     ; 227 {
 483                     	switch	.text
 484  0036               _DMA_Init:
 486  0036 89            	pushw	x
 487       00000000      OFST:	set	0
 490                     ; 229   assert_param(IS_DMA_CHANNEL(DMA_Channelx));
 492                     ; 230   assert_param(IS_DMA_DIR(DMA_DIR));
 494                     ; 231   assert_param(IS_DMA_BUFFER_SIZE(DMA_BufferSize));
 496                     ; 232   assert_param(IS_DMA_MODE(DMA_Mode));
 498                     ; 233   assert_param(IS_DMA_MEMORY_INC_MODE(DMA_MemoryIncMode));
 500                     ; 234   assert_param(IS_DMA_PRIORITY(DMA_Priority));
 502                     ; 238   DMA_Channelx->CCR &= (uint8_t)~(DMA_CCR_CE);
 504  0037 f6            	ld	a,(x)
 505  0038 a4fe          	and	a,#254
 506  003a f7            	ld	(x),a
 507                     ; 241   DMA_Channelx->CCR  = DMA_CCR_RESET_VALUE;
 509  003b 7f            	clr	(x)
 510                     ; 244   DMA_Channelx->CCR |= (uint8_t)((uint8_t)((uint8_t)DMA_DIR | \
 510                     ; 245                                            (uint8_t)DMA_Mode) | \
 510                     ; 246                                            (uint8_t)DMA_MemoryIncMode);
 512  003c 7b0c          	ld	a,(OFST+12,sp)
 513  003e 1a0d          	or	a,(OFST+13,sp)
 514  0040 1a0e          	or	a,(OFST+14,sp)
 515  0042 fa            	or	a,(x)
 516  0043 f7            	ld	(x),a
 517                     ; 249   DMA_Channelx->CSPR &= (uint8_t)(~(uint8_t)(DMA_CSPR_PL | DMA_CSPR_16BM));
 519  0044 e601          	ld	a,(1,x)
 520  0046 a4c7          	and	a,#199
 521  0048 e701          	ld	(1,x),a
 522                     ; 252   DMA_Channelx->CSPR |= (uint8_t)((uint8_t)DMA_Priority | \
 522                     ; 253                                   (uint8_t)DMA_MemoryDataSize);
 524  004a 7b0f          	ld	a,(OFST+15,sp)
 525  004c 1a10          	or	a,(OFST+16,sp)
 526  004e ea01          	or	a,(1,x)
 527  0050 e701          	ld	(1,x),a
 528                     ; 257   DMA_Channelx->CNBTR = (uint8_t)DMA_BufferSize;
 530  0052 7b0b          	ld	a,(OFST+11,sp)
 531  0054 1e01          	ldw	x,(OFST+1,sp)
 532  0056 e702          	ld	(2,x),a
 533                     ; 262   DMA_Channelx->CPARH = (uint8_t)(DMA_PeripheralMemory1BaseAddr >> (uint8_t)8);
 535  0058 7b09          	ld	a,(OFST+9,sp)
 536  005a 1e01          	ldw	x,(OFST+1,sp)
 537  005c e703          	ld	(3,x),a
 538                     ; 263   DMA_Channelx->CPARL = (uint8_t)(DMA_PeripheralMemory1BaseAddr);
 540  005e 7b0a          	ld	a,(OFST+10,sp)
 541  0060 1e01          	ldw	x,(OFST+1,sp)
 542  0062 e704          	ld	(4,x),a
 543                     ; 267   if (DMA_Channelx == DMA1_Channel3)
 545  0064 1e01          	ldw	x,(OFST+1,sp)
 546  0066 a35093        	cpw	x,#20627
 547  0069 2606          	jrne	L742
 548                     ; 269     DMA_Channelx->CM0EAR = (uint8_t)(DMA_Memory0BaseAddr >> (uint8_t)16);
 550  006b 7b06          	ld	a,(OFST+6,sp)
 551  006d 1e01          	ldw	x,(OFST+1,sp)
 552  006f e705          	ld	(5,x),a
 553  0071               L742:
 554                     ; 271   DMA_Channelx->CM0ARH = (uint8_t)(DMA_Memory0BaseAddr >> (uint8_t)8);
 556  0071 7b07          	ld	a,(OFST+7,sp)
 557  0073 1e01          	ldw	x,(OFST+1,sp)
 558  0075 e706          	ld	(6,x),a
 559                     ; 272   DMA_Channelx->CM0ARL = (uint8_t)(DMA_Memory0BaseAddr);
 561  0077 7b08          	ld	a,(OFST+8,sp)
 562  0079 1e01          	ldw	x,(OFST+1,sp)
 563  007b e707          	ld	(7,x),a
 564                     ; 274 }
 567  007d 85            	popw	x
 568  007e 81            	ret
 623                     ; 282 void DMA_GlobalCmd(FunctionalState NewState)
 623                     ; 283 {
 624                     	switch	.text
 625  007f               _DMA_GlobalCmd:
 629                     ; 285   assert_param(IS_FUNCTIONAL_STATE(NewState));
 631                     ; 287   if (NewState != DISABLE)
 633  007f 4d            	tnz	a
 634  0080 2706          	jreq	L772
 635                     ; 290     DMA1->GCSR |= (uint8_t)DMA_GCSR_GE;
 637  0082 72105070      	bset	20592,#0
 639  0086 2004          	jra	L103
 640  0088               L772:
 641                     ; 295     DMA1->GCSR &= (uint8_t)(~DMA_GCSR_GE);
 643  0088 72115070      	bres	20592,#0
 644  008c               L103:
 645                     ; 297 }
 648  008c 81            	ret
 695                     ; 308 void DMA_Cmd(DMA_Channel_TypeDef* DMA_Channelx, FunctionalState NewState)
 695                     ; 309 {
 696                     	switch	.text
 697  008d               _DMA_Cmd:
 699  008d 89            	pushw	x
 700       00000000      OFST:	set	0
 703                     ; 311   assert_param(IS_DMA_CHANNEL(DMA_Channelx));
 705                     ; 312   assert_param(IS_FUNCTIONAL_STATE(NewState));
 707                     ; 314   if (NewState != DISABLE)
 709  008e 0d05          	tnz	(OFST+5,sp)
 710  0090 2706          	jreq	L723
 711                     ; 317     DMA_Channelx->CCR |= DMA_CCR_CE;
 713  0092 f6            	ld	a,(x)
 714  0093 aa01          	or	a,#1
 715  0095 f7            	ld	(x),a
 717  0096 2006          	jra	L133
 718  0098               L723:
 719                     ; 322     DMA_Channelx->CCR &= (uint8_t)(~DMA_CCR_CE);
 721  0098 1e01          	ldw	x,(OFST+1,sp)
 722  009a f6            	ld	a,(x)
 723  009b a4fe          	and	a,#254
 724  009d f7            	ld	(x),a
 725  009e               L133:
 726                     ; 324 }
 729  009e 85            	popw	x
 730  009f 81            	ret
 807                     ; 477 void DMA_ITConfig(DMA_Channel_TypeDef* DMA_Channelx, 
 807                     ; 478                   DMA_ITx_TypeDef DMA_ITx,
 807                     ; 479                   FunctionalState NewState)
 807                     ; 480 {
 808                     	switch	.text
 809  00a0               _DMA_ITConfig:
 811  00a0 89            	pushw	x
 812       00000000      OFST:	set	0
 815                     ; 482   assert_param(IS_DMA_CHANNEL(DMA_Channelx));
 817                     ; 483   assert_param(IS_DMA_CONFIG_ITX(DMA_ITx));
 819                     ; 484   assert_param(IS_FUNCTIONAL_STATE(NewState));
 821                     ; 486   if (NewState != DISABLE)
 823  00a1 0d06          	tnz	(OFST+6,sp)
 824  00a3 2706          	jreq	L373
 825                     ; 489     DMA_Channelx->CCR |= (uint8_t)(DMA_ITx);
 827  00a5 f6            	ld	a,(x)
 828  00a6 1a05          	or	a,(OFST+5,sp)
 829  00a8 f7            	ld	(x),a
 831  00a9 2007          	jra	L573
 832  00ab               L373:
 833                     ; 494     DMA_Channelx->CCR &= (uint8_t)~(DMA_ITx);
 835  00ab 1e01          	ldw	x,(OFST+1,sp)
 836  00ad 7b05          	ld	a,(OFST+5,sp)
 837  00af 43            	cpl	a
 838  00b0 f4            	and	a,(x)
 839  00b1 f7            	ld	(x),a
 840  00b2               L573:
 841                     ; 496 }
 844  00b2 85            	popw	x
 845  00b3 81            	ret
1094                     ; 525 FlagStatus DMA_GetFlagStatus(DMA_FLAG_TypeDef DMA_FLAG)
1094                     ; 526 {
1095                     	switch	.text
1096  00b4               _DMA_GetFlagStatus:
1098  00b4 89            	pushw	x
1099  00b5 5204          	subw	sp,#4
1100       00000004      OFST:	set	4
1103                     ; 527   FlagStatus flagstatus = RESET;
1105                     ; 528   DMA_Channel_TypeDef* DMA_Channelx =  DMA1_Channel0;
1107                     ; 529   uint8_t tmpgir1 = 0;
1109                     ; 530   uint8_t tmpgcsr = 0;
1111                     ; 533   assert_param(IS_DMA_GET_FLAG(DMA_FLAG));
1113                     ; 536   tmpgcsr = DMA1->GCSR;
1115  00b7 c65070        	ld	a,20592
1116  00ba 6b04          	ld	(OFST+0,sp),a
1117                     ; 537   tmpgir1 = DMA1->GIR1;
1119  00bc c65071        	ld	a,20593
1120  00bf 6b01          	ld	(OFST-3,sp),a
1121                     ; 539   if (((uint16_t)DMA_FLAG & (uint16_t)0x0F00) != (uint16_t)RESET)
1123  00c1 01            	rrwa	x,a
1124  00c2 9f            	ld	a,xl
1125  00c3 a40f          	and	a,#15
1126  00c5 97            	ld	xl,a
1127  00c6 4f            	clr	a
1128  00c7 02            	rlwa	x,a
1129  00c8 5d            	tnzw	x
1130  00c9 2736          	jreq	L525
1131                     ; 542     if (((uint16_t)DMA_FLAG & 0x0100) != (uint16_t)RESET)
1133  00cb 7b05          	ld	a,(OFST+1,sp)
1134  00cd a501          	bcp	a,#1
1135  00cf 2707          	jreq	L725
1136                     ; 544       DMA_Channelx = DMA1_Channel0;
1138  00d1 ae5075        	ldw	x,#20597
1139  00d4 1f02          	ldw	(OFST-2,sp),x
1141  00d6 201f          	jra	L135
1142  00d8               L725:
1143                     ; 546     else if  (((uint16_t)DMA_FLAG & 0x0200) != (uint16_t)RESET)
1145  00d8 7b05          	ld	a,(OFST+1,sp)
1146  00da a502          	bcp	a,#2
1147  00dc 2707          	jreq	L335
1148                     ; 548       DMA_Channelx = DMA1_Channel1;
1150  00de ae507f        	ldw	x,#20607
1151  00e1 1f02          	ldw	(OFST-2,sp),x
1153  00e3 2012          	jra	L135
1154  00e5               L335:
1155                     ; 550     else if  (((uint16_t)DMA_FLAG & 0x0400) != (uint16_t)RESET)
1157  00e5 7b05          	ld	a,(OFST+1,sp)
1158  00e7 a504          	bcp	a,#4
1159  00e9 2707          	jreq	L735
1160                     ; 552       DMA_Channelx = DMA1_Channel2;
1162  00eb ae5089        	ldw	x,#20617
1163  00ee 1f02          	ldw	(OFST-2,sp),x
1165  00f0 2005          	jra	L135
1166  00f2               L735:
1167                     ; 556       DMA_Channelx = DMA1_Channel3;
1169  00f2 ae5093        	ldw	x,#20627
1170  00f5 1f02          	ldw	(OFST-2,sp),x
1171  00f7               L135:
1172                     ; 560     flagstatus = (FlagStatus)((uint8_t)(DMA_Channelx->CSPR) & (uint8_t)DMA_FLAG);
1174  00f7 1e02          	ldw	x,(OFST-2,sp)
1175  00f9 e601          	ld	a,(1,x)
1176  00fb 1406          	and	a,(OFST+2,sp)
1177  00fd 6b04          	ld	(OFST+0,sp),a
1179  00ff 2014          	jra	L345
1180  0101               L525:
1181                     ; 562   else if (((uint16_t)DMA_FLAG & 0x1000) != (uint16_t)RESET)
1183  0101 7b05          	ld	a,(OFST+1,sp)
1184  0103 a510          	bcp	a,#16
1185  0105 2708          	jreq	L545
1186                     ; 565     flagstatus = (FlagStatus)(tmpgir1 & (uint8_t)DMA_FLAG);
1188  0107 7b06          	ld	a,(OFST+2,sp)
1189  0109 1401          	and	a,(OFST-3,sp)
1190  010b 6b04          	ld	(OFST+0,sp),a
1192  010d 2006          	jra	L345
1193  010f               L545:
1194                     ; 570     flagstatus = (FlagStatus)(tmpgcsr & DMA_GCSR_GB);
1196  010f 7b04          	ld	a,(OFST+0,sp)
1197  0111 a402          	and	a,#2
1198  0113 6b04          	ld	(OFST+0,sp),a
1199  0115               L345:
1200                     ; 574   return (flagstatus);
1202  0115 7b04          	ld	a,(OFST+0,sp)
1205  0117 5b06          	addw	sp,#6
1206  0119 81            	ret
1253                     ; 592 void DMA_ClearFlag(DMA_FLAG_TypeDef DMA_FLAG)
1253                     ; 593 {
1254                     	switch	.text
1255  011a               _DMA_ClearFlag:
1257  011a 89            	pushw	x
1258  011b 89            	pushw	x
1259       00000002      OFST:	set	2
1262                     ; 594   DMA_Channel_TypeDef* DMA_Channelx =  DMA1_Channel0;
1264                     ; 597   assert_param(IS_DMA_CLEAR_FLAG(DMA_FLAG));
1266                     ; 600   if (((uint16_t)DMA_FLAG & (uint16_t)0x0100) != (uint16_t)RESET)
1268  011c 01            	rrwa	x,a
1269  011d 9f            	ld	a,xl
1270  011e a401          	and	a,#1
1271  0120 97            	ld	xl,a
1272  0121 4f            	clr	a
1273  0122 02            	rlwa	x,a
1274  0123 5d            	tnzw	x
1275  0124 2707          	jreq	L575
1276                     ; 602     DMA_Channelx = DMA1_Channel0;
1278  0126 ae5075        	ldw	x,#20597
1279  0129 1f01          	ldw	(OFST-1,sp),x
1281  012b 201f          	jra	L775
1282  012d               L575:
1283                     ; 606     if (((uint16_t)DMA_FLAG & (uint16_t)0x0200) != (uint16_t)RESET)
1285  012d 7b03          	ld	a,(OFST+1,sp)
1286  012f a502          	bcp	a,#2
1287  0131 2707          	jreq	L106
1288                     ; 608       DMA_Channelx = DMA1_Channel1;
1290  0133 ae507f        	ldw	x,#20607
1291  0136 1f01          	ldw	(OFST-1,sp),x
1293  0138 2012          	jra	L775
1294  013a               L106:
1295                     ; 612       if (((uint16_t)DMA_FLAG & (uint16_t)0x0400) != (uint16_t)RESET)
1297  013a 7b03          	ld	a,(OFST+1,sp)
1298  013c a504          	bcp	a,#4
1299  013e 2707          	jreq	L506
1300                     ; 614         DMA_Channelx = DMA1_Channel2;
1302  0140 ae5089        	ldw	x,#20617
1303  0143 1f01          	ldw	(OFST-1,sp),x
1305  0145 2005          	jra	L775
1306  0147               L506:
1307                     ; 618         DMA_Channelx = DMA1_Channel3;
1309  0147 ae5093        	ldw	x,#20627
1310  014a 1f01          	ldw	(OFST-1,sp),x
1311  014c               L775:
1312                     ; 624   DMA_Channelx->CSPR &= (uint8_t)~(uint8_t)((uint8_t)DMA_FLAG & (uint8_t)0x06);
1314  014c 1e01          	ldw	x,(OFST-1,sp)
1315  014e 7b04          	ld	a,(OFST+2,sp)
1316  0150 a406          	and	a,#6
1317  0152 43            	cpl	a
1318  0153 e401          	and	a,(1,x)
1319  0155 e701          	ld	(1,x),a
1320                     ; 625 }
1323  0157 5b04          	addw	sp,#4
1324  0159 81            	ret
1337                     	xdef	_DMA_ClearFlag
1338                     	xdef	_DMA_GetFlagStatus
1339                     	xdef	_DMA_ITConfig
1340                     	xdef	_DMA_Cmd
1341                     	xdef	_DMA_GlobalCmd
1342                     	xdef	_DMA_Init
1343                     	xdef	_DMA_DeInit
1344                     	xdef	_DMA_GlobalDeInit
1363                     	end
