   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.9.10 - 10 Feb 2011
   3                     ; Generator (Limited) V4.3.6 - 15 Feb 2011
  43                     ; 117 void EXTI_DeInit(void)
  43                     ; 118 {
  45                     	switch	.text
  46  0000               _EXTI_DeInit:
  50                     ; 119   EXTI->CR1 = EXTI_CR1_RESET_VALUE;
  52  0000 725f50a0      	clr	20640
  53                     ; 120   EXTI->CR2 = EXTI_CR2_RESET_VALUE;
  55  0004 725f50a1      	clr	20641
  56                     ; 121   EXTI->CR3 = EXTI_CR3_RESET_VALUE;
  58  0008 725f50a2      	clr	20642
  59                     ; 122   EXTI->CR4 = EXTI_CR4_RESET_VALUE;
  61  000c 725f50aa      	clr	20650
  62                     ; 123   EXTI->SR1 = 0xFF; /* Setting SR1 bits in order to clear flags */
  64  0010 35ff50a3      	mov	20643,#255
  65                     ; 124   EXTI->SR2 = 0xFF; /* Setting SR2 bits in order to clear flags */
  67  0014 35ff50a4      	mov	20644,#255
  68                     ; 125   EXTI->CONF1 = EXTI_CONF1_RESET_VALUE;
  70  0018 725f50a5      	clr	20645
  71                     ; 126   EXTI->CONF2 = EXTI_CONF2_RESET_VALUE;
  73  001c 725f50ab      	clr	20651
  74                     ; 127 }
  77  0020 81            	ret
 223                     ; 154 void EXTI_SetPinSensitivity(EXTI_Pin_TypeDef EXTI_Pin, EXTI_Trigger_TypeDef EXTI_Trigger)
 223                     ; 155 {
 224                     	switch	.text
 225  0021               _EXTI_SetPinSensitivity:
 227  0021 89            	pushw	x
 228       00000000      OFST:	set	0
 231                     ; 158   assert_param(IS_EXTI_PINNUM(EXTI_Pin));
 233                     ; 159   assert_param(IS_EXTI_TRIGGER(EXTI_Trigger));
 235                     ; 162   switch (EXTI_Pin)
 237  0022 9e            	ld	a,xh
 239                     ; 196     default:
 239                     ; 197       break;
 240  0023 4d            	tnz	a
 241  0024 272f          	jreq	L12
 242  0026 a002          	sub	a,#2
 243  0028 274a          	jreq	L32
 244  002a a002          	sub	a,#2
 245  002c 2765          	jreq	L52
 246  002e a002          	sub	a,#2
 247  0030 2603cc00b2    	jreq	L72
 248  0035 a00a          	sub	a,#10
 249  0037 2603          	jrne	L05
 250  0039 cc00cf        	jp	L13
 251  003c               L05:
 252  003c a002          	sub	a,#2
 253  003e 2603          	jrne	L25
 254  0040 cc00ee        	jp	L33
 255  0043               L25:
 256  0043 a002          	sub	a,#2
 257  0045 2603          	jrne	L45
 258  0047 cc010d        	jp	L53
 259  004a               L45:
 260  004a a002          	sub	a,#2
 261  004c 2603          	jrne	L65
 262  004e cc012c        	jp	L73
 263  0051               L65:
 264  0051 ac490149      	jpf	L721
 265  0055               L12:
 266                     ; 164     case EXTI_Pin_0:
 266                     ; 165       EXTI->CR1 &=  (uint8_t)(~EXTI_CR1_P0IS);
 268  0055 c650a0        	ld	a,20640
 269  0058 a4fc          	and	a,#252
 270  005a c750a0        	ld	20640,a
 271                     ; 166       EXTI->CR1 |= (uint8_t)((uint8_t)(EXTI_Trigger) << EXTI_Pin);
 273  005d 7b01          	ld	a,(OFST+1,sp)
 274  005f 5f            	clrw	x
 275  0060 97            	ld	xl,a
 276  0061 7b02          	ld	a,(OFST+2,sp)
 277  0063 5d            	tnzw	x
 278  0064 2704          	jreq	L01
 279  0066               L21:
 280  0066 48            	sll	a
 281  0067 5a            	decw	x
 282  0068 26fc          	jrne	L21
 283  006a               L01:
 284  006a ca50a0        	or	a,20640
 285  006d c750a0        	ld	20640,a
 286                     ; 167       break;
 288  0070 ac490149      	jpf	L721
 289  0074               L32:
 290                     ; 168     case EXTI_Pin_1:
 290                     ; 169       EXTI->CR1 &=  (uint8_t)(~EXTI_CR1_P1IS);
 292  0074 c650a0        	ld	a,20640
 293  0077 a4f3          	and	a,#243
 294  0079 c750a0        	ld	20640,a
 295                     ; 170       EXTI->CR1 |= (uint8_t)((uint8_t)(EXTI_Trigger) << EXTI_Pin);
 297  007c 7b01          	ld	a,(OFST+1,sp)
 298  007e 5f            	clrw	x
 299  007f 97            	ld	xl,a
 300  0080 7b02          	ld	a,(OFST+2,sp)
 301  0082 5d            	tnzw	x
 302  0083 2704          	jreq	L41
 303  0085               L61:
 304  0085 48            	sll	a
 305  0086 5a            	decw	x
 306  0087 26fc          	jrne	L61
 307  0089               L41:
 308  0089 ca50a0        	or	a,20640
 309  008c c750a0        	ld	20640,a
 310                     ; 171       break;
 312  008f ac490149      	jpf	L721
 313  0093               L52:
 314                     ; 172     case EXTI_Pin_2:
 314                     ; 173       EXTI->CR1 &=  (uint8_t)(~EXTI_CR1_P2IS);
 316  0093 c650a0        	ld	a,20640
 317  0096 a4cf          	and	a,#207
 318  0098 c750a0        	ld	20640,a
 319                     ; 174       EXTI->CR1 |= (uint8_t)((uint8_t)(EXTI_Trigger) << EXTI_Pin);
 321  009b 7b01          	ld	a,(OFST+1,sp)
 322  009d 5f            	clrw	x
 323  009e 97            	ld	xl,a
 324  009f 7b02          	ld	a,(OFST+2,sp)
 325  00a1 5d            	tnzw	x
 326  00a2 2704          	jreq	L02
 327  00a4               L22:
 328  00a4 48            	sll	a
 329  00a5 5a            	decw	x
 330  00a6 26fc          	jrne	L22
 331  00a8               L02:
 332  00a8 ca50a0        	or	a,20640
 333  00ab c750a0        	ld	20640,a
 334                     ; 175       break;
 336  00ae ac490149      	jpf	L721
 337  00b2               L72:
 338                     ; 176     case EXTI_Pin_3:
 338                     ; 177       EXTI->CR1 &=  (uint8_t)(~EXTI_CR1_P3IS);
 340  00b2 c650a0        	ld	a,20640
 341  00b5 a43f          	and	a,#63
 342  00b7 c750a0        	ld	20640,a
 343                     ; 178       EXTI->CR1 |= (uint8_t)((uint8_t)(EXTI_Trigger) << EXTI_Pin);
 345  00ba 7b01          	ld	a,(OFST+1,sp)
 346  00bc 5f            	clrw	x
 347  00bd 97            	ld	xl,a
 348  00be 7b02          	ld	a,(OFST+2,sp)
 349  00c0 5d            	tnzw	x
 350  00c1 2704          	jreq	L42
 351  00c3               L62:
 352  00c3 48            	sll	a
 353  00c4 5a            	decw	x
 354  00c5 26fc          	jrne	L62
 355  00c7               L42:
 356  00c7 ca50a0        	or	a,20640
 357  00ca c750a0        	ld	20640,a
 358                     ; 179       break;
 360  00cd 207a          	jra	L721
 361  00cf               L13:
 362                     ; 180     case EXTI_Pin_4:
 362                     ; 181       EXTI->CR2 &=  (uint8_t)(~EXTI_CR2_P4IS);
 364  00cf c650a1        	ld	a,20641
 365  00d2 a4fc          	and	a,#252
 366  00d4 c750a1        	ld	20641,a
 367                     ; 182       EXTI->CR2 |= (uint8_t)((uint8_t)(EXTI_Trigger) << ((uint8_t)EXTI_Pin & (uint8_t)0xEF));
 369  00d7 7b01          	ld	a,(OFST+1,sp)
 370  00d9 a4ef          	and	a,#239
 371  00db 5f            	clrw	x
 372  00dc 97            	ld	xl,a
 373  00dd 7b02          	ld	a,(OFST+2,sp)
 374  00df 5d            	tnzw	x
 375  00e0 2704          	jreq	L03
 376  00e2               L23:
 377  00e2 48            	sll	a
 378  00e3 5a            	decw	x
 379  00e4 26fc          	jrne	L23
 380  00e6               L03:
 381  00e6 ca50a1        	or	a,20641
 382  00e9 c750a1        	ld	20641,a
 383                     ; 183       break;
 385  00ec 205b          	jra	L721
 386  00ee               L33:
 387                     ; 184     case EXTI_Pin_5:
 387                     ; 185       EXTI->CR2 &=  (uint8_t)(~EXTI_CR2_P5IS);
 389  00ee c650a1        	ld	a,20641
 390  00f1 a4f3          	and	a,#243
 391  00f3 c750a1        	ld	20641,a
 392                     ; 186       EXTI->CR2 |= (uint8_t)((uint8_t)(EXTI_Trigger) << ((uint8_t)EXTI_Pin & (uint8_t)0xEF));
 394  00f6 7b01          	ld	a,(OFST+1,sp)
 395  00f8 a4ef          	and	a,#239
 396  00fa 5f            	clrw	x
 397  00fb 97            	ld	xl,a
 398  00fc 7b02          	ld	a,(OFST+2,sp)
 399  00fe 5d            	tnzw	x
 400  00ff 2704          	jreq	L43
 401  0101               L63:
 402  0101 48            	sll	a
 403  0102 5a            	decw	x
 404  0103 26fc          	jrne	L63
 405  0105               L43:
 406  0105 ca50a1        	or	a,20641
 407  0108 c750a1        	ld	20641,a
 408                     ; 187       break;
 410  010b 203c          	jra	L721
 411  010d               L53:
 412                     ; 188     case EXTI_Pin_6:
 412                     ; 189       EXTI->CR2 &=  (uint8_t)(~EXTI_CR2_P6IS);
 414  010d c650a1        	ld	a,20641
 415  0110 a4cf          	and	a,#207
 416  0112 c750a1        	ld	20641,a
 417                     ; 190       EXTI->CR2 |= (uint8_t)((uint8_t)(EXTI_Trigger) << ((uint8_t)EXTI_Pin & (uint8_t)0xEF));
 419  0115 7b01          	ld	a,(OFST+1,sp)
 420  0117 a4ef          	and	a,#239
 421  0119 5f            	clrw	x
 422  011a 97            	ld	xl,a
 423  011b 7b02          	ld	a,(OFST+2,sp)
 424  011d 5d            	tnzw	x
 425  011e 2704          	jreq	L04
 426  0120               L24:
 427  0120 48            	sll	a
 428  0121 5a            	decw	x
 429  0122 26fc          	jrne	L24
 430  0124               L04:
 431  0124 ca50a1        	or	a,20641
 432  0127 c750a1        	ld	20641,a
 433                     ; 191       break;
 435  012a 201d          	jra	L721
 436  012c               L73:
 437                     ; 192     case EXTI_Pin_7:
 437                     ; 193       EXTI->CR2 &=  (uint8_t)(~EXTI_CR2_P7IS);
 439  012c c650a1        	ld	a,20641
 440  012f a43f          	and	a,#63
 441  0131 c750a1        	ld	20641,a
 442                     ; 194       EXTI->CR2 |= (uint8_t)((uint8_t)(EXTI_Trigger) << ((uint8_t)EXTI_Pin & (uint8_t)0xEF));
 444  0134 7b01          	ld	a,(OFST+1,sp)
 445  0136 a4ef          	and	a,#239
 446  0138 5f            	clrw	x
 447  0139 97            	ld	xl,a
 448  013a 7b02          	ld	a,(OFST+2,sp)
 449  013c 5d            	tnzw	x
 450  013d 2704          	jreq	L44
 451  013f               L64:
 452  013f 48            	sll	a
 453  0140 5a            	decw	x
 454  0141 26fc          	jrne	L64
 455  0143               L44:
 456  0143 ca50a1        	or	a,20641
 457  0146 c750a1        	ld	20641,a
 458                     ; 195       break;
 460  0149               L14:
 461                     ; 196     default:
 461                     ; 197       break;
 463  0149               L721:
 464                     ; 199 }
 467  0149 85            	popw	x
 468  014a 81            	ret
 617                     ; 520 void EXTI_ClearITPendingBit(EXTI_IT_TypeDef EXTI_IT)
 617                     ; 521 {
 618                     	switch	.text
 619  014b               _EXTI_ClearITPendingBit:
 621  014b 89            	pushw	x
 622  014c 89            	pushw	x
 623       00000002      OFST:	set	2
 626                     ; 522   uint16_t tempvalue = 0;
 628                     ; 525   assert_param(IS_EXTI_ITPENDINGBIT(EXTI_IT));
 630                     ; 527   tempvalue = ((uint16_t)EXTI_IT & (uint16_t)0xFF00);
 632  014d 01            	rrwa	x,a
 633  014e 9f            	ld	a,xl
 634  014f a4ff          	and	a,#255
 635  0151 97            	ld	xl,a
 636  0152 4f            	clr	a
 637  0153 02            	rlwa	x,a
 638  0154 1f01          	ldw	(OFST-1,sp),x
 639  0156 01            	rrwa	x,a
 640                     ; 529   if ( tempvalue == 0x0100)
 642  0157 1e01          	ldw	x,(OFST-1,sp)
 643  0159 a30100        	cpw	x,#256
 644  015c 2609          	jrne	L312
 645                     ; 531     EXTI->SR2 = (uint8_t)((uint16_t)EXTI_IT & (uint16_t)0x00FF);
 647  015e 7b04          	ld	a,(OFST+2,sp)
 648  0160 a4ff          	and	a,#255
 649  0162 c750a4        	ld	20644,a
 651  0165 2005          	jra	L512
 652  0167               L312:
 653                     ; 535     EXTI->SR1 = (uint8_t) (EXTI_IT);
 655  0167 7b04          	ld	a,(OFST+2,sp)
 656  0169 c750a3        	ld	20643,a
 657  016c               L512:
 658                     ; 537 }
 661  016c 5b04          	addw	sp,#4
 662  016e 81            	ret
 675                     	xdef	_EXTI_ClearITPendingBit
 676                     	xdef	_EXTI_SetPinSensitivity
 677                     	xdef	_EXTI_DeInit
 696                     	end
