   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.9.10 - 10 Feb 2011
   3                     ; Generator (Limited) V4.3.6 - 15 Feb 2011
  43                     ; 254 void FLASH_DeInit(void)
  43                     ; 255 {
  45                     	switch	.text
  46  0000               _FLASH_DeInit:
  50                     ; 256   FLASH->CR1 = FLASH_CR1_RESET_VALUE;
  52  0000 725f5050      	clr	20560
  53                     ; 257   FLASH->CR2 = FLASH_CR2_RESET_VALUE;
  55  0004 725f5051      	clr	20561
  56                     ; 258   FLASH->IAPSR = FLASH_IAPSR_RESET_VALUE;
  58  0008 35405054      	mov	20564,#64
  59                     ; 259   (void) FLASH->IAPSR; /* Reading of this register causes the clearing of status flags */
  61  000c c65054        	ld	a,20564
  62                     ; 260 }
  65  000f 81            	ret
 121                     ; 270 void FLASH_Unlock(FLASH_MemType_TypeDef FLASH_MemType)
 121                     ; 271 {
 122                     	switch	.text
 123  0010               _FLASH_Unlock:
 125  0010 88            	push	a
 126       00000000      OFST:	set	0
 129                     ; 273   assert_param(IS_FLASH_MEMORY_TYPE(FLASH_MemType));
 131                     ; 276   if (FLASH_MemType == FLASH_MemType_Program)
 133  0011 a1fd          	cp	a,#253
 134  0013 2608          	jrne	L74
 135                     ; 278     FLASH->PUKR = FLASH_RASS_KEY1;
 137  0015 35565052      	mov	20562,#86
 138                     ; 279     FLASH->PUKR = FLASH_RASS_KEY2;
 140  0019 35ae5052      	mov	20562,#174
 141  001d               L74:
 142                     ; 283   if (FLASH_MemType == FLASH_MemType_Data)
 144  001d 7b01          	ld	a,(OFST+1,sp)
 145  001f a1f7          	cp	a,#247
 146  0021 2608          	jrne	L15
 147                     ; 285     FLASH->DUKR = FLASH_RASS_KEY2; /* Warning: keys are reversed on data memory !!! */
 149  0023 35ae5053      	mov	20563,#174
 150                     ; 286     FLASH->DUKR = FLASH_RASS_KEY1;
 152  0027 35565053      	mov	20563,#86
 153  002b               L15:
 154                     ; 288 }
 157  002b 84            	pop	a
 158  002c 81            	ret
 201                     ; 314 void FLASH_ProgramByte(uint32_t Address, uint8_t Data)
 201                     ; 315 {
 202                     	switch	.text
 203  002d               _FLASH_ProgramByte:
 205       00000000      OFST:	set	0
 208                     ; 317   assert_param(IS_FLASH_ADDRESS(Address));
 210                     ; 319   *(PointerAttr uint8_t*) (uint16_t)Address = Data;
 212  002d 7b07          	ld	a,(OFST+7,sp)
 213  002f 1e05          	ldw	x,(OFST+5,sp)
 214  0031 f7            	ld	(x),a
 215                     ; 320 }
 218  0032 81            	ret
 252                     ; 366 uint8_t FLASH_ReadByte(uint32_t Address)
 252                     ; 367 {
 253                     	switch	.text
 254  0033               _FLASH_ReadByte:
 256       00000000      OFST:	set	0
 259                     ; 369   return(*(PointerAttr uint8_t *) (uint16_t)Address);
 261  0033 1e05          	ldw	x,(OFST+5,sp)
 262  0035 f6            	ld	a,(x)
 265  0036 81            	ret
 310                     ; 416 void FLASH_ProgramOptionByte(uint16_t Address, uint8_t Data)
 310                     ; 417 {
 311                     	switch	.text
 312  0037               _FLASH_ProgramOptionByte:
 314  0037 89            	pushw	x
 315       00000000      OFST:	set	0
 318                     ; 419   assert_param(IS_OPTION_BYTE_ADDRESS(Address));
 320                     ; 422   FLASH->CR2 |= FLASH_CR2_OPT;
 322  0038 721e5051      	bset	20561,#7
 323                     ; 425   *((PointerAttr uint8_t*)Address) = Data;
 325  003c 7b05          	ld	a,(OFST+5,sp)
 326  003e 1e01          	ldw	x,(OFST+1,sp)
 327  0040 f7            	ld	(x),a
 328                     ; 427   FLASH_WaitForLastOperation(FLASH_MemType_Program);
 330  0041 a6fd          	ld	a,#253
 331  0043 ad53          	call	_FLASH_WaitForLastOperation
 333                     ; 430   FLASH->CR2 &= (uint8_t)(~FLASH_CR2_OPT);
 335  0045 721f5051      	bres	20561,#7
 336                     ; 431 }
 339  0049 85            	popw	x
 340  004a 81            	ret
 374                     ; 487 uint16_t FLASH_GetBootSize(void)
 374                     ; 488 {
 375                     	switch	.text
 376  004b               _FLASH_GetBootSize:
 378  004b 89            	pushw	x
 379       00000002      OFST:	set	2
 382                     ; 489   uint16_t temp = 0;
 384                     ; 492   temp = (uint16_t)((uint16_t)OPT->UBC * (uint16_t)128);
 386  004c c64802        	ld	a,18434
 387  004f 5f            	clrw	x
 388  0050 97            	ld	xl,a
 389  0051 4f            	clr	a
 390  0052 02            	rlwa	x,a
 391  0053 44            	srl	a
 392  0054 56            	rrcw	x
 393  0055 1f01          	ldw	(OFST-1,sp),x
 394                     ; 495   if (OPT->UBC > 0x7F)
 396  0057 c64802        	ld	a,18434
 397  005a a180          	cp	a,#128
 398  005c 2505          	jrult	L351
 399                     ; 497     temp = 8192;
 401  005e ae2000        	ldw	x,#8192
 402  0061 1f01          	ldw	(OFST-1,sp),x
 403  0063               L351:
 404                     ; 501   return(temp);
 406  0063 1e01          	ldw	x,(OFST-1,sp)
 409  0065 5b02          	addw	sp,#2
 410  0067 81            	ret
 444                     ; 511 uint16_t FLASH_GetCodeSize(void)
 444                     ; 512 {
 445                     	switch	.text
 446  0068               _FLASH_GetCodeSize:
 448  0068 89            	pushw	x
 449       00000002      OFST:	set	2
 452                     ; 513   uint16_t temp = 0;
 454                     ; 516   temp = (uint16_t)((uint16_t)OPT->PCODESIZE * (uint16_t)128);
 456  0069 c64807        	ld	a,18439
 457  006c 5f            	clrw	x
 458  006d 97            	ld	xl,a
 459  006e 4f            	clr	a
 460  006f 02            	rlwa	x,a
 461  0070 44            	srl	a
 462  0071 56            	rrcw	x
 463  0072 1f01          	ldw	(OFST-1,sp),x
 464                     ; 519   if (OPT->PCODESIZE > 0x7F)
 466  0074 c64807        	ld	a,18439
 467  0077 a180          	cp	a,#128
 468  0079 2505          	jrult	L371
 469                     ; 521     temp = 8192;
 471  007b ae2000        	ldw	x,#8192
 472  007e 1f01          	ldw	(OFST-1,sp),x
 473  0080               L371:
 474                     ; 525   return(temp);
 476  0080 1e01          	ldw	x,(OFST-1,sp)
 479  0082 5b02          	addw	sp,#2
 480  0084 81            	ret
 589                     ; 582 FlagStatus FLASH_GetFlagStatus(FLASH_FLAG_TypeDef FLASH_FLAG)
 589                     ; 583 {
 590                     	switch	.text
 591  0085               _FLASH_GetFlagStatus:
 593  0085 88            	push	a
 594       00000001      OFST:	set	1
 597                     ; 584   FlagStatus status = RESET;
 599                     ; 585   assert_param(IS_FLASH_FLAGS(FLASH_FLAG));
 601                     ; 588   if ((FLASH->IAPSR  & (uint8_t)FLASH_FLAG) != (uint8_t)RESET)
 603  0086 c45054        	and	a,20564
 604  0089 2706          	jreq	L542
 605                     ; 590     status = SET; /* Flash_FLAG is set*/
 607  008b a601          	ld	a,#1
 608  008d 6b01          	ld	(OFST+0,sp),a
 610  008f 2002          	jra	L742
 611  0091               L542:
 612                     ; 594     status = RESET; /* Flash_FLAG is reset*/
 614  0091 0f01          	clr	(OFST+0,sp)
 615  0093               L742:
 616                     ; 598   return status;
 618  0093 7b01          	ld	a,(OFST+0,sp)
 621  0095 5b01          	addw	sp,#1
 622  0097 81            	ret
 707                     ; 871 IN_RAM(FLASH_Status_TypeDef FLASH_WaitForLastOperation(FLASH_MemType_TypeDef FLASH_MemType))
 707                     ; 872 {
 708                     	switch	.text
 709  0098               _FLASH_WaitForLastOperation:
 711  0098 5205          	subw	sp,#5
 712       00000005      OFST:	set	5
 715                     ; 873   uint32_t timeout = OPERATION_TIMEOUT;
 717  009a aeffff        	ldw	x,#65535
 718  009d 1f03          	ldw	(OFST-2,sp),x
 719  009f ae0000        	ldw	x,#0
 720  00a2 1f01          	ldw	(OFST-4,sp),x
 721                     ; 874   uint8_t flagstatus = 0x00;
 723  00a4 0f05          	clr	(OFST+0,sp)
 724                     ; 876   if (FLASH_MemType == FLASH_MemType_Program)
 726  00a6 a1fd          	cp	a,#253
 727  00a8 2631          	jrne	L723
 729  00aa 2010          	jra	L513
 730  00ac               L313:
 731                     ; 880       flagstatus = (uint8_t)(FLASH->IAPSR & (uint8_t)(FLASH_IAPSR_EOP |
 731                     ; 881                              FLASH_IAPSR_WR_PG_DIS));
 733  00ac c65054        	ld	a,20564
 734  00af a405          	and	a,#5
 735  00b1 6b05          	ld	(OFST+0,sp),a
 736                     ; 882       timeout--;
 738  00b3 96            	ldw	x,sp
 739  00b4 1c0001        	addw	x,#OFST-4
 740  00b7 a601          	ld	a,#1
 741  00b9 cd0000        	call	c_lgsbc
 743  00bc               L513:
 744                     ; 878   while ((flagstatus == 0x00) && (timeout != 0x00))
 746  00bc 0d05          	tnz	(OFST+0,sp)
 747  00be 2628          	jrne	L323
 749  00c0 96            	ldw	x,sp
 750  00c1 1c0001        	addw	x,#OFST-4
 751  00c4 cd0000        	call	c_lzmp
 753  00c7 26e3          	jrne	L313
 754  00c9 201d          	jra	L323
 755  00cb               L523:
 756                     ; 889       flagstatus = (uint8_t)(FLASH->IAPSR & (uint8_t)(FLASH_IAPSR_HVOFF |
 756                     ; 890                              FLASH_IAPSR_WR_PG_DIS));
 758  00cb c65054        	ld	a,20564
 759  00ce a441          	and	a,#65
 760  00d0 6b05          	ld	(OFST+0,sp),a
 761                     ; 891       timeout--;
 763  00d2 96            	ldw	x,sp
 764  00d3 1c0001        	addw	x,#OFST-4
 765  00d6 a601          	ld	a,#1
 766  00d8 cd0000        	call	c_lgsbc
 768  00db               L723:
 769                     ; 887     while ((flagstatus == 0x00) && (timeout != 0x00))
 771  00db 0d05          	tnz	(OFST+0,sp)
 772  00dd 2609          	jrne	L323
 774  00df 96            	ldw	x,sp
 775  00e0 1c0001        	addw	x,#OFST-4
 776  00e3 cd0000        	call	c_lzmp
 778  00e6 26e3          	jrne	L523
 779  00e8               L323:
 780                     ; 894   if (timeout == 0x00 )
 782  00e8 96            	ldw	x,sp
 783  00e9 1c0001        	addw	x,#OFST-4
 784  00ec cd0000        	call	c_lzmp
 786  00ef 2604          	jrne	L533
 787                     ; 896   flagstatus = FLASH_Status_TimeOut;
 789  00f1 a602          	ld	a,#2
 790  00f3 6b05          	ld	(OFST+0,sp),a
 791  00f5               L533:
 792                     ; 899   return((FLASH_Status_TypeDef)flagstatus);
 794  00f5 7b05          	ld	a,(OFST+0,sp)
 797  00f7 5b05          	addw	sp,#5
 798  00f9 81            	ret
 811                     	xdef	_FLASH_WaitForLastOperation
 812                     	xdef	_FLASH_GetFlagStatus
 813                     	xdef	_FLASH_ProgramOptionByte
 814                     	xdef	_FLASH_GetCodeSize
 815                     	xdef	_FLASH_GetBootSize
 816                     	xdef	_FLASH_ReadByte
 817                     	xdef	_FLASH_ProgramByte
 818                     	xdef	_FLASH_Unlock
 819                     	xdef	_FLASH_DeInit
 838                     	xref	c_lzmp
 839                     	xref	c_lgsbc
 840                     	end
