   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.9.10 - 10 Feb 2011
   3                     ; Generator (Limited) V4.3.6 - 15 Feb 2011
 109                     ; 90 void GPIO_DeInit(GPIO_TypeDef* GPIOx)
 109                     ; 91 {
 111                     	switch	.text
 112  0000               _GPIO_DeInit:
 116                     ; 92   GPIOx->CR2 = GPIO_CR2_RESET_VALUE; /* Reset Control Register 2 */
 118  0000 6f04          	clr	(4,x)
 119                     ; 93   GPIOx->ODR = GPIO_ODR_RESET_VALUE; /* Reset Output Data Register */
 121  0002 7f            	clr	(x)
 122                     ; 94   GPIOx->DDR = GPIO_DDR_RESET_VALUE; /* Reset Data Direction Register */
 124  0003 6f02          	clr	(2,x)
 125                     ; 95   GPIOx->CR1 = GPIO_CR1_RESET_VALUE; /* Reset Control Register 1 */
 127  0005 6f03          	clr	(3,x)
 128                     ; 96 }
 131  0007 81            	ret
 287                     ; 127 void GPIO_Init(GPIO_TypeDef* GPIOx, uint8_t GPIO_Pin, GPIO_Mode_TypeDef GPIO_Mode)
 287                     ; 128 {
 288                     	switch	.text
 289  0008               _GPIO_Init:
 291  0008 89            	pushw	x
 292       00000000      OFST:	set	0
 295                     ; 133   assert_param(IS_GPIO_MODE(GPIO_Mode));
 297                     ; 134   assert_param(IS_GPIO_PIN(GPIO_Pin));
 299                     ; 137   GPIOx->CR2 &= (uint8_t)(~(GPIO_Pin));
 301  0009 7b05          	ld	a,(OFST+5,sp)
 302  000b 43            	cpl	a
 303  000c e404          	and	a,(4,x)
 304  000e e704          	ld	(4,x),a
 305                     ; 143   if ((((uint8_t)(GPIO_Mode)) & (uint8_t)0x80) != (uint8_t)0x00) /* Output mode */
 307  0010 7b06          	ld	a,(OFST+6,sp)
 308  0012 a580          	bcp	a,#128
 309  0014 271d          	jreq	L541
 310                     ; 145     if ((((uint8_t)(GPIO_Mode)) & (uint8_t)0x10) != (uint8_t)0x00) /* High level */
 312  0016 7b06          	ld	a,(OFST+6,sp)
 313  0018 a510          	bcp	a,#16
 314  001a 2706          	jreq	L741
 315                     ; 147       GPIOx->ODR |= GPIO_Pin;
 317  001c f6            	ld	a,(x)
 318  001d 1a05          	or	a,(OFST+5,sp)
 319  001f f7            	ld	(x),a
 321  0020 2007          	jra	L151
 322  0022               L741:
 323                     ; 150       GPIOx->ODR &= (uint8_t)(~(GPIO_Pin));
 325  0022 1e01          	ldw	x,(OFST+1,sp)
 326  0024 7b05          	ld	a,(OFST+5,sp)
 327  0026 43            	cpl	a
 328  0027 f4            	and	a,(x)
 329  0028 f7            	ld	(x),a
 330  0029               L151:
 331                     ; 153     GPIOx->DDR |= GPIO_Pin;
 333  0029 1e01          	ldw	x,(OFST+1,sp)
 334  002b e602          	ld	a,(2,x)
 335  002d 1a05          	or	a,(OFST+5,sp)
 336  002f e702          	ld	(2,x),a
 338  0031 2009          	jra	L351
 339  0033               L541:
 340                     ; 157     GPIOx->DDR &= (uint8_t)(~(GPIO_Pin));
 342  0033 1e01          	ldw	x,(OFST+1,sp)
 343  0035 7b05          	ld	a,(OFST+5,sp)
 344  0037 43            	cpl	a
 345  0038 e402          	and	a,(2,x)
 346  003a e702          	ld	(2,x),a
 347  003c               L351:
 348                     ; 164   if ((((uint8_t)(GPIO_Mode)) & (uint8_t)0x40) != (uint8_t)0x00) /* Pull-Up or Push-Pull */
 350  003c 7b06          	ld	a,(OFST+6,sp)
 351  003e a540          	bcp	a,#64
 352  0040 270a          	jreq	L551
 353                     ; 166     GPIOx->CR1 |= GPIO_Pin;
 355  0042 1e01          	ldw	x,(OFST+1,sp)
 356  0044 e603          	ld	a,(3,x)
 357  0046 1a05          	or	a,(OFST+5,sp)
 358  0048 e703          	ld	(3,x),a
 360  004a 2009          	jra	L751
 361  004c               L551:
 362                     ; 169     GPIOx->CR1 &= (uint8_t)(~(GPIO_Pin));
 364  004c 1e01          	ldw	x,(OFST+1,sp)
 365  004e 7b05          	ld	a,(OFST+5,sp)
 366  0050 43            	cpl	a
 367  0051 e403          	and	a,(3,x)
 368  0053 e703          	ld	(3,x),a
 369  0055               L751:
 370                     ; 176   if ((((uint8_t)(GPIO_Mode)) & (uint8_t)0x20) != (uint8_t)0x00) /* Interrupt or Slow slope */
 372  0055 7b06          	ld	a,(OFST+6,sp)
 373  0057 a520          	bcp	a,#32
 374  0059 270a          	jreq	L161
 375                     ; 178     GPIOx->CR2 |= GPIO_Pin;
 377  005b 1e01          	ldw	x,(OFST+1,sp)
 378  005d e604          	ld	a,(4,x)
 379  005f 1a05          	or	a,(OFST+5,sp)
 380  0061 e704          	ld	(4,x),a
 382  0063 2009          	jra	L361
 383  0065               L161:
 384                     ; 181     GPIOx->CR2 &= (uint8_t)(~(GPIO_Pin));
 386  0065 1e01          	ldw	x,(OFST+1,sp)
 387  0067 7b05          	ld	a,(OFST+5,sp)
 388  0069 43            	cpl	a
 389  006a e404          	and	a,(4,x)
 390  006c e704          	ld	(4,x),a
 391  006e               L361:
 392                     ; 184 }
 395  006e 85            	popw	x
 396  006f 81            	ret
 442                     ; 300 void GPIO_SetBits(GPIO_TypeDef* GPIOx, uint8_t GPIO_Pin)
 442                     ; 301 {
 443                     	switch	.text
 444  0070               _GPIO_SetBits:
 446  0070 89            	pushw	x
 447       00000000      OFST:	set	0
 450                     ; 302   GPIOx->ODR |= GPIO_Pin;
 452  0071 f6            	ld	a,(x)
 453  0072 1a05          	or	a,(OFST+5,sp)
 454  0074 f7            	ld	(x),a
 455                     ; 303 }
 458  0075 85            	popw	x
 459  0076 81            	ret
 505                     ; 321 void GPIO_ResetBits(GPIO_TypeDef* GPIOx, uint8_t GPIO_Pin)
 505                     ; 322 {
 506                     	switch	.text
 507  0077               _GPIO_ResetBits:
 509  0077 89            	pushw	x
 510       00000000      OFST:	set	0
 513                     ; 323   GPIOx->ODR &= (uint8_t)(~GPIO_Pin);
 515  0078 7b05          	ld	a,(OFST+5,sp)
 516  007a 43            	cpl	a
 517  007b f4            	and	a,(x)
 518  007c f7            	ld	(x),a
 519                     ; 324 }
 522  007d 85            	popw	x
 523  007e 81            	ret
 560                     ; 346 uint8_t GPIO_ReadInputData(GPIO_TypeDef* GPIOx)
 560                     ; 347 {
 561                     	switch	.text
 562  007f               _GPIO_ReadInputData:
 566                     ; 348   return ((uint8_t)GPIOx->IDR);
 568  007f e601          	ld	a,(1,x)
 571  0081 81            	ret
 723                     ; 379 BitStatus GPIO_ReadInputDataBit(GPIO_TypeDef* GPIOx, GPIO_Pin_TypeDef GPIO_Pin)
 723                     ; 380 {
 724                     	switch	.text
 725  0082               _GPIO_ReadInputDataBit:
 727  0082 89            	pushw	x
 728       00000000      OFST:	set	0
 731                     ; 381   return ((BitStatus)(GPIOx->IDR & (uint8_t)GPIO_Pin));
 733  0083 e601          	ld	a,(1,x)
 734  0085 1405          	and	a,(OFST+5,sp)
 737  0087 85            	popw	x
 738  0088 81            	ret
 751                     	xdef	_GPIO_ReadInputDataBit
 752                     	xdef	_GPIO_ReadInputData
 753                     	xdef	_GPIO_ResetBits
 754                     	xdef	_GPIO_SetBits
 755                     	xdef	_GPIO_Init
 756                     	xdef	_GPIO_DeInit
 775                     	end
