   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.9.10 - 10 Feb 2011
   3                     ; Generator (Limited) V4.3.6 - 15 Feb 2011
 199                     ; 135 void I2C_DeInit(I2C_TypeDef* I2Cx)
 199                     ; 136 {
 201                     	switch	.text
 202  0000               _I2C_DeInit:
 206                     ; 137   I2Cx->CR1 = I2C_CR1_RESET_VALUE;
 208  0000 7f            	clr	(x)
 209                     ; 138   I2Cx->CR2 = I2C_CR2_RESET_VALUE;
 211  0001 6f01          	clr	(1,x)
 212                     ; 139   I2Cx->FREQR = I2C_FREQR_RESET_VALUE;
 214  0003 6f02          	clr	(2,x)
 215                     ; 140   I2Cx->OARL = I2C_OARL_RESET_VALUE;
 217  0005 6f03          	clr	(3,x)
 218                     ; 141   I2Cx->OARH = I2C_OARH_RESET_VALUE;
 220  0007 6f04          	clr	(4,x)
 221                     ; 142   I2Cx->OAR2 = I2C_OAR2_RESET_VALUE;
 223  0009 6f05          	clr	(5,x)
 224                     ; 143   I2Cx->ITR = I2C_ITR_RESET_VALUE;
 226  000b 6f0a          	clr	(10,x)
 227                     ; 144   I2Cx->CCRL = I2C_CCRL_RESET_VALUE;
 229  000d 6f0b          	clr	(11,x)
 230                     ; 145   I2Cx->CCRH = I2C_CCRH_RESET_VALUE;
 232  000f 6f0c          	clr	(12,x)
 233                     ; 146   I2Cx->TRISER = I2C_TRISER_RESET_VALUE;
 235  0011 a602          	ld	a,#2
 236  0013 e70d          	ld	(13,x),a
 237                     ; 147 }
 240  0015 81            	ret
 464                     .const:	section	.text
 465  0000               L01:
 466  0000 000f4240      	dc.l	1000000
 467  0004               L21:
 468  0004 000186a1      	dc.l	100001
 469  0008               L41:
 470  0008 00000004      	dc.l	4
 471                     ; 178 void I2C_Init(I2C_TypeDef* I2Cx, uint32_t OutputClockFrequency, uint16_t OwnAddress,
 471                     ; 179               I2C_Mode_TypeDef I2C_Mode, I2C_DutyCycle_TypeDef I2C_DutyCycle,
 471                     ; 180               I2C_Ack_TypeDef I2C_Ack, I2C_AcknowledgedAddress_TypeDef I2C_AcknowledgedAddress)
 471                     ; 181 {
 472                     	switch	.text
 473  0016               _I2C_Init:
 475  0016 89            	pushw	x
 476  0017 520c          	subw	sp,#12
 477       0000000c      OFST:	set	12
 480                     ; 182   uint32_t result = 0x0004;
 482                     ; 183   uint16_t tmpval = 0;
 484                     ; 184   uint8_t tmpccrh = 0;
 486  0019 0f07          	clr	(OFST-5,sp)
 487                     ; 185   uint8_t input_clock = 0;
 489                     ; 188   assert_param(IS_I2C_MODE(I2C_Mode));
 491                     ; 189   assert_param(IS_I2C_ACK_STATE(I2C_Ack));
 493                     ; 190   assert_param(IS_I2C_ACKNOWLEDGE_ADDRESS(I2C_AcknowledgedAddress));
 495                     ; 191   assert_param(IS_I2C_DUTY_CYCLE(I2C_DutyCycle));
 497                     ; 192   assert_param(IS_I2C_OWN_ADDRESS(OwnAddress));
 499                     ; 193   assert_param(IS_I2C_OUTPUT_CLOCK_FREQ(OutputClockFrequency));
 501                     ; 197   input_clock = (uint8_t) (CLK_GetClockFreq() / 1000000);
 503  001b cd0000        	call	_CLK_GetClockFreq
 505  001e ae0000        	ldw	x,#L01
 506  0021 cd0000        	call	c_ludv
 508  0024 b603          	ld	a,c_lreg+3
 509  0026 6b08          	ld	(OFST-4,sp),a
 510                     ; 201   I2Cx->FREQR &= (uint8_t)(~I2C_FREQR_FREQ);
 512  0028 1e0d          	ldw	x,(OFST+1,sp)
 513  002a e602          	ld	a,(2,x)
 514  002c a4c0          	and	a,#192
 515  002e e702          	ld	(2,x),a
 516                     ; 203   I2Cx->FREQR |= input_clock;
 518  0030 1e0d          	ldw	x,(OFST+1,sp)
 519  0032 e602          	ld	a,(2,x)
 520  0034 1a08          	or	a,(OFST-4,sp)
 521  0036 e702          	ld	(2,x),a
 522                     ; 207   I2Cx->CR1 &= (uint8_t)(~I2C_CR1_PE);
 524  0038 1e0d          	ldw	x,(OFST+1,sp)
 525  003a f6            	ld	a,(x)
 526  003b a4fe          	and	a,#254
 527  003d f7            	ld	(x),a
 528                     ; 210   I2Cx->CCRH &= (uint8_t)(~(I2C_CCRH_FS | I2C_CCRH_DUTY | I2C_CCRH_CCR));
 530  003e 1e0d          	ldw	x,(OFST+1,sp)
 531  0040 e60c          	ld	a,(12,x)
 532  0042 a430          	and	a,#48
 533  0044 e70c          	ld	(12,x),a
 534                     ; 211   I2Cx->CCRL &= (uint8_t)(~I2C_CCRL_CCR);
 536  0046 1e0d          	ldw	x,(OFST+1,sp)
 537  0048 6f0b          	clr	(11,x)
 538                     ; 214   if (OutputClockFrequency > I2C_MAX_STANDARD_FREQ) /* FAST MODE */
 540  004a 96            	ldw	x,sp
 541  004b 1c0011        	addw	x,#OFST+5
 542  004e cd0000        	call	c_ltor
 544  0051 ae0004        	ldw	x,#L21
 545  0054 cd0000        	call	c_lcmp
 547  0057 2403          	jruge	L61
 548  0059 cc00f7        	jp	L362
 549  005c               L61:
 550                     ; 217     tmpccrh = I2C_CCRH_FS;
 552  005c a680          	ld	a,#128
 553  005e 6b07          	ld	(OFST-5,sp),a
 554                     ; 219     if (I2C_DutyCycle == I2C_DutyCycle_2)
 556  0060 0d18          	tnz	(OFST+12,sp)
 557  0062 2633          	jrne	L562
 558                     ; 222       result = (uint32_t) ((input_clock * 1000000) / (OutputClockFrequency * 3));
 560  0064 96            	ldw	x,sp
 561  0065 1c0011        	addw	x,#OFST+5
 562  0068 cd0000        	call	c_ltor
 564  006b a603          	ld	a,#3
 565  006d cd0000        	call	c_smul
 567  0070 96            	ldw	x,sp
 568  0071 1c0001        	addw	x,#OFST-11
 569  0074 cd0000        	call	c_rtol
 571  0077 7b08          	ld	a,(OFST-4,sp)
 572  0079 b703          	ld	c_lreg+3,a
 573  007b 3f02          	clr	c_lreg+2
 574  007d 3f01          	clr	c_lreg+1
 575  007f 3f00          	clr	c_lreg
 576  0081 ae0000        	ldw	x,#L01
 577  0084 cd0000        	call	c_lmul
 579  0087 96            	ldw	x,sp
 580  0088 1c0001        	addw	x,#OFST-11
 581  008b cd0000        	call	c_ludv
 583  008e 96            	ldw	x,sp
 584  008f 1c0009        	addw	x,#OFST-3
 585  0092 cd0000        	call	c_rtol
 588  0095 2037          	jra	L762
 589  0097               L562:
 590                     ; 227       result = (uint32_t) ((input_clock * 1000000) / (OutputClockFrequency * 25));
 592  0097 96            	ldw	x,sp
 593  0098 1c0011        	addw	x,#OFST+5
 594  009b cd0000        	call	c_ltor
 596  009e a619          	ld	a,#25
 597  00a0 cd0000        	call	c_smul
 599  00a3 96            	ldw	x,sp
 600  00a4 1c0001        	addw	x,#OFST-11
 601  00a7 cd0000        	call	c_rtol
 603  00aa 7b08          	ld	a,(OFST-4,sp)
 604  00ac b703          	ld	c_lreg+3,a
 605  00ae 3f02          	clr	c_lreg+2
 606  00b0 3f01          	clr	c_lreg+1
 607  00b2 3f00          	clr	c_lreg
 608  00b4 ae0000        	ldw	x,#L01
 609  00b7 cd0000        	call	c_lmul
 611  00ba 96            	ldw	x,sp
 612  00bb 1c0001        	addw	x,#OFST-11
 613  00be cd0000        	call	c_ludv
 615  00c1 96            	ldw	x,sp
 616  00c2 1c0009        	addw	x,#OFST-3
 617  00c5 cd0000        	call	c_rtol
 619                     ; 229       tmpccrh |= I2C_CCRH_DUTY;
 621  00c8 7b07          	ld	a,(OFST-5,sp)
 622  00ca aa40          	or	a,#64
 623  00cc 6b07          	ld	(OFST-5,sp),a
 624  00ce               L762:
 625                     ; 233     if (result < (uint16_t)0x01)
 627  00ce 96            	ldw	x,sp
 628  00cf 1c0009        	addw	x,#OFST-3
 629  00d2 cd0000        	call	c_lzmp
 631  00d5 260a          	jrne	L172
 632                     ; 236       result = (uint16_t)0x0001;
 634  00d7 ae0001        	ldw	x,#1
 635  00da 1f0b          	ldw	(OFST-1,sp),x
 636  00dc ae0000        	ldw	x,#0
 637  00df 1f09          	ldw	(OFST-3,sp),x
 638  00e1               L172:
 639                     ; 242     tmpval = ((input_clock * 3) / 10) + 1;
 641  00e1 7b08          	ld	a,(OFST-4,sp)
 642  00e3 97            	ld	xl,a
 643  00e4 a603          	ld	a,#3
 644  00e6 42            	mul	x,a
 645  00e7 a60a          	ld	a,#10
 646  00e9 cd0000        	call	c_sdivx
 648  00ec 5c            	incw	x
 649  00ed 1f05          	ldw	(OFST-7,sp),x
 650                     ; 243     I2Cx->TRISER = (uint8_t)tmpval;
 652  00ef 7b06          	ld	a,(OFST-6,sp)
 653  00f1 1e0d          	ldw	x,(OFST+1,sp)
 654  00f3 e70d          	ld	(13,x),a
 656  00f5 205c          	jra	L372
 657  00f7               L362:
 658                     ; 250     result = (uint16_t)((input_clock * 1000000) / (OutputClockFrequency << (uint8_t)1));
 660  00f7 96            	ldw	x,sp
 661  00f8 1c0011        	addw	x,#OFST+5
 662  00fb cd0000        	call	c_ltor
 664  00fe 3803          	sll	c_lreg+3
 665  0100 3902          	rlc	c_lreg+2
 666  0102 3901          	rlc	c_lreg+1
 667  0104 3900          	rlc	c_lreg
 668  0106 96            	ldw	x,sp
 669  0107 1c0001        	addw	x,#OFST-11
 670  010a cd0000        	call	c_rtol
 672  010d 7b08          	ld	a,(OFST-4,sp)
 673  010f b703          	ld	c_lreg+3,a
 674  0111 3f02          	clr	c_lreg+2
 675  0113 3f01          	clr	c_lreg+1
 676  0115 3f00          	clr	c_lreg
 677  0117 ae0000        	ldw	x,#L01
 678  011a cd0000        	call	c_lmul
 680  011d 96            	ldw	x,sp
 681  011e 1c0001        	addw	x,#OFST-11
 682  0121 cd0000        	call	c_ludv
 684  0124 b602          	ld	a,c_lreg+2
 685  0126 97            	ld	xl,a
 686  0127 b603          	ld	a,c_lreg+3
 687  0129 cd0000        	call	c_uitol
 689  012c 96            	ldw	x,sp
 690  012d 1c0009        	addw	x,#OFST-3
 691  0130 cd0000        	call	c_rtol
 693                     ; 253     if (result < (uint16_t)0x0004)
 695  0133 96            	ldw	x,sp
 696  0134 1c0009        	addw	x,#OFST-3
 697  0137 cd0000        	call	c_ltor
 699  013a ae0008        	ldw	x,#L41
 700  013d cd0000        	call	c_lcmp
 702  0140 240a          	jruge	L572
 703                     ; 256       result = (uint16_t)0x0004;
 705  0142 ae0004        	ldw	x,#4
 706  0145 1f0b          	ldw	(OFST-1,sp),x
 707  0147 ae0000        	ldw	x,#0
 708  014a 1f09          	ldw	(OFST-3,sp),x
 709  014c               L572:
 710                     ; 262     I2Cx->TRISER = (uint8_t)((uint8_t)input_clock + (uint8_t)1);
 712  014c 7b08          	ld	a,(OFST-4,sp)
 713  014e 4c            	inc	a
 714  014f 1e0d          	ldw	x,(OFST+1,sp)
 715  0151 e70d          	ld	(13,x),a
 716  0153               L372:
 717                     ; 267   I2Cx->CCRL = (uint8_t)result;
 719  0153 7b0c          	ld	a,(OFST+0,sp)
 720  0155 1e0d          	ldw	x,(OFST+1,sp)
 721  0157 e70b          	ld	(11,x),a
 722                     ; 268   I2Cx->CCRH = (uint8_t)((uint8_t)((uint8_t)((uint8_t)result >> 8) & I2C_CCRH_CCR) | tmpccrh);
 724  0159 7b07          	ld	a,(OFST-5,sp)
 725  015b 1e0d          	ldw	x,(OFST+1,sp)
 726  015d e70c          	ld	(12,x),a
 727                     ; 271   I2Cx->CR1 |= (uint8_t)(I2C_CR1_PE | I2C_Mode);
 729  015f 1e0d          	ldw	x,(OFST+1,sp)
 730  0161 7b17          	ld	a,(OFST+11,sp)
 731  0163 aa01          	or	a,#1
 732  0165 fa            	or	a,(x)
 733  0166 f7            	ld	(x),a
 734                     ; 274   I2Cx->CR2 |= (uint8_t)I2C_Ack;
 736  0167 1e0d          	ldw	x,(OFST+1,sp)
 737  0169 e601          	ld	a,(1,x)
 738  016b 1a19          	or	a,(OFST+13,sp)
 739  016d e701          	ld	(1,x),a
 740                     ; 277   I2Cx->OARL = (uint8_t)(OwnAddress);
 742  016f 7b16          	ld	a,(OFST+10,sp)
 743  0171 1e0d          	ldw	x,(OFST+1,sp)
 744  0173 e703          	ld	(3,x),a
 745                     ; 278   I2Cx->OARH = (uint8_t)((uint8_t)(I2C_AcknowledgedAddress | I2C_OARH_ADDCONF ) | \
 745                     ; 279                          (uint8_t)((uint16_t)( (uint16_t)OwnAddress &  (uint16_t)0x0300) >> 7));
 747  0175 7b15          	ld	a,(OFST+9,sp)
 748  0177 97            	ld	xl,a
 749  0178 7b16          	ld	a,(OFST+10,sp)
 750  017a 9f            	ld	a,xl
 751  017b a403          	and	a,#3
 752  017d 97            	ld	xl,a
 753  017e 4f            	clr	a
 754  017f 02            	rlwa	x,a
 755  0180 4f            	clr	a
 756  0181 01            	rrwa	x,a
 757  0182 48            	sll	a
 758  0183 59            	rlcw	x
 759  0184 9f            	ld	a,xl
 760  0185 6b04          	ld	(OFST-8,sp),a
 761  0187 7b1a          	ld	a,(OFST+14,sp)
 762  0189 aa40          	or	a,#64
 763  018b 1a04          	or	a,(OFST-8,sp)
 764  018d 1e0d          	ldw	x,(OFST+1,sp)
 765  018f e704          	ld	(4,x),a
 766                     ; 280 }
 769  0191 5b0e          	addw	sp,#14
 770  0193 81            	ret
 837                     ; 289 void I2C_Cmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
 837                     ; 290 {
 838                     	switch	.text
 839  0194               _I2C_Cmd:
 841  0194 89            	pushw	x
 842       00000000      OFST:	set	0
 845                     ; 293   assert_param(IS_FUNCTIONAL_STATE(NewState));
 847                     ; 295   if (NewState != DISABLE)
 849  0195 0d05          	tnz	(OFST+5,sp)
 850  0197 2706          	jreq	L333
 851                     ; 298     I2Cx->CR1 |= I2C_CR1_PE;
 853  0199 f6            	ld	a,(x)
 854  019a aa01          	or	a,#1
 855  019c f7            	ld	(x),a
 857  019d 2006          	jra	L533
 858  019f               L333:
 859                     ; 303     I2Cx->CR1 &= (uint8_t)(~I2C_CR1_PE);
 861  019f 1e01          	ldw	x,(OFST+1,sp)
 862  01a1 f6            	ld	a,(x)
 863  01a2 a4fe          	and	a,#254
 864  01a4 f7            	ld	(x),a
 865  01a5               L533:
 866                     ; 305 }
 869  01a5 85            	popw	x
 870  01a6 81            	ret
 917                     ; 343 void I2C_GenerateSTART(I2C_TypeDef* I2Cx, FunctionalState NewState)
 917                     ; 344 {
 918                     	switch	.text
 919  01a7               _I2C_GenerateSTART:
 921  01a7 89            	pushw	x
 922       00000000      OFST:	set	0
 925                     ; 347   assert_param(IS_FUNCTIONAL_STATE(NewState));
 927                     ; 349   if (NewState != DISABLE)
 929  01a8 0d05          	tnz	(OFST+5,sp)
 930  01aa 2708          	jreq	L363
 931                     ; 352     I2Cx->CR2 |= I2C_CR2_START;
 933  01ac e601          	ld	a,(1,x)
 934  01ae aa01          	or	a,#1
 935  01b0 e701          	ld	(1,x),a
 937  01b2 2008          	jra	L563
 938  01b4               L363:
 939                     ; 357     I2Cx->CR2 &= (uint8_t)(~I2C_CR2_START);
 941  01b4 1e01          	ldw	x,(OFST+1,sp)
 942  01b6 e601          	ld	a,(1,x)
 943  01b8 a4fe          	and	a,#254
 944  01ba e701          	ld	(1,x),a
 945  01bc               L563:
 946                     ; 359 }
 949  01bc 85            	popw	x
 950  01bd 81            	ret
 997                     ; 368 void I2C_GenerateSTOP(I2C_TypeDef* I2Cx, FunctionalState NewState)
 997                     ; 369 {
 998                     	switch	.text
 999  01be               _I2C_GenerateSTOP:
1001  01be 89            	pushw	x
1002       00000000      OFST:	set	0
1005                     ; 372   assert_param(IS_FUNCTIONAL_STATE(NewState));
1007                     ; 374   if (NewState != DISABLE)
1009  01bf 0d05          	tnz	(OFST+5,sp)
1010  01c1 2708          	jreq	L314
1011                     ; 377     I2Cx->CR2 |= I2C_CR2_STOP;
1013  01c3 e601          	ld	a,(1,x)
1014  01c5 aa02          	or	a,#2
1015  01c7 e701          	ld	(1,x),a
1017  01c9 2008          	jra	L514
1018  01cb               L314:
1019                     ; 382     I2Cx->CR2 &= (uint8_t)(~I2C_CR2_STOP);
1021  01cb 1e01          	ldw	x,(OFST+1,sp)
1022  01cd e601          	ld	a,(1,x)
1023  01cf a4fd          	and	a,#253
1024  01d1 e701          	ld	(1,x),a
1025  01d3               L514:
1026                     ; 384 }
1029  01d3 85            	popw	x
1030  01d4 81            	ret
1078                     ; 471 void I2C_AcknowledgeConfig(I2C_TypeDef* I2Cx, FunctionalState NewState)
1078                     ; 472 {
1079                     	switch	.text
1080  01d5               _I2C_AcknowledgeConfig:
1082  01d5 89            	pushw	x
1083       00000000      OFST:	set	0
1086                     ; 474   assert_param(IS_FUNCTIONAL_STATE(NewState));
1088                     ; 476   if (NewState != DISABLE)
1090  01d6 0d05          	tnz	(OFST+5,sp)
1091  01d8 2708          	jreq	L344
1092                     ; 479     I2Cx->CR2 |= I2C_CR2_ACK;
1094  01da e601          	ld	a,(1,x)
1095  01dc aa04          	or	a,#4
1096  01de e701          	ld	(1,x),a
1098  01e0 2008          	jra	L544
1099  01e2               L344:
1100                     ; 484     I2Cx->CR2 &= (uint8_t)(~I2C_CR2_ACK);
1102  01e2 1e01          	ldw	x,(OFST+1,sp)
1103  01e4 e601          	ld	a,(1,x)
1104  01e6 a4fb          	and	a,#251
1105  01e8 e701          	ld	(1,x),a
1106  01ea               L544:
1107                     ; 486 }
1110  01ea 85            	popw	x
1111  01eb 81            	ret
1190                     ; 624 void I2C_Send7bitAddress(I2C_TypeDef* I2Cx, uint8_t Address, I2C_Direction_TypeDef I2C_Direction)
1190                     ; 625 {
1191                     	switch	.text
1192  01ec               _I2C_Send7bitAddress:
1194  01ec 89            	pushw	x
1195       00000000      OFST:	set	0
1198                     ; 627   assert_param(IS_I2C_ADDRESS(Address));
1200                     ; 628   assert_param(IS_I2C_DIRECTION(I2C_Direction));
1202                     ; 631   if (I2C_Direction != I2C_Direction_Transmitter)
1204  01ed 0d06          	tnz	(OFST+6,sp)
1205  01ef 2708          	jreq	L705
1206                     ; 634     Address |= OAR1_ADD0_Set;
1208  01f1 7b05          	ld	a,(OFST+5,sp)
1209  01f3 aa01          	or	a,#1
1210  01f5 6b05          	ld	(OFST+5,sp),a
1212  01f7 2006          	jra	L115
1213  01f9               L705:
1214                     ; 639     Address &= OAR1_ADD0_Reset;
1216  01f9 7b05          	ld	a,(OFST+5,sp)
1217  01fb a4fe          	and	a,#254
1218  01fd 6b05          	ld	(OFST+5,sp),a
1219  01ff               L115:
1220                     ; 642   I2Cx->DR = Address;
1222  01ff 7b05          	ld	a,(OFST+5,sp)
1223  0201 1e01          	ldw	x,(OFST+1,sp)
1224  0203 e706          	ld	(6,x),a
1225                     ; 643 }
1228  0205 85            	popw	x
1229  0206 81            	ret
1275                     ; 667 void I2C_SendData(I2C_TypeDef* I2Cx, uint8_t Data)
1275                     ; 668 {
1276                     	switch	.text
1277  0207               _I2C_SendData:
1279  0207 89            	pushw	x
1280       00000000      OFST:	set	0
1283                     ; 670   I2Cx->DR = Data;
1285  0208 7b05          	ld	a,(OFST+5,sp)
1286  020a 1e01          	ldw	x,(OFST+1,sp)
1287  020c e706          	ld	(6,x),a
1288                     ; 671 }
1291  020e 85            	popw	x
1292  020f 81            	ret
1329                     ; 679 uint8_t I2C_ReceiveData(I2C_TypeDef* I2Cx)
1329                     ; 680 {
1330                     	switch	.text
1331  0210               _I2C_ReceiveData:
1335                     ; 682   return ((uint8_t)I2Cx->DR);
1337  0210 e606          	ld	a,(6,x)
1340  0212 81            	ret
1387                     ; 807 void I2C_DMACmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
1387                     ; 808 {
1388                     	switch	.text
1389  0213               _I2C_DMACmd:
1391  0213 89            	pushw	x
1392       00000000      OFST:	set	0
1395                     ; 810   assert_param(IS_FUNCTIONAL_STATE(NewState));
1397                     ; 812   if (NewState != DISABLE)
1399  0214 0d05          	tnz	(OFST+5,sp)
1400  0216 2708          	jreq	L306
1401                     ; 815     I2Cx->ITR |= I2C_ITR_DMAEN;
1403  0218 e60a          	ld	a,(10,x)
1404  021a aa08          	or	a,#8
1405  021c e70a          	ld	(10,x),a
1407  021e 2008          	jra	L506
1408  0220               L306:
1409                     ; 820     I2Cx->ITR &= (uint8_t)(~I2C_ITR_DMAEN);
1411  0220 1e01          	ldw	x,(OFST+1,sp)
1412  0222 e60a          	ld	a,(10,x)
1413  0224 a4f7          	and	a,#247
1414  0226 e70a          	ld	(10,x),a
1415  0228               L506:
1416                     ; 822 }
1419  0228 85            	popw	x
1420  0229 81            	ret
1468                     ; 831 void I2C_DMALastTransferCmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
1468                     ; 832 {
1469                     	switch	.text
1470  022a               _I2C_DMALastTransferCmd:
1472  022a 89            	pushw	x
1473       00000000      OFST:	set	0
1476                     ; 834   assert_param(IS_FUNCTIONAL_STATE(NewState));
1478                     ; 836   if (NewState != DISABLE)
1480  022b 0d05          	tnz	(OFST+5,sp)
1481  022d 2708          	jreq	L336
1482                     ; 839     I2Cx->ITR |= I2C_ITR_LAST;
1484  022f e60a          	ld	a,(10,x)
1485  0231 aa10          	or	a,#16
1486  0233 e70a          	ld	(10,x),a
1488  0235 2008          	jra	L536
1489  0237               L336:
1490                     ; 844     I2Cx->ITR &= (uint8_t)(~I2C_ITR_LAST);
1492  0237 1e01          	ldw	x,(OFST+1,sp)
1493  0239 e60a          	ld	a,(10,x)
1494  023b a4ef          	and	a,#239
1495  023d e70a          	ld	(10,x),a
1496  023f               L536:
1497                     ; 846 }
1500  023f 85            	popw	x
1501  0240 81            	ret
1662                     ; 999 uint8_t I2C_ReadRegister(I2C_TypeDef* I2Cx, I2C_Register_TypeDef I2C_Register)
1662                     ; 1000 {
1663                     	switch	.text
1664  0241               _I2C_ReadRegister:
1666  0241 89            	pushw	x
1667  0242 5204          	subw	sp,#4
1668       00000004      OFST:	set	4
1671                     ; 1001   __IO uint16_t tmp = 0;
1673  0244 5f            	clrw	x
1674  0245 1f03          	ldw	(OFST-1,sp),x
1675                     ; 1003   assert_param(IS_I2C_REGISTER(I2C_Register));
1677                     ; 1005   tmp = (uint16_t) I2Cx;
1679  0247 1e05          	ldw	x,(OFST+1,sp)
1680  0249 1f03          	ldw	(OFST-1,sp),x
1681                     ; 1006   tmp += I2C_Register;
1683  024b 7b09          	ld	a,(OFST+5,sp)
1684  024d 5f            	clrw	x
1685  024e 97            	ld	xl,a
1686  024f 1f01          	ldw	(OFST-3,sp),x
1687  0251 1e03          	ldw	x,(OFST-1,sp)
1688  0253 72fb01        	addw	x,(OFST-3,sp)
1689  0256 1f03          	ldw	(OFST-1,sp),x
1690                     ; 1009   return (*(__IO uint8_t *) tmp);
1692  0258 1e03          	ldw	x,(OFST-1,sp)
1693  025a f6            	ld	a,(x)
1696  025b 5b06          	addw	sp,#6
1697  025d 81            	ret
1951                     ; 1049 ErrorStatus I2C_CheckEvent(I2C_TypeDef* I2Cx, I2C_Event_TypeDef I2C_Event)
1951                     ; 1050 {
1952                     	switch	.text
1953  025e               _I2C_CheckEvent:
1955  025e 89            	pushw	x
1956  025f 5206          	subw	sp,#6
1957       00000006      OFST:	set	6
1960                     ; 1051   __IO uint16_t lastevent = 0x00;
1962  0261 5f            	clrw	x
1963  0262 1f04          	ldw	(OFST-2,sp),x
1964                     ; 1052   uint8_t flag1 = 0x00 ;
1966                     ; 1053   uint8_t flag2 = 0x00;
1968                     ; 1054   ErrorStatus status = ERROR;
1970                     ; 1057   assert_param(IS_I2C_EVENT(I2C_Event));
1972                     ; 1059   if (I2C_Event == I2C_EVENT_SLAVE_ACK_FAILURE)
1974  0264 1e0b          	ldw	x,(OFST+5,sp)
1975  0266 a30004        	cpw	x,#4
1976  0269 260c          	jrne	L1501
1977                     ; 1061     lastevent = I2Cx->SR2 & I2C_SR2_AF;
1979  026b 1e07          	ldw	x,(OFST+1,sp)
1980  026d e608          	ld	a,(8,x)
1981  026f a404          	and	a,#4
1982  0271 5f            	clrw	x
1983  0272 97            	ld	xl,a
1984  0273 1f04          	ldw	(OFST-2,sp),x
1986  0275 2021          	jra	L3501
1987  0277               L1501:
1988                     ; 1065     flag1 = I2Cx->SR1;
1990  0277 1e07          	ldw	x,(OFST+1,sp)
1991  0279 e607          	ld	a,(7,x)
1992  027b 6b03          	ld	(OFST-3,sp),a
1993                     ; 1066     flag2 = I2Cx->SR3;
1995  027d 1e07          	ldw	x,(OFST+1,sp)
1996  027f e609          	ld	a,(9,x)
1997  0281 6b06          	ld	(OFST+0,sp),a
1998                     ; 1067     lastevent = ((uint16_t)((uint16_t)flag2 << (uint16_t)8) | (uint16_t)flag1);
2000  0283 7b03          	ld	a,(OFST-3,sp)
2001  0285 5f            	clrw	x
2002  0286 97            	ld	xl,a
2003  0287 1f01          	ldw	(OFST-5,sp),x
2004  0289 7b06          	ld	a,(OFST+0,sp)
2005  028b 5f            	clrw	x
2006  028c 97            	ld	xl,a
2007  028d 4f            	clr	a
2008  028e 02            	rlwa	x,a
2009  028f 01            	rrwa	x,a
2010  0290 1a02          	or	a,(OFST-4,sp)
2011  0292 01            	rrwa	x,a
2012  0293 1a01          	or	a,(OFST-5,sp)
2013  0295 01            	rrwa	x,a
2014  0296 1f04          	ldw	(OFST-2,sp),x
2015  0298               L3501:
2016                     ; 1070   if (((uint16_t)lastevent & (uint16_t)I2C_Event) == (uint16_t)I2C_Event)
2018  0298 1e04          	ldw	x,(OFST-2,sp)
2019  029a 01            	rrwa	x,a
2020  029b 140c          	and	a,(OFST+6,sp)
2021  029d 01            	rrwa	x,a
2022  029e 140b          	and	a,(OFST+5,sp)
2023  02a0 01            	rrwa	x,a
2024  02a1 130b          	cpw	x,(OFST+5,sp)
2025  02a3 2606          	jrne	L5501
2026                     ; 1073     status = SUCCESS;
2028  02a5 a601          	ld	a,#1
2029  02a7 6b06          	ld	(OFST+0,sp),a
2031  02a9 2002          	jra	L7501
2032  02ab               L5501:
2033                     ; 1078     status = ERROR;
2035  02ab 0f06          	clr	(OFST+0,sp)
2036  02ad               L7501:
2037                     ; 1082   return status;
2039  02ad 7b06          	ld	a,(OFST+0,sp)
2042  02af 5b08          	addw	sp,#8
2043  02b1 81            	ret
2300                     ; 1159 FlagStatus I2C_GetFlagStatus(I2C_TypeDef* I2Cx, I2C_FLAG_TypeDef I2C_FLAG)
2300                     ; 1160 {
2301                     	switch	.text
2302  02b2               _I2C_GetFlagStatus:
2304  02b2 89            	pushw	x
2305  02b3 89            	pushw	x
2306       00000002      OFST:	set	2
2309                     ; 1161   uint8_t tempreg = 0;
2311  02b4 0f02          	clr	(OFST+0,sp)
2312                     ; 1162   uint8_t regindex = 0;
2314                     ; 1163   FlagStatus bitstatus = RESET;
2316                     ; 1166   assert_param(IS_I2C_GET_FLAG(I2C_FLAG));
2318                     ; 1169   regindex = (uint8_t)((uint16_t)I2C_FLAG >> 8);
2320  02b6 7b07          	ld	a,(OFST+5,sp)
2321  02b8 6b01          	ld	(OFST-1,sp),a
2322                     ; 1171   switch (regindex)
2324  02ba 7b01          	ld	a,(OFST-1,sp)
2326                     ; 1188     default:
2326                     ; 1189       break;
2327  02bc 4a            	dec	a
2328  02bd 2708          	jreq	L1601
2329  02bf 4a            	dec	a
2330  02c0 270d          	jreq	L3601
2331  02c2 4a            	dec	a
2332  02c3 2712          	jreq	L5601
2333  02c5 2016          	jra	L3221
2334  02c7               L1601:
2335                     ; 1174     case 0x01:
2335                     ; 1175       tempreg = (uint8_t)I2Cx->SR1;
2337  02c7 1e03          	ldw	x,(OFST+1,sp)
2338  02c9 e607          	ld	a,(7,x)
2339  02cb 6b02          	ld	(OFST+0,sp),a
2340                     ; 1176       break;
2342  02cd 200e          	jra	L3221
2343  02cf               L3601:
2344                     ; 1179     case 0x02:
2344                     ; 1180       tempreg = (uint8_t)I2Cx->SR2;
2346  02cf 1e03          	ldw	x,(OFST+1,sp)
2347  02d1 e608          	ld	a,(8,x)
2348  02d3 6b02          	ld	(OFST+0,sp),a
2349                     ; 1181       break;
2351  02d5 2006          	jra	L3221
2352  02d7               L5601:
2353                     ; 1184     case 0x03:
2353                     ; 1185       tempreg = (uint8_t)I2Cx->SR3;
2355  02d7 1e03          	ldw	x,(OFST+1,sp)
2356  02d9 e609          	ld	a,(9,x)
2357  02db 6b02          	ld	(OFST+0,sp),a
2358                     ; 1186       break;
2360  02dd               L7601:
2361                     ; 1188     default:
2361                     ; 1189       break;
2363  02dd               L3221:
2364                     ; 1193   if ((tempreg & (uint8_t)I2C_FLAG ) != 0)
2366  02dd 7b08          	ld	a,(OFST+6,sp)
2367  02df 1502          	bcp	a,(OFST+0,sp)
2368  02e1 2706          	jreq	L5221
2369                     ; 1196     bitstatus = SET;
2371  02e3 a601          	ld	a,#1
2372  02e5 6b02          	ld	(OFST+0,sp),a
2374  02e7 2002          	jra	L7221
2375  02e9               L5221:
2376                     ; 1201     bitstatus = RESET;
2378  02e9 0f02          	clr	(OFST+0,sp)
2379  02eb               L7221:
2380                     ; 1204   return bitstatus;
2382  02eb 7b02          	ld	a,(OFST+0,sp)
2385  02ed 5b04          	addw	sp,#4
2386  02ef 81            	ret
2442                     ; 1236 void I2C_ClearFlag(I2C_TypeDef* I2Cx, I2C_FLAG_TypeDef I2C_FLAG)
2442                     ; 1237 {
2443                     	switch	.text
2444  02f0               _I2C_ClearFlag:
2446  02f0 89            	pushw	x
2447  02f1 89            	pushw	x
2448       00000002      OFST:	set	2
2451                     ; 1238   uint16_t flagpos = 0;
2453                     ; 1240   assert_param(IS_I2C_CLEAR_FLAG(I2C_FLAG));
2455                     ; 1243   flagpos = (uint16_t)I2C_FLAG & FLAG_Mask;
2457  02f2 7b07          	ld	a,(OFST+5,sp)
2458  02f4 97            	ld	xl,a
2459  02f5 7b08          	ld	a,(OFST+6,sp)
2460  02f7 a4ff          	and	a,#255
2461  02f9 5f            	clrw	x
2462  02fa 02            	rlwa	x,a
2463  02fb 1f01          	ldw	(OFST-1,sp),x
2464  02fd 01            	rrwa	x,a
2465                     ; 1245   I2Cx->SR2 = (uint8_t)((uint16_t)(~flagpos));
2467  02fe 7b02          	ld	a,(OFST+0,sp)
2468  0300 43            	cpl	a
2469  0301 1e03          	ldw	x,(OFST+1,sp)
2470  0303 e708          	ld	(8,x),a
2471                     ; 1246 }
2474  0305 5b04          	addw	sp,#4
2475  0307 81            	ret
2488                     	xdef	_I2C_ClearFlag
2489                     	xdef	_I2C_GetFlagStatus
2490                     	xdef	_I2C_CheckEvent
2491                     	xdef	_I2C_ReadRegister
2492                     	xdef	_I2C_DMALastTransferCmd
2493                     	xdef	_I2C_DMACmd
2494                     	xdef	_I2C_ReceiveData
2495                     	xdef	_I2C_SendData
2496                     	xdef	_I2C_Send7bitAddress
2497                     	xdef	_I2C_AcknowledgeConfig
2498                     	xdef	_I2C_GenerateSTOP
2499                     	xdef	_I2C_GenerateSTART
2500                     	xdef	_I2C_Cmd
2501                     	xdef	_I2C_Init
2502                     	xdef	_I2C_DeInit
2503                     	xref	_CLK_GetClockFreq
2504                     	xref.b	c_lreg
2505                     	xref.b	c_x
2524                     	xref	c_uitol
2525                     	xref	c_sdivx
2526                     	xref	c_lzmp
2527                     	xref	c_rtol
2528                     	xref	c_smul
2529                     	xref	c_lmul
2530                     	xref	c_lcmp
2531                     	xref	c_ltor
2532                     	xref	c_ludv
2533                     	end
